SystemOrganization addCategory: #'SMark-Benchmarks-Classic'!
SystemOrganization addCategory: #'SMark-Benchmarks-DeltaBlue'!
SystemOrganization addCategory: #'SMark-Benchmarks-Richards'!
SystemOrganization addCategory: #'SMark-Benchmarks-SOM'!
SystemOrganization addCategory: #'SMark-Benchmarks-GraphSearch'!
SystemOrganization addCategory: #'SMark-Benchmarks-Json'!
SystemOrganization addCategory: #'SMark-Benchmarks-RSqueak'!
SystemOrganization addCategory: #'SMark-Benchmarks-SqueakJS'!
SystemOrganization addCategory: #'SMark-Benchmarks-NBody'!
SystemOrganization addCategory: #'SMark-Benchmarks-Micro'!
SystemOrganization addCategory: #'SMark-Benchmarks-CPB'!
SystemOrganization addCategory: #'SMark-Benchmarks-Shootout'!

Object subclass: #SMarkAStar
	instanceVariableNames: 'openList closedList graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
closedList
	"Answer the value of closedList"

	^ closedList! !

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
closedList: anObject
	"Set the value of closedList"

	closedList := anObject! !

!SMarkAStar methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 14:50'!
draw
	| form node |
	form := Form extent: self graph nodes last x @ self graph nodes last y.
	form floodFill: Color black at: 1@1.
	node := self graph target.
	[ node ] whileNotNil: [
		form colorAt: (node x @ node) y put: Color white.
		node := node predecessor.
	].
	^form.! !

!SMarkAStar methodsFor: 'as yet unclassified' stamp: 'MP 2/7/2014 11:59'!
expandNode: node
	(node neighbours) do: [:neighbour|
		(self closedList includes: neighbour)
			ifFalse: [
				| costs |
				costs := (node costsFromStart) + (node costsToNode: neighbour) .
				((self openList includes: neighbour) and: (costs >= neighbour costsFromStart))
					ifFalse: [
						neighbour predecessor: node .
						neighbour costsFromStart: costs.
						(self openList includes: neighbour) ifFalse: [
							self openList add: neighbour.]]]].! !

!SMarkAStar methodsFor: 'as yet unclassified' stamp: 'MP 2/7/2014 11:35'!
findPath
	| foundPath break |
	foundPath := nil .
	break := false .
	self openList add: graph start .

	[(break == false) and: ((self openList isEmpty) not)]
		whileTrue: [
			| currentNode |
			currentNode := self nearestNode .
			self openList remove: currentNode .
			(currentNode == self graph target)
				ifTrue: [
					break:=true.
					foundPath:=currentNode.]
				ifFalse: [
					self closedList add: currentNode .
					self expandNode: currentNode .
				].		
		] .
	
	^ foundPath.! !

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
graph
	"Answer the value of graph"

	^ graph! !

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SMarkAStar methodsFor: 'initialize-release' stamp: 'MP 2/7/2014 11:30'!
initialize
	openList := OrderedCollection new .
	closedList := Set new .
	graph := nil .! !

!SMarkAStar methodsFor: 'as yet unclassified' stamp: 'MP 2/7/2014 11:20'!
nearestNode
	"gets the node with the minimal costs to the target"
	| min |
	min := self openList first.
	self openList
		do: [:node | (node estimatedCostsToTarget: self graph target)
					< (min estimatedCostsToTarget: self graph target)
				ifTrue: [min := node]].
	^ min! !

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
openList
	"Answer the value of openList"

	^ openList! !

!SMarkAStar methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:24'!
openList: anObject
	"Set the value of openList"

	openList := anObject! !

!SMarkAStar methodsFor: 'initialize-release' stamp: 'MP 2/7/2014 15:05'!
reset
	self openList removeAll .
	self closedList removeAll .! !

Object subclass: #SMarkAStarGraph
	instanceVariableNames: 'nodes start target width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkAStarGraph class methodsFor: 'instance creation' stamp: 'tfel 6/2/2015 10:32'!
fromString: aString
	| tokens maze |
	tokens := (aString findTokens: Character cr) collect: [:line| (line findTokens: ',') collect: [:t| t asInteger]].
	
	maze := self new.
	maze width: tokens first size.
	
	tokens withIndexDo: [:line :y| line withIndexDo: [:token :x| | node |
			node := (SMarkAStarNode x: x y: y).
			maze nodes add: node.
			token == 1 ifTrue:[
				((y > 1) and: [((tokens at: y-1) at: x) == 1]) ifTrue: [|other|
					other := maze nodeAt: (x @ (y-1)).
					other neighbours add: node.
					node neighbours add: other.
				].
				((x > 1) and: [((tokens at: y) at: x-1) == 1]) ifTrue: [|other|
					other := maze nodeAt: ((x-1) @ y).
					other neighbours add: node.
					node neighbours add: other.
				].
			]
		]
	].
	
	^maze.
	! !

!SMarkAStarGraph class methodsFor: 'instance creation' stamp: 'BS 2/7/2014 14:31'!
testGraph
	| maze |
	maze := self fromString:
'1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,1,1,1,2,
1,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,2,1,2,
1,1,2,1,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,1,1,1,2,
1,1,1,1,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,1,2,1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,2,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,1,2,2,
2,1,1,1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,1,1,1,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,1,2,2,
2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,2,2,2,2,1,2,2,
2,1,1,1,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,1,1,1,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,2,2,1,2,1,1,1,2,2,2,2,2,2,1,1,1,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,2,1,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,1,1,1,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,1,2,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,1,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,2,2,2,2,1,1,1,2,2,1,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,1,
2,2,1,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,1,1,1,1,2,1,
2,2,1,2,2,2,1,1,1,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,1,1,1,
2,2,1,2,2,2,1,2,1,2,2,2,1,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,1,1,2,2,2,2,2,1,1,1,2,2,1,1,1,2,2,1,2,
2,2,1,2,2,2,1,1,1,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,2,1,2,2,1,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,1,1,1,2,2,1,1,1,2,2,1,2,
2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,2,1,2,
2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,1,2,1,1,1,2,
2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,2,2,2,
2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,
2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,'.

	maze start: maze nodes first.
	maze target: maze nodes last.
	
	^maze.! !

!SMarkAStarGraph class methodsFor: 'instance creation' stamp: 'BS 2/7/2014 14:32'!
testGraph2
	| maze |
	maze := self fromString:
'1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,2,1,1,1,1,2,1,1,1,1,1,2,1,1,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,2,2,1,2,1,2,1,2,2,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,1,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,2,1,1,1,2,1,1,1,2,2,1,1,1,2,2,1,1,1,2,2,2,1,1,1,2,2,2,1,1,1,1,2,2,1,1,1,1,1,2,1,1,1,2,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,1,2,2,1,1,1,2,1,1,1,1,2,2,1,1,1,1,2,2,2,1,1,1,2,2,2,1,1,1,2,2,2,2,1,1,2,2,1,1,2,2,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,1,2,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,1,1,1,1,1,2,1,1,1,1,2,2,1,1,2,1,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,2,1,2,2,2,1,2,1,2,1,2,2,2,1,2,1,1,2,1,1,2,1,2,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,1,2,1,1,1,2,2,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,2,2,2,1,1,1,2,2,2,1,1,1,2,2,1,1,2,1,1,1,2,
2,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,2,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,2,2,1,2,2,1,1,1,2,2,1,1,1,2,2,1,1,1,1,2,2,2,1,1,1,1,2,2,2,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,2,1,2,1,1,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,1,2,1,1,1,1,2,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,2,2,1,1,1,1,2,2,2,1,1,2,1,2,2,1,1,2,
2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,1,2,2,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,2,2,1,1,1,1,2,2,1,1,1,2,2,1,1,1,1,1,2,1,1,2,1,1,2,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,2,1,1,1,2,1,1,1,2,2,1,1,1,1,1,2,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,2,1,1,1,1,2,2,1,2,1,1,1,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,2,2,1,1,1,2,2,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,2,1,1,1,1,2,1,2,1,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,1,2,2,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,2,1,1,1,2,1,2,1,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,1,2,2,1,1,1,1,1,2,2,2,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,2,1,1,2,1,2,1,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,2,1,2,2,1,1,1,2,2,1,1,1,1,1,1,2,2,1,1,1,2,2,2,1,1,1,2,2,1,1,1,1,2,2,2,1,1,2,1,1,2,1,2,2,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,2,2,1,1,1,2,2,2,1,1,1,1,1,2,2,1,1,1,1,2,1,1,1,1,2,2,1,1,1,1,1,2,1,1,2,1,1,2,1,1,2,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,2,2,2,1,1,1,2,1,1,1,1,1,2,1,1,2,1,1,2,1,1,2,1,1,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,1,1,1,1,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,1,2,2,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,2,1,1,1,1,2,1,1,2,1,1,2,1,1,2,2,1,2,1,2,
2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,1,1,1,2,1,2,1,2,1,2,1,2,1,2,2,2,1,1,2,2,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,2,1,1,1,2,1,1,2,1,1,2,1,1,1,2,1,1,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,2,1,1,2,2,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,1,1,1,2,1,1,2,1,1,2,1,1,1,2,2,1,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,2,2,1,1,2,2,1,1,1,1,2,2,2,1,1,1,1,2,2,1,1,1,1,2,2,1,2,2,1,1,2,2,1,2,2,1,2,1,1,1,1,2,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,1,2,2,1,1,2,2,1,1,2,2,1,1,1,1,1,2,2,2,1,1,1,2,2,1,1,1,1,2,1,1,2,1,1,1,2,1,1,2,1,2,2,2,2,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,2,2,1,1,2,2,1,1,1,1,1,1,2,2,1,1,1,2,2,1,1,1,2,2,1,2,2,1,1,2,1,1,2,1,1,1,1,1,1,1,2,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,2,2,1,1,2,2,1,1,2,2,1,1,2,2,1,1,1,1,1,1,2,2,1,1,1,2,2,1,1,1,2,1,1,2,1,1,2,1,1,2,1,1,1,1,1,1,2,2,1,2,
2,1,1,1,1,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,1,1,2,2,1,1,2,2,1,1,2,2,1,1,2,2,2,1,1,1,1,1,2,2,1,1,1,2,1,1,1,2,1,1,2,1,1,2,2,1,2,2,2,2,2,2,2,2,1,1,2,
2,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,2,1,1,2,2,1,1,2,2,1,1,2,2,1,1,1,2,2,1,1,1,1,2,2,1,1,1,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,
2,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,1,2,1,2,1,2,1,2,1,2,2,2,1,1,2,2,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,2,2,1,1,2,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,2,1,2,1,2,1,2,1,2,1,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,1,2,2,2,1,1,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,1,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,1,1,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,2,2,2,2,1,1,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,2,2,2,2,2,1,2,2,2,2,2,1,1,1,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,1,2,2,2,2,2,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,2,2,1,1,1,1,2,2,2,2,2,1,1,1,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,1,2,2,2,2,1,2,2,2,1,1,2,2,1,2,2,2,2,2,2,2,1,1,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,1,2,2,1,1,2,2,2,1,2,2,2,2,2,2,2,2,1,1,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,1,2,2,2,1,2,2,1,2,2,2,2,1,1,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,1,1,2,2,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,1,1,1,1,1,1,1,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,2,2,2,2,1,2,2,1,1,1,1,1,1,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,1,2,2,1,1,1,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,1,1,1,2,2,2,2,1,2,2,2,1,1,1,2,2,2,2,1,1,2,2,2,1,2,2,2,2,2,2,1,1,1,2,2,2,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,1,2,2,
2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,1,1,2,2,1,1,2,2,2,2,1,1,1,2,2,1,1,2,2,2,2,1,2,2,2,2,2,1,1,2,1,1,2,2,2,1,2,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,1,2,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,1,1,2,1,1,1,1,2,2,2,1,1,1,1,1,2,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,1,1,2,
2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,1,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,1,2,
2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,1,2,
2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,'.

	maze start: maze nodes first.
	maze target: maze nodes last.
	
	^maze.! !

!SMarkAStarGraph methodsFor: 'initialize-release' stamp: 'BS 2/7/2014 13:29'!
initialize
	nodes := OrderedCollection new.
	width := 0.
	start := nil .
	target := nil .! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'BS 2/7/2014 14:03'!
nodeAt: aPoint
	| index |
	index := (aPoint y - 1) * width + aPoint x.
	^self nodes at: index. ! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
nodes
	"Answer the value of nodes"

	^ nodes! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
nodes: anObject
	"Set the value of nodes"

	nodes := anObject! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
start
	"Answer the value of start"

	^ start! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
start: anObject
	"Set the value of start"

	start := anObject! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
target
	"Answer the value of target"

	^ target! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:36'!
target: anObject
	"Set the value of target"

	target := anObject! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'BS 2/7/2014 13:30'!
width
	"Answer the value of width"

	^ width! !

!SMarkAStarGraph methodsFor: 'accessing' stamp: 'BS 2/7/2014 13:30'!
width: anObject
	"Set the value of width"

	width := anObject! !

Object subclass: #SMarkAStarNode
	instanceVariableNames: 'neighbours x y costsFromStart predecessor distanceMetric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkAStarNode class methodsFor: 'instance creation' stamp: 'MP 2/7/2014 10:12'!
x: x y: y
	| instance |
	instance := self new .
	instance
		x: x;
		y: y .
	^ instance .! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:19'!
addNeighbour: neighbour
	self neighbours add: neighbour .! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 11:05'!
costsFromStart
	"Answer the value of costsFromStart"

	^ costsFromStart! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 11:05'!
costsFromStart: anObject
	"Set the value of costsFromStart"

	costsFromStart := anObject! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 12:58'!
costsToNode: node
	(self distanceMetric = #euclidian)
		ifTrue: [
			^ self euclideanDistanceTo: node . ]
		ifFalse: [
			(self distanceMetric = #manhattan)
				ifTrue: [
					^ self manhattanDistanceTo: node .]
				ifFalse: [
					^ 1 .
				]
		].! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 12:52'!
distanceMetric
	"Answer the value of distanceMetric"

	^ distanceMetric! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 12:52'!
distanceMetric: anObject
	"Set the value of distanceMetric"

	distanceMetric := anObject! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 11:18'!
estimatedCostsToTarget: target
	^ self costsFromStart + (self costsToNode: target) .! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 12:55'!
euclideanDistanceTo: node
	| dX dY |
	dX := node x - self x .
	dY := node y - self y .
	^ (dX*dX) + (dY*dY) .! !

!SMarkAStarNode methodsFor: 'initialize-release' stamp: 'MP 2/7/2014 12:52'!
initialize
	neighbours := Set new .
	x := 0 .
	y := 0 .
	costsFromStart := 0 .
	predecessor := nil .
	distanceMetric := #manhattan .! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 12:54'!
manhattanDistanceTo: node
	^ ((node x - self x) abs) + ((node y - self y) abs) .! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:05'!
neighbours
	"Answer the value of neighbours"

	^ neighbours! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:05'!
neighbours: anObject
	"Set the value of neighbours"

	neighbours := anObject! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 11:20'!
predecessor
	"Answer the value of predecessor"

	^ predecessor! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 11:20'!
predecessor: anObject
	"Set the value of predecessor"

	predecessor := anObject! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:10'!
x
	"Answer the value of x"

	^ x! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:10'!
x: anObject
	"Set the value of x"

	x := anObject! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:10'!
y
	"Answer the value of y"

	^ y! !

!SMarkAStarNode methodsFor: 'accessing' stamp: 'MP 2/7/2014 10:10'!
y: anObject
	"Set the value of y"

	y := anObject! !

Object subclass: #SMarkAbstractConstraint
	instanceVariableNames: 'strength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkAbstractConstraint commentStamp: '<historical>' prior: 0!
I am an abstract class representing a system-maintainable relationship (or "constraint") between a set of variables. I supply a strength instance variable; concrete subclasses provide a means of storing the constrained variables and other information required to represent a constraint.

Instance variables:
	strength			the strength of this constraint <Strength>!

!SMarkAbstractConstraint methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:08'!
addConstraint
	"Activate this constraint and attempt to satisfy it."

	self addToGraph.
	SMarkPlanner current incrementalAdd: self.! !

!SMarkAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
addToGraph
	"Add myself to the constraint graph."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
chooseMethod: mark
	"Decide if I can be satisfied and record that decision. The output of
	 the choosen method must not have the given mark and must have a
	 walkabout strength less than that of this constraint."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:08'!
destroyConstraint
	"Deactivate this constraint, remove it from the constraint graph,
	 possibly causing other constraints to be satisfied, and destroy it."

	(self isSatisfied) ifTrue: [SMarkPlanner current incrementalRemove: self].
	self removeFromGraph.
	"self release."! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
inputsDo: aBlock
	"Assume that I am satisfied. Evaluate the given block on all my current
	 input variables."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 14:55'!
inputsKnown: mark
	"Assume that I am satisfied. Answer true if all my current inputs are
	 known. A variable is known if either a) it is 'stay' (i.e. it is a
	 constant at plan execution time), b) it has the given mark (indicating
	 that it has been computed by a constraint appearing earlier in the
	 plan), or c) it is not determined by any constraint."

	self inputsDo:
		[ :v |
		 (v mark = mark or: [(v stay) or: [v determinedBy == nil]]) ifFalse:
			[^false]].
	^true! !

!SMarkAbstractConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:53'!
isInput
	"Normal constraints are not input constraints. An input constraint is
	 one that depends on external state, such as the mouse, the keyboard,
	 a clock, or some arbitrary piece of imperative code."

	^false! !

!SMarkAbstractConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:54'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:02'!
longPrintOn: aStream

	aStream nextPut: $(.
	self shortPrintOn: aStream.
	aStream space; nextPutAll: self strength printString.
	(self isSatisfied)
		ifTrue:
			[aStream cr; space; space; space.
			 self inputsDo:
				[ :in | aStream nextPutAll: 'v', in printString, ' '].
			aStream nextPutAll: '-> '.
			aStream nextPutAll: 'v', self output printString]
		ifFalse:
			[aStream space; nextPutAll: 'UNSATISFIED'].
	aStream nextPut: $); cr.! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
output
	"Answer my current output variable. Raise an error if I am not
	 currently satisfied."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 10:57'!
printOn: aStream

	self shortPrintOn: aStream! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:56'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
	 the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
removeFromGraph
	"Remove myself from the constraint graph."

	self subclassResponsibility! !

!SMarkAbstractConstraint methodsFor: 'planning' stamp: 'tfel 3/21/2016 16:59'!
satisfy: mark
	"Attempt to find a way to enforce this (still unsatisfied) constraint.
	 If successful, record the solution, perhaps modifying the current
	 dataflow graph.  Answer the constraint that this constraint overrides,
	 if there is one, or nil, if there isn't."

	| overridden out |
	self chooseMethod: mark.
	(self isSatisfied)
		ifTrue:			"constraint can be satisfied"
			["mark inputs to allow cycle detection in addPropagate"
			 self inputsDo: [ :in | in mark: mark].
			 out := self output.
			 overridden := out determinedBy.
			 (overridden == nil) ifFalse: [overridden markUnsatisfied].
			 out determinedBy: self.
			 (SMarkPlanner current addPropagate: self mark: mark) ifFalse:
				[self notify:
					('Cycle encountered adding:\   ',
					 self printString,
					 '\Constraint removed.') withCRs.
				 ^nil].
			 out mark: mark]
		ifFalse:			"constraint cannot be satisfied"
			[overridden := nil.
			 (strength sameAs: (SMarkStrength required)) ifTrue:
				[self notify: 'Failed to satisfy a required constraint']].
	^ overridden! !

!SMarkAbstractConstraint methodsFor: 'printing' stamp: 'tfel 3/21/2016 16:57'!
shortPrintOn: aStream

	aStream nextPutAll: self class name, '('.
	super printOn: aStream.
	aStream nextPutAll: ')'.! !

!SMarkAbstractConstraint methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:53'!
strength
	^ strength! !

!SMarkAbstractConstraint methodsFor: 'accessing' stamp: 'tfel 3/21/2016 17:00'!
strength: strengthSymbol
	strength := SMarkStrength of: strengthSymbol! !

SMarkAbstractConstraint subclass: #SMarkBinaryConstraint
	instanceVariableNames: 'direction v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkBinaryConstraint commentStamp: '<historical>' prior: 0!
I am an abstract superclass for constraints having two possible output variables.

Instance variables:
	v1, v2		possible output variables <Variable>
	direction		one of:
					#forward (v2 is output)
					#backward (	v1 is output)
					nil (not satisfied)!

!SMarkBinaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:21'!
addToGraph
	"Add myself to the constraint graph."

	v1 addConstraint: self.
	v2 addConstraint: self.
	direction := nil.! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 15:01'!
chooseMethod: mark
	"Decide if I can be satisfied and which way I should flow based on the relative strength of the variables I relate, and record that decision."

	(v1 mark == mark) ifTrue:		"forward or nothing"
		[((v2 mark ~= mark) and: [strength stronger: v2 walkStrength]) 
			ifTrue: [ ^ direction := #forward ]
			ifFalse: [ ^ direction := nil ] ].

	(v2 mark == mark) ifTrue:		"backward or nothing"
		[((v1 mark ~= mark) and: [strength stronger: v1 walkStrength])
			ifTrue: [ ^ direction := #backward ]
			ifFalse: [ ^ direction := nil ] ].

	"if we get here, neither variable is marked, so we have choice"
	(v1 walkStrength weaker: v2 walkStrength)
		ifTrue:
			[(strength stronger: v1 walkStrength)
				ifTrue: [ ^ direction := #backward ]
				ifFalse: [ ^ direction := nil ]]
		ifFalse:
			[(strength stronger: v2 walkStrength)
				ifTrue: [ ^ direction := #forward ]
				ifFalse: [ ^ direction := nil ]]. ! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
inputsDo: aBlock
	"Evaluate the given block on my current input variable."

	direction == #forward
		ifTrue: [ aBlock value: v1 ]
		ifFalse: [ aBlock value: v2 ].! !

!SMarkBinaryConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:21'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	^ direction notNil! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	direction := nil.! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 15:01'!
output
	"Answer my current output variable."

	direction == #forward
		ifTrue: [ ^ v2 ]
		ifFalse: [ ^ v1 ]! !

!SMarkBinaryConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 15:02'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
         the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	| in out |
	(direction == #forward)
		ifTrue: [in := v1. out := v2]
		ifFalse: [in := v2. out := v1].
	out walkStrength: (strength weakest: in walkStrength).
	out stay: (in stay).
	(out stay) ifTrue: [ self execute ].		"stay optimization"! !

!SMarkBinaryConstraint methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 14:58'!
removeFromGraph
	"Remove myself from the constraint graph."

	(v1 == nil) ifFalse: [v1 removeConstraint: self].
	(v2 == nil) ifFalse: [v2 removeConstraint: self].
	direction := nil.! !

!SMarkBinaryConstraint methodsFor: 'initialize' stamp: 'tfel 3/21/2016 16:59'!
var: variable1 var: variable2 strength: strengthSymbol
	"Initialize myself with the given variables and strength."

	strength := SMarkStrength of: strengthSymbol.
	v1 := variable1.
	v2 := variable2.
	direction := nil.
	self addConstraint.! !

SMarkBinaryConstraint subclass: #SMarkEqualityConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkEqualityConstraint commentStamp: '<historical>' prior: 0!
I constrain two variables to have the same value: "v1 = v2".!

!SMarkEqualityConstraint class methodsFor: 'instance creation' stamp: 'StefanMarr 4/2/2015 15:55'!
var: variable1 var: variable2 strength: strengthSymbol
	"Install a constraint with the given strength equating the given
	 variables."

	^(self new) var: variable1 var: variable2 strength: strengthSymbol! !

!SMarkEqualityConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 15:18'!
execute
	"Enforce this constraint. Assume that it is satisfied."
 
	(direction == #forward)
		ifTrue: [v2 value: v1 value]
		ifFalse: [v1 value: v2 value].! !

SMarkBinaryConstraint subclass: #SMarkScaleConstraint
	instanceVariableNames: 'offset scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkScaleConstraint commentStamp: '<historical>' prior: 0!
I relate two variables by the linear scaling relationship:
"v2 = (v1 * scale) + offset". Either v1 or v2 may be changed to maintain this
relationship but the scale factor and offset are considered read-only.

Instance variables:
	scale		scale factor input variable <Variable>
	offset		offset input variable <Variable>!

!SMarkScaleConstraint class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:32'!
var: src var: scale var: offset var: dst strength: strengthSymbol
	"Install a scale constraint with the given strength on the given variables."

	^(self new) src: src scale: scale offset: offset dst: dst strength: strengthSymbol! !

!SMarkScaleConstraint methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 16:23'!
addToGraph
	"Add myself to the constraint graph."

	v1 addConstraint: self.
   v2 addConstraint: self.
   scale addConstraint: self.
   offset addConstraint: self.
   direction := nil.
! !

!SMarkScaleConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 16:30'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	(direction == #forward)
		ifTrue: [v2 value: (v1 value * scale value) + offset value]
		ifFalse: [v1 value: (v2 value - offset value) // scale value].! !

!SMarkScaleConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 16:32'!
inputsDo: aBlock
	"Evaluate the given block on my current input variable."

	(direction == #forward)
		ifTrue: [ aBlock value: v1.
					 aBlock value: scale.
					 aBlock value: offset]
		ifFalse: [ aBlock value: v2.
					  aBlock 	value: scale. 
					  aBlock 	value: offset].! !

!SMarkScaleConstraint methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 16:32'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay', the value for the current output of this constraint. Assume this constraint is satisfied."

	| in out |
	(direction == #forward)
		ifTrue: [in := v1. out := v2]
		ifFalse: [out := v1. in := v2].
	out walkStrength: (strength weakest: in walkStrength).
	out stay: ((in stay) and: [(scale stay) and: [offset stay]]).
	out stay ifTrue: [self execute].		"stay optimization"! !

!SMarkScaleConstraint methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 16:24'!
removeFromGraph
	"Remove myself from the constraint graph."

	(v1 == nil) ifFalse: [v1 removeConstraint: self].
	(v2 == nil) ifFalse: [v2 removeConstraint: self].
	(scale == nil) ifFalse: [scale removeConstraint: self].
	(offset == nil) ifFalse: [offset removeConstraint: self].
	direction := nil.
! !

!SMarkScaleConstraint methodsFor: 'initialize' stamp: 'tfel 3/21/2016 16:59'!
src: srcVar scale: scaleVar offset: offsetVar dst: dstVar strength: strengthSymbol
	"Initialize myself with the given variables and strength."

	strength := SMarkStrength of: strengthSymbol.
	v1 := srcVar.
	v2 := dstVar.
	scale := scaleVar.
	offset := offsetVar.
	direction := nil.
	self addConstraint.! !

SMarkAbstractConstraint subclass: #SMarkUnaryConstraint
	instanceVariableNames: 'output satisfied'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkUnaryConstraint commentStamp: '<historical>' prior: 0!
I am an abstract superclass for constraints having a single possible output variable.

Instance variables:
	output		possible output variable <Variable>
	satisfied		true if I am currently satisfied <Boolean>!

SMarkUnaryConstraint subclass: #SMarkEditConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkEditConstraint commentStamp: '<historical>' prior: 0!
I mark variables that should, with some level of preference, stay the same. I have one method with zero inputs and one output, which does nothing. Planners may exploit the fact that, if I am satisfied, my output will not change during plan execution. This is called "stay optimization."!

!SMarkEditConstraint class methodsFor: 'instance creation' stamp: 'StefanMarr 4/2/2015 15:16'!
var: aVariable strength: strengthSymbol
	"Install an edit constraint with the given strength on the given
	 variable."

	^(self new) var: aVariable strength: strengthSymbol! !

!SMarkEditConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:19'!
execute
	"Edit constraints do nothing."! !

!SMarkEditConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:18'!
isInput
	"I indicate that a variable is to be changed by imperative code."

	^true! !

SMarkUnaryConstraint subclass: #SMarkStayConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkStayConstraint commentStamp: '<historical>' prior: 0!
I mark variables that should, with some level of preference, stay the same.
I have one method with zero inputs and one output, which does nothing. Planners
may exploit the fact that, if I am satisfied, my output will not change during
plan execution. This is called "stay optimization."!

!SMarkStayConstraint class methodsFor: 'instance creation' stamp: 'StefanMarr 4/2/2015 15:17'!
var: aVariable strength: strengthSymbol
	"Install an edit constraint with the given strength on the given
	 variable."

	^(self new) var: aVariable strength: strengthSymbol! !

!SMarkStayConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:20'!
execute
	"Stay constraints do nothing."! !

!SMarkUnaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:16'!
addToGraph
	"Add myself to the constraint graph."

	output addConstraint: self.
	satisfied := false.! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:19'!
chooseMethod: mark
	"Decide if I can be satisfied and record that decision."

	satisfied :=
		output mark ~= mark and:
		[strength stronger: output walkStrength].! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
inputsDo: aBlock
	"I have no input variables."! !

!SMarkUnaryConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:15'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	^satisfied! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	satisfied := false.! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:18'!
output
	"Answer my current output variable."

	^ output! !

!SMarkUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:18'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
	 the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	output walkStrength: strength.
	output stay: self isInput not.
	output stay ifTrue: [self execute].	"stay optimization"! !

!SMarkUnaryConstraint methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 16:41'!
removeFromGraph
	"Remove myself from the constraint graph."

	(output == nil) ifFalse: [output removeConstraint: self].
	satisfied := false.! !

!SMarkUnaryConstraint methodsFor: 'initialize' stamp: 'tfel 3/21/2016 16:59'!
var: aVariable strength: strengthSymbol
	"Initialize myself with the given variable and strength."

	strength := SMarkStrength of: strengthSymbol.
	output := aVariable.
	satisfied := false.
	self addConstraint.! !

Object subclass: #SMarkBlowfish
	instanceVariableNames: 'rounds piArray s0 s1 s2 s3 xl xr current key data index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkBlowfish commentStamp: '<historical>' prior: 0!
This is just enough of the Blowfish algorithm from 
http://www.openbsd.org/cgi-bin/cvsweb/~checkout~/src/lib/libc/crypt/blowfish.c

to be able to run BCrypt.  


Instance Variables:
	rounds	<AbstractSound | CalendarDuration | Collection | Color | DateAndTime | DhbDecimalFloatingNumber | DhbMatrix | DhbPolynomial | Duration | InfiniteDuration | Number | PassportNotAMetanumber | Point | ScientificDuration | TemporalInterval | Timespan | TraitComposition | TraitDescription | TraitTransformation>
	piArray	<Object>
	s0	<Matrix>
	s1	<Object>
	s2	<Object>
	s3	<Object>
	s4	<ProtoObject | PseudoContext>
	xl	<Integer>
	xr	<Integer>
	current	<Integer>
	key	<ProtoObject | PseudoContext>
	data	<Object>!

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
blockSize
	^8! !

!SMarkBlowfish class methodsFor: 'decrypt' stamp: 'gsa 4/30/2012 19:50'!
decrypt: someData with: aKeyByteArray
"use this when you have a wordArray"
	^self new decrypt: someData with: aKeyByteArray.! !

!SMarkBlowfish class methodsFor: 'decrypt' stamp: 'gsa 4/30/2012 19:50'!
decryptString: someData with: aKeyString
|dataToEncrypt |
dataToEncrypt :=OrderedCollection new.
someData do:[:each | dataToEncrypt add: each asciiValue ].
	^self new decrypt: dataToEncrypt asArray with: aKeyString asByteArray .! !

!SMarkBlowfish class methodsFor: 'decrypt' stamp: 'tfel 6/2/2015 10:16'!
decryptToString: someData with: aKey
	| decryptedData | 
	decryptedData := (self new ecbDecrypt: someData with: (self intAsByteArray: aKey)).
	^ decryptedData asByteArray asString.! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
defaultRounds
^self minRounds! !

!SMarkBlowfish class methodsFor: 'encrypt' stamp: 'gsa 4/30/2012 19:50'!
ecbDecrypt: someData with: aKey
"use this when you have a byteArray"
	^self new ecbDecrypt: someData with: aKey.! !

!SMarkBlowfish class methodsFor: 'encrypt' stamp: 'gsa 4/30/2012 19:50'!
ecbEncrypt: someData with: aKey
"use this when you have a byteArray"
	^self new ecbEncrypt: someData with: aKey.! !

!SMarkBlowfish class methodsFor: 'encrypt' stamp: 'gsa 4/30/2012 19:50'!
encrypt: someData with: aKey
"use this when you have a wordArray"
	^self new encrypt: someData  with: aKey.! !

!SMarkBlowfish class methodsFor: 'encrypt' stamp: 'gsa 4/30/2012 19:50'!
encryptString: someData with: aKeyString
"use this with a string"
|dataToEncrypt |
dataToEncrypt :=OrderedCollection new.
someData do:[:each | dataToEncrypt add: each asciiValue ].
	^self new ecbEncrypt: dataToEncrypt asArray with: aKeyString asByteArray .! !

!SMarkBlowfish class methodsFor: 'util' stamp: 'tfel 6/2/2015 10:10'!
intAsByteArray: anInteger
	| stream |
	stream := WriteStream on: ByteArray new.
	anInteger digitLength to: 1 by: -1 do: [:digitIndex |
		stream nextPut: (anInteger digitAt: digitIndex)].
	^ stream contents! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
maxRounds
^20
! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
maxUserKeyLength
	^448/8! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
minRounds
^16! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:51'!
pBox
	^#(		16r243F6A88 16r85A308D3 16r13198A2E 16r03707344 16rA4093822 16r299F31D0
			16r082EFA98 16rEC4E6C89 16r452821E6 16r38D01377 16rBE5466CF 16r34E90C6C
			16rC0AC29B7 16rC97C50DD 16r3F84D5B5 16rB5470917 16r9216D5D9 16r8979FB1B)! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:52'!
s0Box
	^#(16rD1310BA6 16r98DFB5AC 16r2FFD72DB 16rD01ADFB7
			16rB8E1AFED 16r6A267E96 16rBA7C9045 16rF12C7F99
			16r24A19947 16rB3916CF7 16r0801F2E2 16r858EFC16
			16r636920D8 16r71574E69 16rA458FEA3 16rF4933D7E
			16r0D95748F 16r728EB658 16r718BCD58 16r82154AEE
			16r7B54A41D 16rC25A59B5 16r9C30D539 16r2AF26013
			16rC5D1B023 16r286085F0 16rCA417918 16rB8DB38EF
			16r8E79DCB0 16r603A180E 16r6C9E0E8B 16rB01E8A3E
			16rD71577C1 16rBD314B27 16r78AF2FDA 16r55605C60
			16rE65525F3 16rAA55AB94 16r57489862 16r63E81440
			16r55CA396A 16r2AAB10B6 16rB4CC5C34 16r1141E8CE
			16rA15486AF 16r7C72E993 16rB3EE1411 16r636FBC2A
			16r2BA9C55D 16r741831F6 16rCE5C3E16 16r9B87931E
			16rAFD6BA33 16r6C24CF5C 16r7A325381 16r28958677
			16r3B8F4898 16r6B4BB9AF 16rC4BFE81B 16r66282193
			16r61D809CC 16rFB21A991 16r487CAC60 16r5DEC8032
			16rEF845D5D 16rE98575B1 16rDC262302 16rEB651B88
			16r23893E81 16rD396ACC5 16r0F6D6FF3 16r83F44239
			16r2E0B4482 16rA4842004 16r69C8F04A 16r9E1F9B5E
			16r21C66842 16rF6E96C9A 16r670C9C61 16rABD388F0
			16r6A51A0D2 16rD8542F68 16r960FA728 16rAB5133A3
			16r6EEF0B6C 16r137A3BE4 16rBA3BF050 16r7EFB2A98
			16rA1F1651D 16r39AF0176 16r66CA593E 16r82430E88
			16r8CEE8619 16r456F9FB4 16r7D84A5C3 16r3B8B5EBE
			16rE06F75D8 16r85C12073 16r401A449F 16r56C16AA6
			16r4ED3AA62 16r363F7706 16r1BFEDF72 16r429B023D
			16r37D0D724 16rD00A1248 16rDB0FEAD3 16r49F1C09B
			16r075372C9 16r80991B7B 16r25D479D8 16rF6E8DEF7
			16rE3FE501A 16rB6794C3B 16r976CE0BD 16r04C006BA
			16rC1A94FB6 16r409F60C4 16r5E5C9EC2 16r196A2463
			16r68FB6FAF 16r3E6C53B5 16r1339B2EB 16r3B52EC6F
			16r6DFC511F 16r9B30952C 16rCC814544 16rAF5EBD09
			16rBEE3D004 16rDE334AFD 16r660F2807 16r192E4BB3
			16rC0CBA857 16r45C8740F 16rD20B5F39 16rB9D3FBDB
			16r5579C0BD 16r1A60320A 16rD6A100C6 16r402C7279
			16r679F25FE 16rFB1FA3CC 16r8EA5E9F8 16rDB3222F8
			16r3C7516DF 16rFD616B15 16r2F501EC8 16rAD0552AB
			16r323DB5FA 16rFD238760 16r53317B48 16r3E00DF82
			16r9E5C57BB 16rCA6F8CA0 16r1A87562E 16rDF1769DB
			16rD542A8F6 16r287EFFC3 16rAC6732C6 16r8C4F5573
			16r695B27B0 16rBBCA58C8 16rE1FFA35D 16rB8F011A0
			16r10FA3D98 16rFD2183B8 16r4AFCB56C 16r2DD1D35B
			16r9A53E479 16rB6F84565 16rD28E49BC 16r4BFB9790
			16rE1DDF2DA 16rA4CB7E33 16r62FB1341 16rCEE4C6E8
			16rEF20CADA 16r36774C01 16rD07E9EFE 16r2BF11FB4
			16r95DBDA4D 16rAE909198 16rEAAD8E71 16r6B93D5A0
			16rD08ED1D0 16rAFC725E0 16r8E3C5B2F 16r8E7594B7
			16r8FF6E2FB 16rF2122B64 16r8888B812 16r900DF01C
			16r4FAD5EA0 16r688FC31C 16rD1CFF191 16rB3A8C1AD
			16r2F2F2218 16rBE0E1777 16rEA752DFE 16r8B021FA1
			16rE5A0CC0F 16rB56F74E8 16r18ACF3D6 16rCE89E299
			16rB4A84FE0 16rFD13E0B7 16r7CC43B81 16rD2ADA8D9
			16r165FA266 16r80957705 16r93CC7314 16r211A1477
			16rE6AD2065 16r77B5FA86 16rC75442F5 16rFB9D35CF
			16rEBCDAF0C 16r7B3E89A0 16rD6411BD3 16rAE1E7E49
			16r00250E2D 16r2071B35E 16r226800BB 16r57B8E0AF
			16r2464369B 16rF009B91E 16r5563911D 16r59DFA6AA
			16r78C14389 16rD95A537F 16r207D5BA2 16r02E5B9C5
			16r83260376 16r6295CFA9 16r11C81968 16r4E734A41
			16rB3472DCA 16r7B14A94A 16r1B510052 16r9A532915
			16rD60F573F 16rBC9BC6E4 16r2B60A476 16r81E67400
			16r08BA6FB5 16r571BE91F 16rF296EC6B 16r2A0DD915
			16rB6636521 16rE7B9F9B6 16rFF34052E 16rC5855664
			16r53B02D5D 16rA99F8FA1 16r08BA4799 16r6E85076A	)! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:52'!
s1Box
	^#(16r4B7A70E9 16rB5B32944 16rDB75092E 16rC4192623
			16rAD6EA6B0 16r49A7DF7D 16r9CEE60B8 16r8FEDB266
			16rECAA8C71 16r699A17FF 16r5664526C 16rC2B19EE1
			16r193602A5 16r75094C29 16rA0591340 16rE4183A3E
			16r3F54989A 16r5B429D65 16r6B8FE4D6 16r99F73FD6
			16rA1D29C07 16rEFE830F5 16r4D2D38E6 16rF0255DC1
			16r4CDD2086 16r8470EB26 16r6382E9C6 16r021ECC5E
			16r09686B3F 16r3EBAEFC9 16r3C971814 16r6B6A70A1
			16r687F3584 16r52A0E286 16rB79C5305 16rAA500737
			16r3E07841C 16r7FDEAE5C 16r8E7D44EC 16r5716F2B8
			16rB03ADA37 16rF0500C0D 16rF01C1F04 16r0200B3FF
			16rAE0CF51A 16r3CB574B2 16r25837A58 16rDC0921BD
			16rD19113F9 16r7CA92FF6 16r94324773 16r22F54701
			16r3AE5E581 16r37C2DADC 16rC8B57634 16r9AF3DDA7
			16rA9446146 16r0FD0030E 16rECC8C73E 16rA4751E41
			16rE238CD99 16r3BEA0E2F 16r3280BBA1 16r183EB331
			16r4E548B38 16r4F6DB908 16r6F420D03 16rF60A04BF
			16r2CB81290 16r24977C79 16r5679B072 16rBCAF89AF
			16rDE9A771F 16rD9930810 16rB38BAE12 16rDCCF3F2E
			16r5512721F 16r2E6B7124 16r501ADDE6 16r9F84CD87
			16r7A584718 16r7408DA17 16rBC9F9ABC 16rE94B7D8C
			16rEC7AEC3A 16rDB851DFA 16r63094366 16rC464C3D2
			16rEF1C1847 16r3215D908 16rDD433B37 16r24C2BA16
			16r12A14D43 16r2A65C451 16r50940002 16r133AE4DD
			16r71DFF89E 16r10314E55 16r81AC77D6 16r5F11199B
			16r043556F1 16rD7A3C76B 16r3C11183B 16r5924A509
			16rF28FE6ED 16r97F1FBFA 16r9EBABF2C 16r1E153C6E
			16r86E34570 16rEAE96FB1 16r860E5E0A 16r5A3E2AB3
			16r771FE71C 16r4E3D06FA 16r2965DCB9 16r99E71D0F
			16r803E89D6 16r5266C825 16r2E4CC978 16r9C10B36A
			16rC6150EBA 16r94E2EA78 16rA5FC3C53 16r1E0A2DF4
			16rF2F74EA7 16r361D2B3D 16r1939260F 16r19C27960
			16r5223A708 16rF71312B6 16rEBADFE6E 16rEAC31F66
			16rE3BC4595 16rA67BC883 16rB17F37D1 16r018CFF28
			16rC332DDEF 16rBE6C5AA5 16r65582185 16r68AB9802
			16rEECEA50F 16rDB2F953B 16r2AEF7DAD 16r5B6E2F84
			16r1521B628 16r29076170 16rECDD4775 16r619F1510
			16r13CCA830 16rEB61BD96 16r0334FE1E 16rAA0363CF
			16rB5735C90 16r4C70A239 16rD59E9E0B 16rCBAADE14
			16rEECC86BC 16r60622CA7 16r9CAB5CAB 16rB2F3846E
			16r648B1EAF 16r19BDF0CA 16rA02369B9 16r655ABB50
			16r40685A32 16r3C2AB4B3 16r319EE9D5 16rC021B8F7
			16r9B540B19 16r875FA099 16r95F7997E 16r623D7DA8
			16rF837889A 16r97E32D77 16r11ED935F 16r16681281
			16r0E358829 16rC7E61FD6 16r96DEDFA1 16r7858BA99
			16r57F584A5 16r1B227263 16r9B83C3FF 16r1AC24696
			16rCDB30AEB 16r532E3054 16r8FD948E4 16r6DBC3128
			16r58EBF2EF 16r34C6FFEA 16rFE28ED61 16rEE7C3C73
			16r5D4A14D9 16rE864B7E3 16r42105D14 16r203E13E0
			16r45EEE2B6 16rA3AAABEA 16rDB6C4F15 16rFACB4FD0
			16rC742F442 16rEF6ABBB5 16r654F3B1D 16r41CD2105
			16rD81E799E 16r86854DC7 16rE44B476A 16r3D816250
			16rCF62A1F2 16r5B8D2646 16rFC8883A0 16rC1C7B6A3
			16r7F1524C3 16r69CB7492 16r47848A0B 16r5692B285
			16r095BBF00 16rAD19489D 16r1462B174 16r23820E00
			16r58428D2A 16r0C55F5EA 16r1DADF43E 16r233F7061
			16r3372F092 16r8D937E41 16rD65FECF1 16r6C223BDB
			16r7CDE3759 16rCBEE7460 16r4085F2A7 16rCE77326E
			16rA6078084 16r19F8509E 16rE8EFD855 16r61D99735
			16rA969A7AA 16rC50C06C2 16r5A04ABFC 16r800BCADC
			16r9E447A2E 16rC3453484 16rFDD56705 16r0E1E9EC9
			16rDB73DBD3 16r105588CD 16r675FDA79 16rE3674340
			16rC5C43465 16r713E38D8 16r3D28F89E 16rF16DFF20
			16r153E21E7 16r8FB03D4A 16rE6E39F2B 16rDB83ADF7)! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:52'!
s2Box
	^#(16rE93D5A68 16r948140F7 16rF64C261C 16r94692934
			16r411520F7 16r7602D4F7 16rBCF46B2E 16rD4A20068
			16rD4082471 16r3320F46A 16r43B7D4B7 16r500061AF
			16r1E39F62E 16r97244546 16r14214F74 16rBF8B8840
			16r4D95FC1D 16r96B591AF 16r70F4DDD3 16r66A02F45
			16rBFBC09EC 16r03BD9785 16r7FAC6DD0 16r31CB8504
			16r96EB27B3 16r55FD3941 16rDA2547E6 16rABCA0A9A
			16r28507825 16r530429F4 16r0A2C86DA 16rE9B66DFB
			16r68DC1462 16rD7486900 16r680EC0A4 16r27A18DEE
			16r4F3FFEA2 16rE887AD8C 16rB58CE006 16r7AF4D6B6
			16rAACE1E7C 16rD3375FEC 16rCE78A399 16r406B2A42
			16r20FE9E35 16rD9F385B9 16rEE39D7AB 16r3B124E8B
			16r1DC9FAF7 16r4B6D1856 16r26A36631 16rEAE397B2
			16r3A6EFA74 16rDD5B4332 16r6841E7F7 16rCA7820FB
			16rFB0AF54E 16rD8FEB397 16r454056AC 16rBA489527
			16r55533A3A 16r20838D87 16rFE6BA9B7 16rD096954B
			16r55A867BC 16rA1159A58 16rCCA92963 16r99E1DB33
			16rA62A4A56 16r3F3125F9 16r5EF47E1C 16r9029317C
			16rFDF8E802 16r04272F70 16r80BB155C 16r05282CE3
			16r95C11548 16rE4C66D22 16r48C1133F 16rC70F86DC
			16r07F9C9EE 16r41041F0F 16r404779A4 16r5D886E17
			16r325F51EB 16rD59BC0D1 16rF2BCC18F 16r41113564
			16r257B7834 16r602A9C60 16rDFF8E8A3 16r1F636C1B
			16r0E12B4C2 16r02E1329E 16rAF664FD1 16rCAD18115
			16r6B2395E0 16r333E92E1 16r3B240B62 16rEEBEB922
			16r85B2A20E 16rE6BA0D99 16rDE720C8C 16r2DA2F728
			16rD0127845 16r95B794FD 16r647D0862 16rE7CCF5F0
			16r5449A36F 16r877D48FA 16rC39DFD27 16rF33E8D1E
			16r0A476341 16r992EFF74 16r3A6F6EAB 16rF4F8FD37
			16rA812DC60 16rA1EBDDF8 16r991BE14C 16rDB6E6B0D
			16rC67B5510 16r6D672C37 16r2765D43B 16rDCD0E804
			16rF1290DC7 16rCC00FFA3 16rB5390F92 16r690FED0B
			16r667B9FFB 16rCEDB7D9C 16rA091CF0B 16rD9155EA3
			16rBB132F88 16r515BAD24 16r7B9479BF 16r763BD6EB
			16r37392EB3 16rCC115979 16r8026E297 16rF42E312D
			16r6842ADA7 16rC66A2B3B 16r12754CCC 16r782EF11C
			16r6A124237 16rB79251E7 16r06A1BBE6 16r4BFB6350
			16r1A6B1018 16r11CAEDFA 16r3D25BDD8 16rE2E1C3C9
			16r44421659 16r0A121386 16rD90CEC6E 16rD5ABEA2A
			16r64AF674E 16rDA86A85F 16rBEBFE988 16r64E4C3FE
			16r9DBC8057 16rF0F7C086 16r60787BF8 16r6003604D
			16rD1FD8346 16rF6381FB0 16r7745AE04 16rD736FCCC
			16r83426B33 16rF01EAB71 16rB0804187 16r3C005E5F
			16r77A057BE 16rBDE8AE24 16r55464299 16rBF582E61
			16r4E58F48F 16rF2DDFDA2 16rF474EF38 16r8789BDC2
			16r5366F9C3 16rC8B38E74 16rB475F255 16r46FCD9B9
			16r7AEB2661 16r8B1DDF84 16r846A0E79 16r915F95E2
			16r466E598E 16r20B45770 16r8CD55591 16rC902DE4C
			16rB90BACE1 16rBB8205D0 16r11A86248 16r7574A99E
			16rB77F19B6 16rE0A9DC09 16r662D09A1 16rC4324633
			16rE85A1F02 16r09F0BE8C 16r4A99A025 16r1D6EFE10
			16r1AB93D1D 16r0BA5A4DF 16rA186F20F 16r2868F169
			16rDCB7DA83 16r573906FE 16rA1E2CE9B 16r4FCD7F52
			16r50115E01 16rA70683FA 16rA002B5C4 16r0DE6D027
			16r9AF88C27 16r773F8641 16rC3604C06 16r61A806B5
			16rF0177A28 16rC0F586E0 16r006058AA 16r30DC7D62
			16r11E69ED7 16r2338EA63 16r53C2DD94 16rC2C21634
			16rBBCBEE56 16r90BCB6DE 16rEBFC7DA1 16rCE591D76
			16r6F05E409 16r4B7C0188 16r39720A3D 16r7C927C24
			16r86E3725F 16r724D9DB9 16r1AC15BB4 16rD39EB8FC
			16rED545578 16r08FCA5B5 16rD83D7CD3 16r4DAD0FC4
			16r1E50EF5E 16rB161E6F8 16rA28514D9 16r6C51133C
			16r6FD5C7E7 16r56E14EC4 16r362ABFCE 16rDDC6C837
			16rD79A3234 16r92638212 16r670EFA8E 16r406000E0)! !

!SMarkBlowfish class methodsFor: 'defaults' stamp: 'gsa 4/30/2012 19:52'!
s3Box
	^#(16r3A39CE37 16rD3FAF5CF 16rABC27737 16r5AC52D1B
			16r5CB0679E 16r4FA33742 16rD3822740 16r99BC9BBE
			16rD5118E9D 16rBF0F7315 16rD62D1C7E 16rC700C47B
			16rB78C1B6B 16r21A19045 16rB26EB1BE 16r6A366EB4
			16r5748AB2F 16rBC946E79 16rC6A376D2 16r6549C2C8
			16r530FF8EE 16r468DDE7D 16rD5730A1D 16r4CD04DC6
			16r2939BBDB 16rA9BA4650 16rAC9526E8 16rBE5EE304
			16rA1FAD5F0 16r6A2D519A 16r63EF8CE2 16r9A86EE22
			16rC089C2B8 16r43242EF6 16rA51E03AA 16r9CF2D0A4
			16r83C061BA 16r9BE96A4D 16r8FE51550 16rBA645BD6
			16r2826A2F9 16rA73A3AE1 16r4BA99586 16rEF5562E9
			16rC72FEFD3 16rF752F7DA 16r3F046F69 16r77FA0A59
			16r80E4A915 16r87B08601 16r9B09E6AD 16r3B3EE593
			16rE990FD5A 16r9E34D797 16r2CF0B7D9 16r022B8B51
			16r96D5AC3A 16r017DA67D 16rD1CF3ED6 16r7C7D2D28
			16r1F9F25CF 16rADF2B89B 16r5AD6B472 16r5A88F54C
			16rE029AC71 16rE019A5E6 16r47B0ACFD 16rED93FA9B
			16rE8D3C48D 16r283B57CC 16rF8D56629 16r79132E28
			16r785F0191 16rED756055 16rF7960E44 16rE3D35E8C
			16r15056DD4 16r88F46DBA 16r03A16125 16r0564F0BD
			16rC3EB9E15 16r3C9057A2 16r97271AEC 16rA93A072A
			16r1B3F6D9B 16r1E6321F5 16rF59C66FB 16r26DCF319
			16r7533D928 16rB155FDF5 16r03563482 16r8ABA3CBB
			16r28517711 16rC20AD9F8 16rABCC5167 16rCCAD925F
			16r4DE81751 16r3830DC8E 16r379D5862 16r9320F991
			16rEA7A90C2 16rFB3E7BCE 16r5121CE64 16r774FBE32
			16rA8B6E37E 16rC3293D46 16r48DE5369 16r6413E680
			16rA2AE0810 16rDD6DB224 16r69852DFD 16r09072166
			16rB39A460A 16r6445C0DD 16r586CDECF 16r1C20C8AE
			16r5BBEF7DD 16r1B588D40 16rCCD2017F 16r6BB4E3BB
			16rDDA26A7E 16r3A59FF45 16r3E350A44 16rBCB4CDD5
			16r72EACEA8 16rFA6484BB 16r8D6612AE 16rBF3C6F47
			16rD29BE463 16r542F5D9E 16rAEC2771B 16rF64E6370
			16r740E0D8D 16rE75B1357 16rF8721671 16rAF537D5D
			16r4040CB08 16r4EB4E2CC 16r34D2466A 16r0115AF84
			16rE1B00428 16r95983A1D 16r06B89FB4 16rCE6EA048
			16r6F3F3B82 16r3520AB82 16r011A1D4B 16r277227F8
			16r611560B1 16rE7933FDC 16rBB3A792B 16r344525BD
			16rA08839E1 16r51CE794B 16r2F32C9B7 16rA01FBAC9
			16rE01CC87E 16rBCC7D1F6 16rCF0111C3 16rA1E8AAC7
			16r1A908749 16rD44FBD9A 16rD0DADECB 16rD50ADA38
			16r0339C32A 16rC6913667 16r8DF9317C 16rE0B12B4F
			16rF79E59B7 16r43F5BB3A 16rF2D519FF 16r27D9459C
			16rBF97222C 16r15E6FC2A 16r0F91FC71 16r9B941525
			16rFAE59361 16rCEB69CEB 16rC2A86459 16r12BAA8D1
			16rB6C1075E 16rE3056A0C 16r10D25065 16rCB03A442
			16rE0EC6E0E 16r1698DB3B 16r4C98A0BE 16r3278E964
			16r9F1F9532 16rE0D392DF 16rD3A0342B 16r8971F21E
			16r1B0A7441 16r4BA3348C 16rC5BE7120 16rC37632D8
			16rDF359F8D 16r9B992F2E 16rE60B6F47 16r0FE3F11D
			16rE54CDA54 16r1EDAD891 16rCE6279CF 16rCD3E7E6F
			16r1618B166 16rFD2C1D05 16r848FD2C5 16rF6FB2299
			16rF523F357 16rA6327623 16r93A83531 16r56CCCD02
			16rACF08162 16r5A75EBB5 16r6E163697 16r88D273CC
			16rDE966292 16r81B949D0 16r4C50901B 16r71C65614
			16rE6C6C7BD 16r327A140A 16r45E1D006 16rC3F27B9A
			16rC9AA53FD 16r62A80F00 16rBB25BFE2 16r35BDD2F6
			16r71126905 16rB2040222 16rB6CBCF7C 16rCD769C2B
			16r53113EC0 16r1640E3D3 16r38ABBD60 16r2547ADF0
			16rBA38209C 16rF746CE76 16r77AFA1C5 16r20756060
			16r85CBFE4E 16r8AE88DD8 16r7AAAF9B0 16r4CF9AA7E
			16r1948C25C 16r02FB8A8C 16r01C36AE4 16rD6EBE1F9
			16r90D4F869 16rA65CDEA0 16r3F09252D 16rC208E69F
			16rB74E6132 16rCE77E25B 16r578FDFE3 16r3AC372E6)! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:53'!
blfDec: dataArray for: blocks
	| j newDataArray |
	newDataArray := Array new: dataArray size.
	j := 1.
	(1 to: blocks)
		do: [ :each | 
			xl := dataArray at: j.
			xr := dataArray at: j + 1.
			self decipher.
			newDataArray at: j put: xl.
			newDataArray at: j + 1 put: xr.
			j := j + 2 ].
	^ newDataArray! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 18:48'!
blfEcbDecrypt: dataArray for: times

 |  newDataArray |
newDataArray:=dataArray copy.

	(1 to: times by: 8) do:[ :each | 
		
		xl:=((((newDataArray at: 1) bitShift: 24) bitOr: ((newDataArray at: 2) bitShift: 16) )bitOr: ((newDataArray at: 3) bitShift: 8)) bitOr: (newDataArray at: 4).  
		xr:=((((newDataArray at: 5) bitShift: 24) bitOr: ((newDataArray at: 6) bitShift: 16) )bitOr: ((newDataArray at: 7) bitShift: 8)) bitOr: (newDataArray at: 8).
		
		self decipher .
		
		newDataArray at: 1 put: ((xl  bitShift: -24) bitAnd: 16rFF).		
		newDataArray at: 2 put: ((xl  bitShift: -16) bitAnd: 16rFF).	
		newDataArray at: 3 put: ((xl  bitShift: -8) bitAnd: 16rFF).	
		newDataArray at: 4 put: (xl bitAnd: 16rFF).
		newDataArray at: 5 put: ((xr  bitShift: -24) bitAnd: 16rFF).	
		newDataArray at: 6 put: ((xr  bitShift: -16) bitAnd: 16rFF).
		newDataArray at: 7 put: ((xr  bitShift: -8) bitAnd: 16rFF).	
		newDataArray at: 8 put: (xr bitAnd: 16rFF).	
		]	.
		
	^newDataArray ! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 18:50'!
blfEcbEncrypt: dataArray for: times

 |  newDataArray |
newDataArray:=dataArray copy.

	(1 to: times by: 8) do:[ :each | 
		
		xl:=((((newDataArray at: 1) bitShift: 24) bitOr: ((newDataArray at: 2) bitShift: 16) )bitOr: ((newDataArray at: 3) bitShift: 8)) bitOr: (newDataArray at: 4).  
		xr:=((((newDataArray at: 5) bitShift: 24) bitOr: ((newDataArray at: 6) bitShift: 16) )bitOr: ((newDataArray at: 7) bitShift: 8)) bitOr: (newDataArray at: 8).
		
		self encipher .
		
		newDataArray at: 1 put: ((xl  bitShift: -24) bitAnd: 16rFF).		
		newDataArray at: 2 put: ((xl  bitShift: -16) bitAnd: 16rFF).	
		newDataArray at: 3 put: ((xl  bitShift: -8) bitAnd: 16rFF).	
		newDataArray at: 4 put: (xl bitAnd: 16rFF).
		newDataArray at: 5 put: ((xr  bitShift: -24) bitAnd: 16rFF).	
		newDataArray at: 6 put: ((xr  bitShift: -16) bitAnd: 16rFF).
		newDataArray at: 7 put: ((xr  bitShift: -8) bitAnd: 16rFF).	
		newDataArray at: 8 put: (xr bitAnd: 16rFF).	
		]	.
		
	^newDataArray ! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:53'!
blfEnc: dataArray for: blocks
	| j newDataArray |
	newDataArray := dataArray copy.
	j := 1.
	(1 to: blocks)
		do: [ :each | 
			xl := newDataArray at: j.
			xr := newDataArray at: j + 1.
			self encipher.
			newDataArray at: j put: xl.
			newDataArray at: j + 1 put: xr.
			j := j + 2 ].
	^ newDataArray! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:53'!
blfKey: aKey
	index:=0.
	key:= aKey.
	"self initializeLittleEndianBoxes."
	self initializeBoxes.
	self expandZeroState.! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:54'!
calculateBlfRndFor:oneHalf with: otherHalf andPiAt: n
"#define BLFRND(s,p,i,j,n) (i ^= F(s,j) ^ (p)[n])"

	
^ oneHalf bitXor: ((self feistelWith: otherHalf  ) bitXor: (piArray at: n)) .
! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:54'!
decipher
	| xL xR temp |
	xL := xl copy.
	xR := xr copy.
	xL := xL bitXor: (piArray at: 18).
	(17 to: 2 by: -2)
		do: [ :each | 
			xR := self calculateBlfRndFor: xR with: xL andPiAt: each.
			xL := self calculateBlfRndFor: xL with: xR andPiAt: each - 1 ].
	xl := xR bitXor: (piArray at: 1).
	xr := xL! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:54'!
decrypt: someData with:   aKeyString

	
	self setRounds: self class defaultRounds .

	self blfKey: aKeyString.
	^self blfDec: someData for: someData size // 2.! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:54'!
ecbDecrypt: someData with:   aKeyString


	self setRounds: self class defaultRounds .

	self blfKey: aKeyString.
	^self blfEcbDecrypt: someData for: someData size // 2.! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:54'!
ecbEncrypt: someData with:   aKeyString


	self setRounds: self class defaultRounds .

	self blfKey: aKeyString.
	^self blfEcbEncrypt: someData for: someData size // 2.! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:55'!
encipher
	| xL xR temp |
	xL := xl copy.
	xR := xr copy.
	xL := xL bitXor: (piArray at: 1).
"	index <= 2
		ifTrue: [ 
			Transcript
				cr;
				show: 'New encipher';
				cr;
				show: 'Left: ';
				show: xL hex greaseString ]."
	(2 to: 17 by: 2)
		do: [ :each | 
			xR := self calculateBlfRndFor: xR with: xL andPiAt: each.
			xL := self calculateBlfRndFor: xL with: xR andPiAt: each + 1.
"			index = 2
				ifTrue: [ 
					Transcript
						cr;
						show: 'Right: ';
						show: xR hex greaseString;
						cr;
						show: 'Left: ';
						show: xL hex greaseString.
					index = 0 ] ]."].
	xR := xR bitXor: (piArray at: 18).
	xl := xR.
	xr := xL! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:55'!
encrypt: someData with:   aKeyString


	self setRounds: self class defaultRounds .

	self blfKey: aKeyString.
	
	^self blfEnc: someData  for: someData size // 2.! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:55'!
expandZeroState
	| dataL dataR s0Test s1Test s2Test s3Test  pTest|
	current := 1.
pTest:=piArray copy.
	(1 to: rounds + 2)
		do: [ :each | piArray at: each put: ((piArray at: each) bitXor: (self stream2word: key)) ].

"xl := 16r0.
xr := 16r0."
xl:=#[0 0 0 0] unsignedLongAt: 1 bigEndian:   true.
xr:=#[0 0 0 0] unsignedLongAt: 1 bigEndian:   true.
pTest:=piArray copy.
		(1 to: rounds + 2 by: 2)
		do: [ :each | 		
			self encipher.
					piArray at: each put: xl copy.
					piArray at: each+1 put: xr copy.].

s0Test :=s0 copy.
s1Test :=s1 copy.
s2Test :=s2 copy.
s3Test :=s3 copy.



		(1 to:256 by:2)
		do: [ :each | self encipher.
					s0 at: each put: xl copy.
					s0 at: each+1 put: xr copy.
					].

		(1 to:256 by:2)
		do: [ :each | self encipher.
					s1 at: each put: xl copy.
					s1 at: each+1 put: xr copy.].

		(1 to:256 by:2)
		do: [ :each | self encipher.
					s2 at: each put: xl copy.
					s2 at: each+1 put: xr copy.].

		(1 to:256 by:2)
		do: [ :each | self encipher.
					s3 at: each put: xl copy.
					s3 at: each+1 put: xr copy.].
			
"	s0Test:= s0 select:[:each | each asByteArray size >4].
	s1Test:= s1 select:[:each | each asByteArray size >4].
	s2Test:= s2 select:[:each | each asByteArray size >4].
	s3Test:= s3 select:[:each | each asByteArray size >4].
	(s0Test size + s1Test size + s2Test size + s3Test size) >0 ifTrue:[self halt]."! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 18:47'!
feistelWith: otherHalf
	| a b c d y byteArray |
	a := ((otherHalf bitShift: -24) bitAnd: 16rFF) + 1.
	b := ((otherHalf bitShift: -16) bitAnd: 16rFF) + 1.
	c := ((otherHalf bitShift: -8) bitAnd: 16rFF) + 1.
	d := (otherHalf bitAnd: 16rFF) + 1.
	y := ((s0 at: a) + (s1 at: b)) \\ 4294967296.	" (2 raisedTo: 32)"
	y := y bitXor: (s2 at: c).
	y := (y + (s3 at: d)) \\ 4294967296.	"(2 raisedTo: 32)"
	^ y! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:56'!
initializeBoxes
	piArray :=self class pBox copy.
	s0:=self class s0Box copy.
	s1:=self class s1Box copy.
	s2:=self class s2Box copy.
	s3:=self class s3Box copy.

	
	! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:56'!
setRounds: anInteger

	rounds:=(anInteger >= self class minRounds and:[anInteger <= self class maxRounds]) ifTrue: [anInteger] ifFalse:[self class defaultRounds ]   ! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:56'!
stream2word: someData 


|temp j dataBytes |
temp:=0.

dataBytes := someData size.

1 to: 4 do:  [ :each | 
		temp:=(temp bitShift: 8 ) bitOr: ((someData at: current) bitAnd: 16rFF).

	current := (current \\ dataBytes) +1.

	   ].


^temp.
! !

!SMarkBlowfish methodsFor: 'as yet unclassified' stamp: 'gsa 4/30/2012 19:56'!
stream2word: someData length: someBytes


|temp j  |
temp:=0.



1 to: 4 do:  [ :each | 
		temp:=(temp bitShift: 8 ) bitOr: ((someData atWrap: current) bitAnd: 16rFF).

	current := (current \\ someBytes) +1.

	   ].


^temp.
! !

Object subclass: #SMarkBlowfishProfiling
	instanceVariableNames: 'keys clear encrypted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkBlowfishProfiling class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/10/2012 13:43'!
longTest
	! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/10/2012 13:49'!
initialize
	super initialize.
	self
		initializeClear;
		initializeEncrypted;
		initializeKeys! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:13'!
initializeClear
	| tmpClear |
	clear := OrderedCollection new.
	tmpClear := #('0000000000000000' 'FFFFFFFFFFFFFFFF' '1000000000000001' '1111111111111111' '1111111111111111' '0123456789ABCDEF' '0000000000000000' '0123456789ABCDEF' '01A1D6D039776742' '5CD54CA83DEF57DA' '0248D43806F67172' '51454B582DDF440A' '42FD443059577FA2' '059B5E0851CF143A' '0756D8E0774761D2' '762514B829BF486A' '3BDD119049372802' '26955F6835AF609A' '164D5E404F275232' '6B056E18759F5CCA' '004BD6EF09176062' '480D39006EE762F2' '437540C8698F3CFA' '072D43A077075292' '02FE55778117F12A' '1D9D5C5018F728C2' '305532286D6F295A' '0123456789ABCDEF' '0123456789ABCDEF' '0123456789ABCDEF' 'FFFFFFFFFFFFFFFF' '0000000000000000' '0000000000000000' 'FFFFFFFFFFFFFFFF').
	tmpClear
		do: [ :each | 
			| array tmpByteArray |
			array := WordArray new: 2.
			array at: 1 put: ((ByteArray readHexFrom: (each copyFrom: 1 to: 8)) unsignedLongAt: 1 bigEndian: true).
			array at: 2 put: ((ByteArray readHexFrom: (each copyFrom: 9 to: 16)) unsignedLongAt: 1 bigEndian: true).
			clear add: array ]! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:13'!
initializeEncrypted
	| tmpEncrypted |
	encrypted := OrderedCollection new.
	tmpEncrypted := #('4EF997456198DD78' '51866FD5B85ECB8A' '7D856F9A613063F2' '2466DD878B963C9D' '61F9C3802281B096' '7D0CC630AFDA1EC7' '4EF997456198DD78' '0ACEAB0FC6A0A28D' '59C68245EB05282B' 'B1B8CC0B250F09A0' '1730E5778BEA1DA4' 'A25E7856CF2651EB' '353882B109CE8F1A' '48F4D0884C379918' '432193B78951FC98' '13F04154D69D1AE5' '2EEDDA93FFD39C79' 'D887E0393C2DA6E3' '5F99D04F5B163969' '4A057A3B24D3977B' '452031C1E4FADA8E' '7555AE39F59B87BD' '53C55F9CB49FC019' '7A8E7BFA937E89A3' 'CF9C5D7A4986ADB5' 'D1ABB290658BC778' '55CB3774D13EF201' 'FA34EC4847B268B2' 'A790795108EA3CAE' 'C39E072D9FAC631D' '014933E0CDAFF6E4' 'F21E9A77B71C49BC' '245946885754369A' '6B5C5A9C5D9E0A5A').
	tmpEncrypted
		do: [ :each | 
			| array tmpByteArray |
			array := WordArray new: 2.
			array at: 1 put: ((ByteArray readHexFrom: (each copyFrom: 1 to: 8)) unsignedLongAt: 1 bigEndian: true).
			array at: 2 put: ((ByteArray readHexFrom: (each copyFrom: 9 to: 16)) unsignedLongAt: 1 bigEndian: true).
			encrypted add: array ]! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:12'!
initializeKeys
	| tempKeys |
	keys := OrderedCollection new.
	tempKeys := #('0000000000000000' 'FFFFFFFFFFFFFFFF' '3000000000000000' '1111111111111111' '0123456789ABCDEF' '1111111111111111' '0000000000000000' 'FEDCBA9876543210' '7CA110454A1A6E57' '0131D9619DC1376E' '07A1133E4A0B2686' '3849674C2602319E' '04B915BA43FEB5B6' '0113B970FD34F2CE' '0170F175468FB5E6' '43297FAD38E373FE' '07A7137045DA2A16' '04689104C2FD3B2F' '37D06BB516CB7546' '1F08260D1AC2465E' '584023641ABA6176' '025816164629B007' '49793EBC79B3258F' '4FB05E1515AB73A7' '49E95D6D4CA229BF' '018310DC409B26D6' '1C587F1C13924FEF' '0101010101010101' '1F1F1F1F0E0E0E0E' 'E0FEE0FEF1FEF1FE' '0000000000000000' 'FFFFFFFFFFFFFFFF' '0123456789ABCDEF' 'FEDCBA9876543210').
	tempKeys do: [ :each | keys add: (ByteArray readHexFrom: each) ]! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:32'!
longDecryptionTest
	"(1 to: keys size)"
	(20 to: keys size)
		do: [ :each | 
			| key clearText cipherText enc |
			key := keys at: each.
			clearText := clear at: each.
			cipherText := encrypted at: each.
			enc := SMarkBlowfish decrypt: cipherText with: key ]! !

!SMarkBlowfishProfiling methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:32'!
longEncryptionTest
	"(1 to: keys size)"
	(20 to: keys size)
		do: [ :each | 
			| key clearText cipherText enc |
			key := keys at: each.
			clearText := clear at: each.
			cipherText := encrypted at: each.
			enc := SMarkBlowfish encrypt: clearText with: key ]! !

Object subclass: #SMarkGSEdge
	instanceVariableNames: 'dest weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-GraphSearch'!

!SMarkGSEdge class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 15:25'!
newWith: dest and: weight
	^ self basicNew initializeWith: dest and: weight! !

!SMarkGSEdge methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 15:24'!
dest
	^ dest! !

!SMarkGSEdge methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 15:25'!
initializeWith: destination and: w
	dest   := destination.
	weight := w.! !

!SMarkGSEdge methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 15:25'!
weight
	^ weight! !

Object subclass: #SMarkGSJenkinsRandom
	instanceVariableNames: ''
	classVariableNames: 'Seed'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-GraphSearch'!

!SMarkGSJenkinsRandom methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 11:15'!
random
	"Robert Jenkins' 32 bit integer hash function."
	 Seed := ((Seed asInteger       + 2127912214 "0x7ed55d16")       + (Seed as32BitUnsignedValue  << 12) as32BitSignedValue) as32BitSignedValue.
    Seed := ((Seed bitXor: 3345072700 "0xc761c23c") bitXor: (Seed as32BitUnsignedValue >>> 19)) as32BitSignedValue.
    Seed := ((Seed asInteger      +  374761393 "0x165667B1")       + (Seed as32BitUnsignedValue  <<  5) as32BitSignedValue) as32BitSignedValue.
    Seed := ((Seed asInteger      + 3550635116 "0xd3a2646c") bitXor: (Seed as32BitUnsignedValue  <<  9) as32BitSignedValue) as32BitSignedValue.
    Seed := ((Seed asInteger      + 4251993797 "0xfd7046c5")       + (Seed as32BitUnsignedValue  <<  3) as32BitSignedValue) as32BitSignedValue.
    Seed := ((Seed bitXor: 3042594569 "0xb55a4f09") bitXor: (Seed as32BitUnsignedValue >>> 16)) as32BitSignedValue.
    ^ Seed! !

!SMarkGSJenkinsRandom methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 11:14'!
seed: val
	Seed := ThirtyTwoBitRegister basicNew load: val! !

Object subclass: #SMarkGSNode
	instanceVariableNames: 'starting noOfEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-GraphSearch'!

!SMarkGSNode class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 15:24'!
newWith: starting and: noOfEdges
	^ self basicNew initializeWith: starting and: noOfEdges! !

!SMarkGSNode methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 15:23'!
initializeWith: start and: edges
	starting := start.
	noOfEdges:= edges! !

!SMarkGSNode methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 15:23'!
noOfEdges
	^ noOfEdges! !

!SMarkGSNode methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 15:23'!
starting
	^ starting! !

Object subclass: #SMarkInplaceComplex
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkInplaceComplex class methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:33'!
real: a imaginary: b
	^(self new) real: a imaginary: b.
	! !

!SMarkInplaceComplex class methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:39'!
zero
	^(self new) real: 0 imaginary: 0.
	! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:41'!
absSq
	^(a*a) + (b*b)! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:36'!
add: aComplex
	a := a + aComplex real.
	b := b + aComplex imaginary.! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:36'!
imaginary
	^b.! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:36'!
real
	^a.! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:33'!
real: aNumber imaginary: bNumber
	a := aNumber.
	b := bNumber.
	! !

!SMarkInplaceComplex methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 13:35'!
square
	| tempA |
	tempA := (a * a) - (b * b).
	b := 2 * a * b.
	a := tempA.! !

Object subclass: #SMarkJSHashIndexTable
	instanceVariableNames: 'hashTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSHashIndexTable methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:22'!
at: name
    | slot |
    slot := self hashSlotFor: name.

    " subtract 1, 0 stands for empty "
    ^ ((hashTable at: slot) & 255) - 1! !

!SMarkJSHashIndexTable methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:16'!
at: name put: index
    | slot |
    slot := self hashSlotFor: name.
    
    index < 255
      ifTrue:  [ hashTable at: slot put: index + 1 ]
      ifFalse: [ hashTable at: slot put: 0 ]! !

!SMarkJSHashIndexTable methodsFor: 'hash' stamp: 'tfel 5/15/2015 11:48'!
hashSlotFor: element
    ^ (element hash bitAnd: 31) + 1! !

!SMarkJSHashIndexTable methodsFor: 'initialization' stamp: 'StefanMarr 4/2/2015 22:16'!
initialize
	hashTable := IntegerArray new: 32 withAll: 0! !

!SMarkJSHashIndexTable methodsFor: 'removing' stamp: 'StefanMarr 4/2/2015 22:21'!
remove: index
    1 to: hashTable size do: [:i |
      index + 1 = (hashTable at: i)
        ifTrue:  [ hashTable at: i put: 0 ]
        ifFalse: [ 
          (hashTable at: i) > index + 1 ifTrue: [
            hashTable at: i put: (hashTable at: i) - 1]]]! !

Object subclass: #SMarkJSJsonParser
	instanceVariableNames: 'input index line column current captureBuffer captureStart exceptionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonParser class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 11:38'!
with: aJsonString
    ^ self basicNew initializeWith: aJsonString! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 13:03'!
endCapture
    | captured |
    '' = captureBuffer
      ifTrue:  [ captured := input copyFrom: captureStart to: index - 1 ]
      ifFalse: [
        self pauseCapture.
        captured := captureBuffer.
        captureBuffer := '' ].
    captureStart := -1.
    
    ^ captured! !

!SMarkJSJsonParser methodsFor: 'error handling' stamp: 'tfel 5/15/2015 11:37'!
error: message
    'error:' print.
    message print.
    ':' print.
    line print.
    column println.
    exceptionBlock value: (SMarkJSParseException with: message at: index
                                          line: line    column: column )
  ! !

!SMarkJSJsonParser methodsFor: 'error handling' stamp: 'StefanMarr 4/3/2015 11:45'!
expected: expected
    self isEndOfText ifTrue: [
      self error: 'Unexpected end of input, expected ', expected asString
    ].
    self error: 'Expected ', expected! !

!SMarkJSJsonParser methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 11:31'!
initializeWith: string
    input := string.
    index := 0.
    line  := 1.
    column := 0.
    current := nil.
    captureBuffer := ''.! !

!SMarkJSJsonParser methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 11:38'!
isDigit
    current = '0' ifTrue: [^ true].
    current = '1' ifTrue: [^ true].
    current = '2' ifTrue: [^ true].
    current = '3' ifTrue: [^ true].
    current = '4' ifTrue: [^ true].
    current = '5' ifTrue: [^ true].
    current = '6' ifTrue: [^ true].
    current = '7' ifTrue: [^ true].
    current = '8' ifTrue: [^ true].
    current = '9' ifTrue: [^ true].
    ^ false! !

!SMarkJSJsonParser methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 11:38'!
isEndOfText
    ^ current isNil! !

!SMarkJSJsonParser methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 11:38'!
isWhiteSpace
    current = ' '  ifTrue: [^ true].
    current = '\t' ifTrue: [^ true].
    current = '\n' ifTrue: [^ true].
    current = '\r' ifTrue: [^ true].
    ^ false! !

!SMarkJSJsonParser methodsFor: 'parsing' stamp: 'StefanMarr 4/3/2015 11:31'!
parse
    | result |
    exceptionBlock := [:ex | ^ ex ].
    self read.
    self skipWhiteSpace.
    result := self readValue.
    self skipWhiteSpace.
    self isEndOfText ifFalse: [ self error: 'Unexpected character'].
    ^ result! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:37'!
pauseCapture
    captureBuffer := captureBuffer concatenate: (
      input substringFrom: captureStart to: index - 1).
    captureStart := -1! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 13:02'!
read
	"TODO: this is probably broken"
    current = '\n' ifTrue: [
      line := line + 1.
      column := 0.
    ].
    
    index := index + 1.
    column := column + 1.

    input ifNil: [ self error:'input nil'].
    index <= input size
      ifTrue:  [ current := input copyFrom: index to: index ]
      ifFalse: [ current := nil ]! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:36'!
readArray
    | array |
    self read.
    array := SMarkJSJsonArray new.
    
    "Array might be empty"
    self skipWhiteSpace.
    (self readChar: ']') ifTrue: [
      ^ array
    ].
    
    self readArrayElement: array.
    [self readChar: ','] whileTrue: [
      self readArrayElement: array.
    ].

    (self readChar: ']') ifFalse: [
      self expected: '"," or "]"'
    ].
    ^ array! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:32'!
readArrayElement: array
    self skipWhiteSpace.
    array add: self readValue.
    self skipWhiteSpace.! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:36'!
readChar: ch
    current = ch ifFalse: [ ^ false ].
    self read.
    ^ true! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:36'!
readDigit
    self isDigit ifFalse: [ ^ false ].
    self read.
    ^ true! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:35'!
readEscape
    self read.    
    captureBuffer := captureBuffer concatenate: self readEscapeChar.
    self read! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:35'!
readEscapeChar
    current = '"'  ifTrue: [ ^ '"'  ].
    current = '/'  ifTrue: [ ^ '/'  ].
    current = '\\' ifTrue: [ ^ '\\' ].

    current = 'b'  ifTrue: [ ^ '\b'  ].
    current = 'f'  ifTrue: [ ^ '\f'  ].
    current = 'n'  ifTrue: [ ^ '\n'  ].
    current = 'r'  ifTrue: [ ^ '\r'  ].
    current = 't'  ifTrue: [ ^ '\t'  ].

    "TODO: SOM doesn't have a way to create unicode characters."
    self expected: 'valid escape sequence. note, some are not supported'
! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:35'!
readExponent
    ((self readChar: 'e') not and: [
      (self readChar: 'E') not]) ifTrue: [ ^ false ].
    
    
    (self readChar: '+') ifFalse: [ self readChar: '-' ].
    
    self readDigit ifFalse: [ self expected: 'digit' ].

    [self readDigit] whileTrue: [].

    ^ true! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:36'!
readFalse
    self read.
    self readRequiredChar: 'a'.
    self readRequiredChar: 'l'.
    self readRequiredChar: 's'.
    self readRequiredChar: 'e'.
    ^ SMarkJSJsonLiteral FALSE! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:35'!
readFraction
    (self readChar: '.') ifFalse: [ ^ false ].
    
    self readDigit ifFalse: [ self expected: 'digit' ].
    
    [self readDigit] whileTrue: [].

    ^ true! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:33'!
readName
    current = '"' ifFalse: [ self expected: 'name' ].
    ^ self readStringInternal! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:36'!
readNull
    self read.
    self readRequiredChar: 'u'.
    self readRequiredChar: 'l'.
    self readRequiredChar: 'l'.
    ^ SMarkJSJsonLiteral NULL! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:36'!
readNumber
    | firstDigit |
    self startCapture.
    self readChar: '-'.
    firstDigit := current.
    
    self readDigit ifFalse: [ self expected: 'digit' ].
    firstDigit ~= '0' ifTrue: [ [self readDigit] whileTrue: []].
        
    self readFraction.
    self readExponent.
    ^ SMarkJSJsonNumber new: self endCapture! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:37'!
readObject
    | object |
    self read.
    object := SMarkJSJsonObject new.
    self skipWhiteSpace.

    (self readChar: '}') ifTrue: [
      ^ object
    ].
    
    self readObjectKeyValuePair: object.
    [self readChar: ','] whileTrue: [
      self readObjectKeyValuePair: object.
    ].
    
    (self readChar: '}') ifFalse: [
      self expected: '"," or "}"'
    ].
    
    ^ object! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:32'!
readObjectKeyValuePair: object
    | name |
    self skipWhiteSpace.
    name := self readName.
    self skipWhiteSpace.
  
    (self readChar: ':') ifFalse: [ self expected: ':' ].
  
    self skipWhiteSpace.
  
    object add: name with: self readValue.
  
    self skipWhiteSpace! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:34'!
readRequiredChar: ch
    (self readChar: ch) ifFalse: [
      self expected: 'character: ' + ch
    ]! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:37'!
readString
    ^ SMarkJSJsonString new: self readStringInternal! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:34'!
readStringInternal
    | string |
    self read.
    self startCapture.
    
    [current = '"'] whileFalse: [
      current = '\\' ifTrue: [
        self pauseCapture.
        self readEscape.
        self startCapture.
      ] ifFalse: [
        "if (current < 0x20) { throw expected('valid string character'); }"
        "we currently don't have a way to get the ordinal value for a character"
        "} else {"
        self read.
      ]
    ].
    string := self endCapture.
    self read.
    ^ string! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'tfel 5/15/2015 11:36'!
readTrue
    self read.
    self readRequiredChar: 'r'.
    self readRequiredChar: 'u'.
    self readRequiredChar: 'e'.
    ^ SMarkJSJsonLiteral TRUE! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:31'!
readValue
    current = 'n' ifTrue: [ ^ self readNull   ].
    current = 't' ifTrue: [ ^ self readTrue   ].
    current = 'f' ifTrue: [ ^ self readFalse  ].
    current = '"' ifTrue: [ ^ self readString ].
    current = '[' ifTrue: [ ^ self readArray  ].
    current = '{' ifTrue: [ ^ self readObject ].
    
    "Is this really the best way to write this?, or better #or:?,
     but with all the nesting, it's just ugly."
    current = '-' ifTrue: [ ^ self readNumber ].
    current = '0' ifTrue: [ ^ self readNumber ].
    current = '1' ifTrue: [ ^ self readNumber ].
    current = '2' ifTrue: [ ^ self readNumber ].
    current = '3' ifTrue: [ ^ self readNumber ].
    current = '4' ifTrue: [ ^ self readNumber ].
    current = '5' ifTrue: [ ^ self readNumber ].
    current = '6' ifTrue: [ ^ self readNumber ].
    current = '7' ifTrue: [ ^ self readNumber ].
    current = '8' ifTrue: [ ^ self readNumber ].
    current = '9' ifTrue: [ ^ self readNumber ].
    
    "else"
    self expected: 'value'! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:36'!
skipWhiteSpace
    [ self isWhiteSpace ]
      whileTrue:
        [ self read ].! !

!SMarkJSJsonParser methodsFor: 'parsing-private' stamp: 'StefanMarr 4/3/2015 11:36'!
startCapture
    captureStart := index! !

Object subclass: #SMarkJSJsonValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

SMarkJSJsonValue subclass: #SMarkJSJsonArray
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonArray class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:35'!
readFrom: string
    ^ (SMarkJSJsonValue readFrom: string) asArray! !

!SMarkJSJsonArray methodsFor: 'comparing' stamp: 'StefanMarr 4/2/2015 22:51'!
= other
    self == other ifTrue: [ ^ true ].
    other == nil ifTrue: [ ^ false ].
    self class == other class ifFalse: [ ^ false ].

    ^ values = other values! !

!SMarkJSJsonArray methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 22:49'!
add: value
    value ifNil: [ self error: 'value is null' ].
    values add: value! !

!SMarkJSJsonArray methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:35'!
addBoolean: value
    values add: (SMarkJSJsonValue boolean: value)! !

!SMarkJSJsonArray methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:35'!
addDouble: value
	values add: (SMarkJSJsonValue double: value)! !

!SMarkJSJsonArray methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:35'!
addInteger: value
    values add: (SMarkJSJsonValue integer: value)! !

!SMarkJSJsonArray methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:35'!
addString: value
    values add: (SMarkJSJsonValue string: value)! !

!SMarkJSJsonArray methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:51'!
asArray
	^ self! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:50'!
at: index
	^ values at: index! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:50'!
at: index put: value
    value ifNil: [ self error: 'value is null' ].
    values at: index put: value! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:35'!
at: index putBoolean: value
    values at: index put: (SMarkJSJsonValue boolean: value)! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:35'!
at: index putDouble: value
    values at: index put: (SMarkJSJsonValue double: value)! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:35'!
at: index putInteger: value
    values at: index put: (SMarkJSJsonValue integer: value)! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:35'!
at: index putString: value
    values at: index put: (SMarkJSJsonValue string: value)! !

!SMarkJSJsonArray methodsFor: 'hash' stamp: 'StefanMarr 4/2/2015 22:51'!
hashcode
	^ values hash! !

!SMarkJSJsonArray methodsFor: 'initialization' stamp: 'StefanMarr 4/2/2015 22:47'!
initialize
	values := OrderedCollection new.! !

!SMarkJSJsonArray methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:51'!
isArray
	^ true! !

!SMarkJSJsonArray methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:50'!
isEmpty
    ^ values isEmpty! !

!SMarkJSJsonArray methodsFor: 'removing' stamp: 'StefanMarr 4/2/2015 22:50'!
removeAt: index
    values removeAt: index! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:50'!
size
    ^ values size! !

!SMarkJSJsonArray methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 22:51'!
values
	^ values! !

SMarkJSJsonValue subclass: #SMarkJSJsonLiteral
	instanceVariableNames: 'value isNull isTrue isFalse'
	classVariableNames: 'FALSE NULL TRUE'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonLiteral class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 10:51'!
FALSE
	^ FALSE! !

!SMarkJSJsonLiteral class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 10:51'!
NULL
	^ NULL! !

!SMarkJSJsonLiteral class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 10:51'!
TRUE
	^ TRUE! !

!SMarkJSJsonLiteral class methodsFor: 'class initialization' stamp: 'StefanMarr 4/3/2015 13:13'!
initialize
   "self initialize"
	NULL := self basicNew initializeWith: 'null'.
	TRUE := self basicNew initializeWith: 'true'.
	FALSE:= self basicNew initializeWith: 'false'.! !

!SMarkJSJsonLiteral methodsFor: 'comparing' stamp: 'StefanMarr 4/3/2015 10:50'!
= other
    self == other ifTrue: [ ^ true ].  
    other == nil ifTrue: [ ^ false ].
    self class == other class ifFalse: [ ^ false ].

    ^ value = other asString
! !

!SMarkJSJsonLiteral methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 10:49'!
asBoolean
	isNull ifTrue: [ ^ super asBoolean ]
	       ifFalse:[ ^ isTrue ]! !

!SMarkJSJsonLiteral methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 10:44'!
asString
	^ value! !

!SMarkJSJsonLiteral methodsFor: 'hash' stamp: 'StefanMarr 4/3/2015 10:44'!
hashcode
	^ value hash! !

!SMarkJSJsonLiteral methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 10:44'!
initializeWith: val
    value   := val.
    isNull  := 'null'  = val.
    isTrue  := 'true'  = val.
    isFalse := 'false' = val.! !

!SMarkJSJsonLiteral methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 10:49'!
isBoolean
	^ isTrue | isFalse! !

!SMarkJSJsonLiteral methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 10:48'!
isFalse
	^ isFalse! !

!SMarkJSJsonLiteral methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 10:48'!
isNull
	^ isNull! !

!SMarkJSJsonLiteral methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 10:48'!
isTrue
	^ isTrue! !

SMarkJSJsonValue subclass: #SMarkJSJsonNumber
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonNumber class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 11:05'!
new: string
    string ifNil: [ self error: 'string is null' ].
    ^ self new initializeWith: string
! !

!SMarkJSJsonNumber methodsFor: 'comparing' stamp: 'StefanMarr 4/3/2015 10:58'!
= other
    self == other ifTrue: [ ^ true ].
    other == nil ifTrue: [ ^ false ].
    
    self class == other class ifFalse: [ ^ false ].
    ^ string = other asString
! !

!SMarkJSJsonNumber methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 10:57'!
asDouble
	^ Float readFromString: string! !

!SMarkJSJsonNumber methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 10:53'!
asInteger
	^ string asInteger! !

!SMarkJSJsonNumber methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 10:52'!
asString
	^ string! !

!SMarkJSJsonNumber methodsFor: 'hash' stamp: 'StefanMarr 4/3/2015 10:58'!
hashcode
	^ string hash! !

!SMarkJSJsonNumber methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 10:52'!
initializeWith: str
	string := str! !

!SMarkJSJsonNumber methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 10:52'!
isNumber
	^ true! !

SMarkJSJsonValue subclass: #SMarkJSJsonObject
	instanceVariableNames: 'names values table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonObject class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:36'!
readFrom: string
	^ (SMarkJSJsonValue readFrom: string) asObject! !

!SMarkJSJsonObject methodsFor: 'comparing' stamp: 'StefanMarr 4/3/2015 11:16'!
= other
    self == other ifTrue: [ ^ true  ].
    self == nil   ifTrue: [ ^ false ].
    self class == other class ifFalse: [ ^ false ].
    
    ^ names = other names & values = other values! !

!SMarkJSJsonObject methodsFor: 'adding' stamp: 'StefanMarr 4/3/2015 13:05'!
add: name with: aJsonValue
    name ifNil: [ self error: 'name is null'  ].
    aJsonValue ifNil: [ self error: 'aJsonValue is null' ].

    names  add: name.
    values add: aJsonValue.
    table at: name put: names size.! !

!SMarkJSJsonObject methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:36'!
add: name withBoolean: value
    self add: name with: (SMarkJSJsonValue boolean: value)! !

!SMarkJSJsonObject methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:36'!
add: name withNumber: value
    self add: name with: (SMarkJSJsonValue number: value)! !

!SMarkJSJsonObject methodsFor: 'adding' stamp: 'tfel 5/15/2015 11:36'!
add: name withString: value
    self add: name with: (SMarkJSJsonValue string: value)! !

!SMarkJSJsonObject methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 11:15'!
asObject
	^ self! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:14'!
at: name
    | idx |
    name ifNil: [ self error: 'name is null'  ].
    idx := self indexOf: name.
    idx = -1
      ifTrue:  [ ^ nil ]
      ifFalse: [ ^ values at: idx ]! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:14'!
at: name asBooleanWith: default
    | value |
    value := self at: name.
    value
      ifNil:    [ ^ default ]
      ifNotNil: [ ^ value asBoolean ]! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:14'!
at: name asDoubleWith: default
    | value |
    value := self at: name.
    value
      ifNil:    [ ^ default ]
      ifNotNil: [ ^ value asDouble ]! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:14'!
at: name asIntegerWith: default
    | value |
    value := self at: name.
    value
      ifNil:    [ ^ default ]
      ifNotNil: [ ^ value asInteger ]! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:14'!
at: name asStringWith: default
    | value |
    value := self at: name.
    value
      ifNil:    [ ^ default ]
      ifNotNil: [ ^ value asString ]! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:12'!
at: name put: aJsonValue
    | idx |
    name ifNil: [ self error: 'name is null'  ].
    aJsonValue ifNil: [ self error: 'aJsonValue is null' ].
  
    idx := self indexOf: name.
    idx <> -1
      ifTrue:  [values at: idx put: aJsonValue]
      ifFalse: [
        names  append: name.
        values append: aJsonValue.
        table at: name put: names size.
      ].! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:36'!
at: name putBoolean: value
    self at: name put: (SMarkJSJsonValue boolean: value)! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:36'!
at: name putNumber: value
    self at: name put: (SMarkJSJsonValue number: value)! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:36'!
at: name putString: value
    self at: name put: (SMarkJSJsonValue string: value)! !

!SMarkJSJsonObject methodsFor: 'hash' stamp: 'StefanMarr 4/3/2015 11:15'!
hashcode
	| result |
    result := 1.
    result := 31 * result + names hash.
    result := 31 * result + values hash.
    ^ result
! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:15'!
indexOf: name
    | idx |
    idx := table at: name.    
    idx ~= -1 & name = (names at: idx) ifTrue: [ ^ idx ].
    ^ names lastIndexOf: name! !

!SMarkJSJsonObject methodsFor: 'initialization' stamp: 'tfel 5/15/2015 11:35'!
initialize
    names  := OrderedCollection new.
    values := OrderedCollection new.
    table  := SMarkJSHashIndexTable new
! !

!SMarkJSJsonObject methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 11:15'!
isEmpty
	^ names isEmpty! !

!SMarkJSJsonObject methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 11:15'!
isObject
	^ true! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:15'!
names
	^ names! !

!SMarkJSJsonObject methodsFor: 'removing' stamp: 'StefanMarr 4/3/2015 11:14'!
remove: name
    | idx |
    name ifNil: [ self error: 'name is null' ].
    idx := self indexOf: name.
    idx = -1 ifFalse: [
      table  remove: name.
      names  remove: idx.
      values remove: idx.
    ].! !

!SMarkJSJsonObject methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:15'!
size
	^ names size! !

!SMarkJSJsonObject methodsFor: 'hash' stamp: 'StefanMarr 4/3/2015 11:17'!
updateHashIndex
    | size |
    size := names size.
    1 to: size do: [: i |
      table add: (names at: i) put: i
    ]! !

SMarkJSJsonValue subclass: #SMarkJSJsonString
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJsonString class methodsFor: 'instance creation' stamp: 'StefanMarr 4/2/2015 22:33'!
new: str
	^ self basicNew initializeWith: str! !

!SMarkJSJsonString methodsFor: 'comparing' stamp: 'StefanMarr 4/2/2015 22:35'!
= other
	self == other ifTrue: [ ^ true ].
	other == nil ifTrue: [ ^ false ].

	self class == other class ifFalse: [ ^ false ].

	^ string =  other asString! !

!SMarkJSJsonString methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:34'!
asString
	^ string! !

!SMarkJSJsonString methodsFor: 'hash' stamp: 'StefanMarr 4/2/2015 22:34'!
hashcode
	^ string hash! !

!SMarkJSJsonString methodsFor: 'initialization' stamp: 'StefanMarr 4/2/2015 22:34'!
initializeWith: str
	string := str! !

!SMarkJSJsonString methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:34'!
isString
	^ true! !

!SMarkJSJsonValue class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:36'!
boolean: aBoolean
	^ aBoolean
		ifTrue:  [ SMarkJSJsonLiteral TRUE ]
		ifFalse: [ SMarkJSJsonLiteral FALSE ]! !

!SMarkJSJsonValue class methodsFor: 'helper' stamp: 'StefanMarr 4/2/2015 22:32'!
cutOffPointZero: str
    (str endsWith: '.0') ifTrue: [ ^ str substringFrom: 1 to: str length - 2].
    ^ str! !

!SMarkJSJsonValue class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:36'!
double: aDouble
	aDouble ifNil: [ self error: 'aDouble nil' ].
	^ SMarkJSJsonNumber new: (self cutOffPointZero: aDouble asString)! !

!SMarkJSJsonValue class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:36'!
integer: anInteger
	^ SMarkJSJsonNumber new: anInteger asString! !

!SMarkJSJsonValue class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:35'!
readFrom: str 
	^ (SMarkJSJsonParser with: str) parse! !

!SMarkJSJsonValue class methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:37'!
string: aString
	^ aString == nil
		ifTrue:  [ SMarkJSJsonLiteral NULL ]
		ifFalse: [ SMarkJSJsonString new: aString ]! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:26'!
asArray
	self error: 'Unsupported operation, not an array ' + self asString! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:27'!
asBoolean
	self error: 'Unsupported operation, not a boolean ' + self asString! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:26'!
asDouble
	self error: 'Unsupported operation, not a double ' + self asString! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:26'!
asInteger
	self error: 'Unsupported operation, not an integer ' + self asString! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:26'!
asObject
	self error: 'Unsupported operation, not an object: ' + self asString! !

!SMarkJSJsonValue methodsFor: 'converting' stamp: 'StefanMarr 4/2/2015 22:27'!
asString
	self error: 'Unsupported operation, not a string ' + self asString! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:25'!
isArray
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:26'!
isBoolean
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:26'!
isFalse
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:26'!
isNull
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:25'!
isNumber
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:25'!
isObject
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:25'!
isString
	^ false! !

!SMarkJSJsonValue methodsFor: 'testing' stamp: 'StefanMarr 4/2/2015 22:26'!
isTrue
	^ false! !

!SMarkJSJsonValue methodsFor: 'writing' stamp: 'StefanMarr 4/2/2015 22:27'!
writeOn: writer
	^ self subclassResponsibility! !

!SMarkJSJsonValue methodsFor: 'writing' stamp: 'StefanMarr 4/2/2015 22:27'!
writeTo: writer
	self writeTo: writer with: nil! !

Object subclass: #SMarkJSParseException
	instanceVariableNames: 'msg offset line column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSParseException methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 11:41'!
asString ^ msg, ':', line, ':', column! !

!SMarkJSParseException methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:41'!
column ^ column! !

!SMarkJSParseException methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 11:40'!
initializeWith: message at: anOffset line: aLine column: aColumn
    msg    := message.
    offset := anOffset.
    line   := aLine.
    column := aColumn.! !

!SMarkJSParseException methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:41'!
line ^ line! !

!SMarkJSParseException methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:40'!
message ^ msg! !

!SMarkJSParseException methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 11:40'!
offset ^ offset! !

Object subclass: #SMarkLoopsDNUObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkLoopsDNUObject methodsFor: 'error handling' stamp: 'tfel 4/26/2016 11:48'!
doesNotUnderstand: aMessage

	^ aMessage selector! !

Object subclass: #SMarkLoopsMethodObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkLoopsMethodObject methodsFor: 'accessing' stamp: 'tfel 4/26/2016 11:59'!
flushCache
! !

!SMarkLoopsMethodObject methodsFor: 'message handling' stamp: 'tfel 4/26/2016 11:51'!
run: oldSelector with: arguments in: aReceiver

	^ aReceiver asOop asString, oldSelector, arguments! !

Object subclass: #SMarkLoopsMethodObjectReceiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

Object subclass: #SMarkMandelbrotRenderBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkMandelbrotRenderBenchmark class methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 14:49'!
calculateAt: aComplex value: anotherComplex iteration: aNumber maxIterations: anotherNumber
	(aNumber >= anotherNumber) ifTrue: [^anotherNumber].
	anotherComplex square.
	anotherComplex add: aComplex.
	(anotherComplex absSq >= 4)
		ifTrue: [^ aNumber]
		ifFalse: [^ self
				calculateAt: aComplex
				value: anotherComplex
				iteration: aNumber + 1
				maxIterations: anotherNumber]! !

!SMarkMandelbrotRenderBenchmark class methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:34'!
calculateAtIterative: aComplex maxIterations: maxIterations
	| current |
	current := SMarkInplaceComplex zero.
	0 to: maxIterations do: [:iteration|
		current square.
		current add: aComplex.
		(current absSq >= 4) ifTrue:[
			^iteration.	
		].
	].
	^maxIterations.! !

!SMarkMandelbrotRenderBenchmark class methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:34'!
calculateAtRecursive: aComplex maxIterations: aNumber
	^self calculateAt: aComplex value: SMarkInplaceComplex zero iteration: 0 maxIterations: aNumber.! !

Object subclass: #SMarkMeetingPlace
	instanceVariableNames: 'mutex first total max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkMeetingPlace class methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 16:59'!
forMeetings: maxMeetings
	^super new
		initialize;
		max: maxMeetings;
		yourself! !

!SMarkMeetingPlace methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 16:59'!
initialize
	mutex := Semaphore forMutualExclusion.
	total := 0! !

!SMarkMeetingPlace methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 16:59'!
max: maxMeetings
	max := maxMeetings! !

!SMarkMeetingPlace methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 16:59'!
organizeMeetingWith: second
	total >= max
		ifTrue: [
			first fade.
			second fade]
		ifFalse: [
			first met: second color.
			second met: first color ].
	total := total + 1! !

!SMarkMeetingPlace methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 16:59'!
reachedBy: chameleon
	mutex critical: [
        first isNil
            ifTrue: [ first := chameleon ]
            ifFalse: [ self organizeMeetingWith: chameleon. first := nil ] ]! !

Object subclass: #SMarkNBBody
	instanceVariableNames: 'x y z vx vy vz mass'
	classVariableNames: 'SolarMass'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-NBody'!

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:18'!
DaysPerYear
	^ 365.24! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:18'!
Pi
	^ 3.141592653589793! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'tfel 5/11/2015 15:47'!
SolarMass
	^ SolarMass! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'tfel 5/11/2015 15:47'!
initialize
	"self initialize"
	SolarMass := 4 * self Pi * self Pi.
	! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:19'!
jupiter
		| b |
       b := super new.
       b x:    4.8414314424647209.
       b y:   -1.16032004402742839.
       b z:   -0.103622044471123109.
       b vx:   0.00166007664274403694   * self DaysPerYear.
       b vy:   0.00769901118419740425   * self DaysPerYear.
       b vz:  -0.0000690460016972063023 * self DaysPerYear.
       b mass: 0.000954791938424326609  * self SolarMass.
       ^ b! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:20'!
neptune
		| b |
       b := super new.
       b x:   15.3796971148509165.
       b y:  -25.9193146099879641.
       b z:    0.179258772950371181.
       b vx:   0.00268067772490389322   * self DaysPerYear.
       b vy:   0.00162824170038242295   * self DaysPerYear.
       b vz:  -0.000095159225451971587  * self DaysPerYear.
       b mass: 0.0000515138902046611451 * self SolarMass.
       ^ b! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:19'!
new
	| b |
        b := super new.
        b x: 0.0.  b vx: 0.0.
        b y: 0.0.  b vy: 0.0.
        b z: 0.0.  b vz: 0.0.
        b mass: 0.0.
        ^ b! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:19'!
saturn 
		| b |
       b := super new.
       b x:    8.34336671824457987.
       b y:    4.12479856412430479.
       b z:   -0.403523417114321381.
       b vx:  -0.00276742510726862411   * self DaysPerYear.
       b vy:   0.00499852801234917238   * self DaysPerYear.
       b vz:   0.0000230417297573763929 * self DaysPerYear.
       b mass: 0.000285885980666130812  * self SolarMass.
       ^ b! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:20'!
sun 
		| b |
       b := self new.
       b mass: self SolarMass.
       ^ b! !

!SMarkNBBody class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:19'!
uranus
		| b |
       b := super new.
       b x:   12.894369562139131.
       b y:  -15.1111514016986312.
       b z:   -0.223307578892655734.
       b vx:   0.00296460137564761618   * self DaysPerYear.
       b vy:   0.0023784717395948095    * self DaysPerYear.
       b vz:  -0.0000296589568540237556 * self DaysPerYear.
       b mass: 0.0000436624404335156298 * self SolarMass.
       ^ b! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
mass ^ mass! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:17'!
mass: val
	mass := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 11:29'!
offsetMomentumX: px y: py z: pz
       vx := 0.0 - (px / SMarkNBBody SolarMass).
       vy := 0.0 - (py / SMarkNBBody SolarMass).
       vz := 0.0 - (pz / SMarkNBBody SolarMass).! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:15'!
vx ^ vx! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
vx: val
	vx := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
vy ^ vy! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
vy: val
	vy := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
vz ^ vz! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:17'!
vz: val
	vz := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:15'!
x ^ x! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
x: val
	x := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:15'!
y ^ y! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
y: val
	y := val! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:15'!
z ^ z! !

!SMarkNBBody methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:16'!
z: val
	z := val! !

Object subclass: #SMarkNBodySystem
	instanceVariableNames: 'bodies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-NBody'!

!SMarkNBodySystem methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:21'!
advance: dt
        1 to: bodies size do: [:i |
            | iBody |
            iBody := bodies at: i.

            i + 1 to: bodies size do: [:j |
                | dx dy dz jBody dSquared distance mag |
                jBody := bodies at: j.
                dx := iBody x - jBody x.
                dy := iBody y - jBody y.
                dz := iBody z - jBody z.

                dSquared := (dx * dx) + (dy * dy) + (dz * dz).
                distance := dSquared sqrt.
                mag      := dt / (dSquared * distance).

                iBody vx: iBody vx - (dx * jBody mass * mag).
                iBody vy: iBody vy - (dy * jBody mass * mag).
                iBody vz: iBody vz - (dz * jBody mass * mag).

                jBody vx: jBody vx + (dx * iBody mass * mag).
                jBody vy: jBody vy + (dy * iBody mass * mag).
                jBody vz: jBody vz + (dz * iBody mass * mag).
            ].
       ].
       
       bodies do: [:body |
           body x: body x + (dt * body vx).
           body y: body y + (dt * body vy).
           body z: body z + (dt * body vz).
       ].! !

!SMarkNBodySystem methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 17:21'!
energy
        | dx dy dz distance e |
        e := 0.0.

        1 to: bodies size do: [:i |
            | iBody |
            iBody := bodies at: i.
            
            e := e + (0.5 * iBody mass *
                 ((iBody vx * iBody vx) +
                  (iBody vy * iBody vy) +
                  (iBody vz * iBody vz))).
            
            i + 1 to: bodies size do: [:j |
                | jBody |
                jBody := bodies at: j.
                
                dx := iBody x - jBody x.
                dy := iBody y - jBody y.
                dz := iBody z - jBody z.

                distance := ((dx*dx) + (dy*dy) + (dz*dz)) sqrt.
                e := e - ((iBody mass * jBody mass) / distance).
            ].
       ].
       ^ e! !

!SMarkNBodySystem methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 11:29'!
initialize
        | px py pz |

        bodies := Array new: 5.
        bodies at: 1 put: SMarkNBBody sun.
        bodies at: 2 put: SMarkNBBody jupiter.
        bodies at: 3 put: SMarkNBBody saturn.
        bodies at: 4 put: SMarkNBBody uranus.
        bodies at: 5 put: SMarkNBBody neptune.
        
        "bodies do: [:b | b print. '' println ]."

        px := 0.0.  py := 0.0.  pz := 0.0.

        bodies do: [:b |
            px := px + (b vx * b mass).
            py := py + (b vy * b mass).
            pz := pz + (b vz * b mass).
        ].
        
        (bodies at: 1) offsetMomentumX: px y: py z: pz.
        
        "bodies do: [:b | b print. '' println ]."! !

Object subclass: #SMarkPlanner
	instanceVariableNames: 'currentMark'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

SMarkPlanner class
	instanceVariableNames: 'currentPlanner'!

!SMarkPlanner commentStamp: '<historical>' prior: 0!
This benchmark is an implementation of the DeltaBlue Constraint Solver described in `The DeltaBlue Algorithm: An Incremental Constraint Hierarchy Solver'', by Bjorn N. Freeman-Benson and John Maloney, Communications of the ACM, January 1990 (also as University of Washington TR 89-08-06).
!

SMarkPlanner class
	instanceVariableNames: 'currentPlanner'!

!SMarkPlanner class methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:10'!
chainTest: n
        "Do chain-of-equality-constraints performance tests."
        | vars editConstraint plan planner |
        planner := SMarkPlanner new.
        vars := Array new: n+1.
        1 to: n+1 do: [:i | vars at: i put: SMarkVariable new ].

        "thread a chain of equality constraints through the variables"
        1 to: n do:
            [ :i | | v1 v2 |
             v1 := vars at: i.
             v2 := vars at: i + 1.
             SMarkEqualityConstraint var: v1 var: v2 strength: #required].

        SMarkStayConstraint var: vars last strength: #strongDefault.
        editConstraint := SMarkEditConstraint var: (vars first) strength: #preferred.
        plan := planner extractPlanFromConstraints: (Array with: editConstraint).
        1 to: 100 do: [ :v | 
            vars first value: v.
            plan execute.
            vars last value ~= v ifTrue: [self error: 'Chain test failed!!!!']].
        editConstraint destroyConstraint
  ! !

!SMarkPlanner class methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 11:16'!
current
	^ currentPlanner! !

!SMarkPlanner class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:39'!
new
	^ currentPlanner := super new! !

!SMarkPlanner class methodsFor: 'accessing' stamp: 'tfel 5/15/2015 11:10'!
projectionTest: n
        "This test constructs a two sets of variables related to each other by
         a simple linear transformation (scale and offset)."

        | scale offset src dst planner dests |
        planner := SMarkPlanner new.
        dests := OrderedCollection new.
        scale := SMarkVariable value: 10.
        offset := SMarkVariable value: 1000.
        1 to: n do:
            [ :i |
            src := SMarkVariable value: i.
            dst := SMarkVariable value: i.
            dests add: dst.
            SMarkStayConstraint var: src strength: #default.
            SMarkScaleConstraint var: src var: scale var: offset var: dst strength: #required].

        planner changeVar: src newValue: 17.
        dst value ~= 1170 ifTrue: [self error: 'Projection test 1 failed!!!!'].

        planner changeVar: dst newValue: 1050.
        src value ~= 5 ifTrue: [self error: 'Projection test 2 failed!!!!'].

        planner changeVar: scale newValue: 5.
        1 to: n - 1 do: [ :i |
            (dests at: i) value ~= (i*5 + 1000)
                ifTrue: [self error: 'Projection test 3 failed!!!!']].

        planner changeVar: offset newValue: 2000.
        1 to: n - 1 do: [ :i |
            (dests at: i) value ~= (i*5 + 2000)
                ifTrue: [self error: 'Projection test 4 failed!!!!']]! !

!SMarkPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:36'!
addConstraintsConsuming: v to: aCollection

	| determiningC |
	determiningC := v determinedBy.
	v constraints do:
		[ :c |
		 (c == determiningC or: [c isSatisfied not]) ifFalse:
			[aCollection add: c]].! !

!SMarkPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:36'!
addPropagate: c mark: mark
	"Recompute the walkabout strengths and stay flags of all variables
	 downstream of the given constraint and recompute the actual values
	 of all variables whose stay flag is true. If a cycle is detected,
	 remove the given constraint and answer false. Otherwise, answer true.

	 Details: Cycles are detected when a marked variable is encountered
	 downstream of the given constraint. The sender is assumed to have
	 marked the inputs of the given constraint with the given mark. Thus,
	 encountering a marked node downstream of the output constraint means
	 that there is a path from the constraint's output to one of its
	 inputs."

	| todo d |
	todo := OrderedCollection with: c.
	[todo isEmpty] whileFalse:
		[d := todo removeFirst.
		 (d output mark = mark) ifTrue:
			[self incrementalRemove: c.
			 ^ false].
		 d recalculate.
		 self addConstraintsConsuming: d output to: todo].
	^ true! !

!SMarkPlanner methodsFor: 'private' stamp: 'tfel 5/15/2015 11:10'!
changeVar: aVariable newValue: newValue

	| editConstraint plan |
	editConstraint := SMarkEditConstraint var: aVariable strength: #preferred.
	plan := self extractPlanFromConstraints: (Array with: editConstraint).
	10 timesRepeat: [
		aVariable value: newValue.
		plan execute].
	editConstraint destroyConstraint.! !

!SMarkPlanner methodsFor: 'private' stamp: 'StefanMarr 4/2/2015 16:03'!
constraintsConsuming: v do: aBlock

	| determiningC |
	determiningC := v determinedBy.
	v constraints do:
		[ :c |
		 ((c == determiningC) or: [c isSatisfied not]) ifFalse:
			[aBlock value: c]].! !

!SMarkPlanner methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 15:59'!
extractPlanFromConstraints: constraints
	"Extract a plan for resatisfaction starting from the outputs of the
	 given constraints, usually a set of input constraints."

	| sources |
	sources := OrderedCollection new.
	constraints do:
		[: c | ((c isInput) and: [c isSatisfied]) ifTrue: [sources add: c]].
	^self makePlan: sources! !

!SMarkPlanner methodsFor: 'planning' stamp: 'StefanMarr 4/2/2015 16:00'!
extractPlanFromVariables: variables
	"Extract a plan from the dataflow graph having the given variables. It
	 is assumed that the given set of variables is complete, or at least
	 that it contains all the input variables."

	| sources |
	sources := OrderedCollection new.
	variables do:
		[: v |
		 (v constraints) do:
			[: c | ((c isInput) and: [c isSatisfied]) ifTrue: [sources add: c]]].
	^self makePlan: sources! !

!SMarkPlanner methodsFor: 'adding' stamp: 'StefanMarr 4/2/2015 15:58'!
incrementalAdd: c
	"Attempt to satisfy the given constraint and, if successful,
	 incrementally update the dataflow graph.

	 Details: If satifying the constraint is successful, it may override a
	 weaker constraint on its output. The algorithm attempts to resatisfy
	 that constraint using some other method. This process is repeated
	 until either a) it reaches a variable that was not previously
	 determined by any constraint or b) it reaches a constraint that
	 is too weak to be satisfied using any of its methods. The variables
	 of constraints that have been processed are marked with a unique mark
	 value so that we know where we've been. This allows the algorithm to
	 avoid getting into an infinite loop even if the constraint graph has
	 an inadvertent cycle."

	| mark overridden |
	mark := self newMark.
	overridden := c satisfy: mark.
	[overridden == nil] whileFalse:
		[overridden := overridden satisfy: mark].! !

!SMarkPlanner methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:34'!
incrementalRemove: c
	"Entry point for retracting a constraint. Remove the given constraint,
	 which should be satisfied, and incrementally update the dataflow
	 graph.

	 Details: Retracting the given constraint may allow some currently
	 unsatisfiable downstream constraint be satisfied. We thus collect a
	 list of unsatisfied downstream constraints and attempt to satisfy
	 each one in turn. This list is sorted by constraint strength,
	 strongest first, as a heuristic for avoiding unnecessarily adding
	 and then overriding weak constraints."

	| out unsatisfied |
	out := c output.
	c markUnsatisfied.
	c removeFromGraph.
	unsatisfied := self removePropagateFrom: out.
	unsatisfied do: [: u | self incrementalAdd: u].! !

!SMarkPlanner methodsFor: 'initialize' stamp: 'StefanMarr 4/2/2015 15:57'!
initialize

	"super initialize."

	currentMark := 1.! !

!SMarkPlanner methodsFor: 'planning' stamp: 'tfel 5/15/2015 11:08'!
makePlan: sources
	"Extract a plan for resatisfaction starting from the given satisfied
	 source constraints, usually a set of input constraints. This method
	 assumes that stay optimization is desired; the plan will contain only
	 constraints whose output variables are not stay. Constraints that do
	 no computation, such as stay and edit constraints, are not included
	 in the plan.

	 Details: The outputs of a constraint are marked when it is added to
	 the plan under construction. A constraint may be appended to the plan
	 when all its input variables are known. A variable is known if either
	 a) the variable is marked (indicating that has been computed by a
	 constraint appearing earlier in the plan), b) the variable is 'stay'
	 (i.e. it is a constant at plan execution time), or c) the variable
	 is not determined by any constraint. The last provision is for past
	 states of history variables, which are not stay but which are also
	 not computed by any constraint."

	| mark plan todo c |
	mark := self newMark.
	plan := SMarkPlan new.
	todo := sources.
	[todo isEmpty] whileFalse:
		[c := todo removeFirst.
		 ((c output mark ~= mark) and:		"not in plan already and..."
		  [c inputsKnown: mark]) ifTrue:	"eligible for inclusion"
			[plan addLast: c.
			 c output mark: mark.
			 self addConstraintsConsuming: c output to: todo]].
	^ plan! !

!SMarkPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:37'!
newMark
	"Select a previously unused mark value.

	 Details: We just keep incrementing. If necessary, the counter will
	 turn into a LargePositiveInteger. In that case, it will be a bit
	 slower to compute the next mark but the algorithms will all behave
	 correctly. We reserve the value '0' to mean 'unmarked'. Thus, this
	 generator starts at '1' and will never produce '0' as a mark value."

	^currentMark := currentMark + 1! !

!SMarkPlanner methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:36'!
propagateFrom: v
	"The given variable has changed. Propagate new values downstream."

	| todo c |
	todo := OrderedCollection new.
	self addConstraintsConsuming: v to: todo.
	[todo isEmpty] whileFalse:
		[c := todo removeFirst.
		 c execute.
		 self addConstraintsConsuming: c output to: todo].! !

!SMarkPlanner methodsFor: 'private' stamp: 'tfel 3/21/2016 16:59'!
removePropagateFrom: out
	"Update the walkabout strengths and stay flags of all variables
	 downstream of the given constraint. Answer a collection of unsatisfied
	 constraints sorted in order of decreasing strength."

	| unsatisfied todo v |
	unsatisfied := OrderedCollection new.
	
	out determinedBy: nil.
	out walkStrength: SMarkStrength absoluteWeakest.
	out stay: true.
	todo := OrderedCollection with: out.
	[todo isEmpty] whileFalse:
		[v := todo removeFirst.
		 v constraints do:
		 	[ :c | (c isSatisfied) ifFalse: [unsatisfied add: c]].
		 self constraintsConsuming: v do:
			[ :c |
			 c recalculate.
			 todo add: c output]].
	
	unsatisfied sort: [ :c1 :c2 | c1 strength stronger: c2 strength].
	^ unsatisfied! !

Object subclass: #SMarkRichObject
	instanceVariableNames: ''
	classVariableNames: 'DeviceA DeviceB DevicePacketKind HandlerA HandlerB Idler NoTask NoWork WorkPacketKind Worker'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichObject commentStamp: '<historical>' prior: 0!
This class mostly adds some constants that are used in the Richards benchmarks.!

SMarkRichObject subclass: #SMarkRichDeviceTaskDataRecord
	instanceVariableNames: 'pending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichDeviceTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that suspends itself after each time it has been run to simulate waiting for data from an external device.
!

!SMarkRichDeviceTaskDataRecord class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 13:40'!
create
	^ super basicNew create! !

!SMarkRichDeviceTaskDataRecord methodsFor: 'initialization' stamp: 'tfel 5/15/2015 11:30'!
create
	pending := SMarkRichObject NoWork! !

!SMarkRichDeviceTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
pending
	^ pending! !

!SMarkRichDeviceTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:39'!
pending: packet
	pending := packet! !

SMarkRichObject subclass: #SMarkRichHandlerTaskDataRecord
	instanceVariableNames: 'workIn deviceIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichHandlerTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that manipulates work packets and then suspends itself.!

!SMarkRichHandlerTaskDataRecord class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 15:03'!
create
	^ super basicNew create! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'converting' stamp: 'StefanMarr 4/3/2015 13:42'!
asString
	^ 'HandlerTaskDataRecord(', workIn asString, ', ', deviceIn asString, ')'! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:30'!
create
	workIn := deviceIn := SMarkRichObject NoWork! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
deviceIn
	^ deviceIn! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:41'!
deviceIn: aPacket
	deviceIn := aPacket! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
deviceInAdd: packet
    deviceIn := self append: packet head: deviceIn! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
workIn
	^ workIn! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:41'!
workIn: aWorkQueue
	workIn := aWorkQueue! !

!SMarkRichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
workInAdd: packet
    workIn := self append: packet head: workIn! !

SMarkRichObject subclass: #SMarkRichIdleTaskDataRecord
	instanceVariableNames: 'control count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichIdleTaskDataRecord commentStamp: '<historical>' prior: 0!
An idle task doesn't do any work itself but cycles control between the two device tasks.!

!SMarkRichIdleTaskDataRecord class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 13:43'!
create
	^ super basicNew create! !

!SMarkRichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
control
	^ control! !

!SMarkRichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:43'!
control: aNumber
	control := aNumber! !

!SMarkRichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
count
	^ count! !

!SMarkRichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:43'!
count: aCount
	count := aCount! !

!SMarkRichIdleTaskDataRecord methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 15:04'!
create
    control := 1.
    count := 10000! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
DeviceA
	^ DeviceA! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
DeviceB
	^ DeviceB! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
DevicePacketKind
	^ DevicePacketKind! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
HandlerA
	^ HandlerA! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
HandlerB
	^ HandlerB! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:37'!
Idler
	^ Idler! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:37'!
NoTask
	^ NoTask! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:37'!
NoWork
	^ NoWork! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
WorkPacketKind
	^ WorkPacketKind! !

!SMarkRichObject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 13:38'!
Worker
	^ Worker! !

!SMarkRichObject class methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 13:37'!
initialize
    	DeviceA := 5.
    	DeviceB := 6.
    	DevicePacketKind := 1.
    	HandlerA := 3.
    	HandlerB := 4.
    	Idler := 1.
	   NoWork := nil.
	   NoTask := nil.
    	Worker := 2.
    	WorkPacketKind := 2! !

!SMarkRichObject methodsFor: 'utilities' stamp: 'tfel 5/15/2015 11:32'!
append: packet head: queueHead
    | mouse link |
    packet link: SMarkRichObject NoWork.
    SMarkRichObject NoWork == queueHead ifTrue: [ ^ packet ].
    mouse := queueHead.
    [SMarkRichObject NoWork == (link := mouse link)]
        whileFalse: [ mouse := link ].
    mouse link: packet.
    ^ queueHead! !

SMarkRichObject subclass: #SMarkRichPacket
	instanceVariableNames: 'data datum identity kind link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichPacket commentStamp: '<historical>' prior: 0!
A simple package of data that is manipulated by the tasks.  The exact layout of the payload data carried by a packet is not importaint, and neither is the nature of the work performed on packets by the tasks. Besides carrying data, packets form linked lists and are hence used both as data and worklists.!

!SMarkRichPacket class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 13:44'!
create: link identity: identity kind: kind 
    ^ self basicNew
		link: link
		identity: identity
		kind: kind! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
data
	^ data! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
datum
	^ datum! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
datum: anObject
	datum := anObject! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
identity
	^ identity! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
identity: anObject
	identity := anObject! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
kind
	^ kind! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
link
	^ link! !

!SMarkRichPacket methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 13:45'!
link: aWorkQueue
	link := aWorkQueue! !

!SMarkRichPacket methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 15:20'!
link: aLink identity: anIdentity kind: aKind 
    link := aLink.
    identity := anIdentity. 
    kind := aKind.
    datum := 1.
    data := ByteArray new: 4! !

SMarkRichObject subclass: #SMarkRichTaskState
	instanceVariableNames: 'packetPending taskHolding taskWaiting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichTaskState commentStamp: '<historical>' prior: 0!
Abstract task that manipulates work packets.!

SMarkRichTaskState subclass: #SMarkRichTaskControlBlock
	instanceVariableNames: 'link identity priority input function handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichTaskControlBlock commentStamp: '<historical>' prior: 0!
A task control block manages a task and the queue of work packages associated with it.!

!SMarkRichTaskControlBlock class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:17'!
link: link create: identity priority: priority initialWorkQueue: initialWorkQueue initialState: initialState function: aBlock privateData: privateData 
    ^ self new
		link: link
		identity: identity
		priority: priority
		initialWorkQueue: initialWorkQueue
		initialState: initialState
		function: aBlock
		privateData: privateData! !

!SMarkRichTaskControlBlock methodsFor: 'scheduling' stamp: 'tfel 5/15/2015 11:32'!
addInput: packet checkPriority: oldTask
    SMarkRichObject NoWork == input
	ifTrue: 
	    [input := packet.
	    self packetPending: true.
	    priority > oldTask priority ifTrue: [ ^ self ]]
	ifFalse: 
	    [ input := self append: packet head: input ].
    ^ oldTask! !

!SMarkRichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
identity
	^ identity! !

!SMarkRichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
link
	^ link! !

!SMarkRichTaskControlBlock methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 15:16'!
link: aLink identity: anIdentity priority: aPriority initialWorkQueue: anInitialWorkQueue initialState: anInitialState function: aBlock privateData: aPrivateData 
    link := aLink.
    identity := anIdentity.
    priority := aPriority.
    input := anInitialWorkQueue.
    self packetPending: anInitialState isPacketPending.
    self taskWaiting: anInitialState isTaskWaiting.
    self taskHolding: anInitialState isTaskHolding.
    function := aBlock.
    handle := aPrivateData! !

!SMarkRichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
priority
	^ priority! !

!SMarkRichTaskControlBlock methodsFor: 'scheduling' stamp: 'tfel 5/15/2015 11:32'!
runTask
    | message |
    self isWaitingWithPacket
	ifTrue: 
	    [message := input.
	    input := message link.
	    SMarkRichObject NoWork == input 
		ifTrue: [self running]
		ifFalse: [self packetPending]]
	ifFalse: [message := SMarkRichObject NoWork].
    ^ function value: message value: handle! !

!SMarkRichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
packetPending
    ^super new packetPending! !

!SMarkRichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
running
    ^super new running! !

!SMarkRichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
waiting
    ^super new waiting! !

!SMarkRichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
waitingWithPacket
    ^super new waitingWithPacket! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 14:36'!
isPacketPending
    ^packetPending! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 14:38'!
isRunning
    ^ packetPending not and: [taskWaiting not and: [taskHolding not]]! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:06'!
isTaskHolding
    ^taskHolding! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 14:38'!
isTaskHoldingOrWaiting
    ^taskHolding or: [packetPending not and: [taskWaiting]]! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:06'!
isTaskWaiting
    ^taskWaiting! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 14:39'!
isWaiting
    ^packetPending not and: [taskWaiting and: [taskHolding not]]! !

!SMarkRichTaskState methodsFor: 'testing' stamp: 'StefanMarr 4/3/2015 14:39'!
isWaitingWithPacket
    ^packetPending and: [taskWaiting and: [taskHolding not]]! !

!SMarkRichTaskState methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 14:37'!
packetPending
    packetPending := true.
    taskWaiting := false.
    taskHolding := false! !

!SMarkRichTaskState methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 14:37'!
packetPending: aBoolean
	packetPending := aBoolean! !

!SMarkRichTaskState methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 14:38'!
running
    packetPending := taskWaiting := taskHolding := false! !

!SMarkRichTaskState methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 14:37'!
taskHolding: aBoolean
	^ taskHolding := aBoolean! !

!SMarkRichTaskState methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 14:37'!
taskWaiting: aBoolean
	^ taskWaiting := aBoolean! !

!SMarkRichTaskState methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 14:38'!
waiting
    packetPending := taskHolding := false.
    taskWaiting := true! !

!SMarkRichTaskState methodsFor: 'initialize' stamp: 'StefanMarr 4/3/2015 14:38'!
waitingWithPacket
    taskHolding := false.
    taskWaiting := packetPending := true! !

SMarkRichObject subclass: #SMarkRichWorkerTaskDataRecord
	instanceVariableNames: 'destination count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichWorkerTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that manipulates work packets.!

!SMarkRichWorkerTaskDataRecord class methodsFor: 'instance creation' stamp: 'StefanMarr 4/3/2015 14:40'!
create
	^ super basicNew create! !

!SMarkRichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
count
	^ count! !

!SMarkRichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 15:16'!
count: anInteger
	count := anInteger! !

!SMarkRichWorkerTaskDataRecord methodsFor: 'instance creation' stamp: 'tfel 5/15/2015 11:32'!
create
    destination := SMarkRichObject HandlerA.
    count := 0! !

!SMarkRichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
destination
	^ destination! !

!SMarkRichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
destination: anObject
	destination := anObject! !

Object subclass: #SMarkRichRunner
	instanceVariableNames: 'taskList currentTask currentTaskIdentity taskTable tracing layout queuePacketCount holdCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichRunner commentStamp: '<historical>' prior: 0!
Richards simulates the task dispatcher of an operating system.!

!SMarkRichRunner class methodsFor: 'starting' stamp: 'ClementBera 9/27/2013 15:58'!
start
    "RichardsBenchmark start"

    ^self new start! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:33'!
createDevice: identity priority: priority work: work state: state 
    | data |
    data := SMarkRichDeviceTaskDataRecord create.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 functionWork |
	    data1 := word.
	    functionWork := work1.
	    SMarkRichObject NoWork == functionWork 
		ifTrue:
		    [SMarkRichObject NoWork == (functionWork := data1 pending)
			ifTrue: [self wait]
			ifFalse: 
			    [data1 pending: SMarkRichObject NoWork.
			    self queuePacket: functionWork]]
		ifFalse: 
		    [data1 pending: functionWork.
			tracing ifTrue: [ self trace: functionWork datum ].
		    self holdSelf]]
	data: data! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:33'!
createHandler: identity priority: priority work: work state: state 
    | data |
    data := SMarkRichHandlerTaskDataRecord create.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 workPacket |
	    data1 := word.
	    SMarkRichObject NoWork == work1 
		ifFalse: [SMarkRichObject WorkPacketKind == work1 kind 
		    ifTrue: [data1 workInAdd: work1]
		    ifFalse: [data1 deviceInAdd: work1]].
	    SMarkRichObject NoWork == (workPacket := data1 workIn) 
		ifTrue: [self wait]
		ifFalse: 
		    [ | count |
			count := workPacket datum.
		    count > 4
			ifTrue: 
			    [data1 workIn: workPacket link.
			    self queuePacket: workPacket]
			ifFalse:
			    [ | devicePacket |
				SMarkRichObject NoWork == (devicePacket := data1 deviceIn) 
				ifTrue: [self wait]
				ifFalse: 
				    [data1 deviceIn: devicePacket link.
				    devicePacket datum: (workPacket data at: count).
				    workPacket datum: count + 1.
				    self queuePacket: devicePacket]]]]
	data: data! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:33'!
createIdler: identity priority: priority work: work state: state 
    | data |
    data := SMarkRichIdleTaskDataRecord create.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 |
	    data1 := word.
	    data1 count: data1 count - 1.
	    0 = data1 count
		ifTrue: [self holdSelf]
		ifFalse:
		    [0 = (data1 control bitAnd: 1)
			ifTrue: 
			    [data1 control: data1 control // 2.
			    self release: SMarkRichObject DeviceA]
			ifFalse: 
			    [data1 control: (data1 control // 2 bitXor: 53256).
			    self release: SMarkRichObject DeviceB]]]
	data: data! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:33'!
createPacket: link identity: identity kind: kind 
    ^ SMarkRichPacket
		create: link
		identity: identity
		kind: kind! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:34'!
createTask: identity priority: priority work: work state: state function: aBlock data: data 
    | t |
    t := SMarkRichTaskControlBlock
		link: taskList
		create: identity
		priority: priority
		initialWorkQueue: work
		initialState: state
		function: aBlock
		privateData: data.
    taskList := t.
    taskTable at: identity put: t! !

!SMarkRichRunner methodsFor: 'creation' stamp: 'tfel 5/15/2015 11:34'!
createWorker: identity priority: priority work: work state: state 
    | data |
    data := SMarkRichWorkerTaskDataRecord create.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 |
	    data1 := word.
	    SMarkRichObject NoWork == work1
		ifTrue: [self wait]
		ifFalse: 
		    [data1 destination: (SMarkRichObject HandlerA = data1 destination
			    ifTrue:  [SMarkRichObject HandlerB]
			    ifFalse: [SMarkRichObject HandlerA]).
		    work1 identity: data1 destination.
		    work1 datum: 1.
		    1 to: 4 do: [ :i | 
			data1 count: data1 count + 1.
			data1 count > 26 ifTrue: [data1 count: 1].
			work1 data at: i put: $A asInteger + data1 count - 1].
		    self queuePacket: work1]]
	data: data! !

!SMarkRichRunner methodsFor: 'private' stamp: 'tfel 5/15/2015 11:31'!
findTask: identity 
    | t |
    t := taskTable at: identity.
    SMarkRichObject NoTask == t ifTrue: [self error: 'findTask failed'].
    ^ t! !

!SMarkRichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:35'!
holdSelf
    holdCount := holdCount + 1.
    currentTask taskHolding: true.
    ^ currentTask link! !

!SMarkRichRunner methodsFor: 'private' stamp: 'tfel 5/15/2015 11:31'!
initScheduler
    queuePacketCount := 0.
    holdCount := 0.
    taskTable := Array new: 6 withAll: SMarkRichObject NoTask.
    taskList := SMarkRichObject NoTask.! !

!SMarkRichRunner methodsFor: 'private' stamp: 'StefanMarr 4/3/2015 14:08'!
initTrace
	tracing := false.
	layout := 0! !

!SMarkRichRunner methodsFor: 'private' stamp: 'tfel 5/15/2015 11:31'!
queuePacket: packet 
    | t |
    t := self findTask: packet identity.
    SMarkRichObject NoTask ==  t ifTrue: [ ^ SMarkRichObject NoTask ].
    queuePacketCount := queuePacketCount + 1.
    packet link: SMarkRichObject NoWork.
    packet identity: currentTaskIdentity.
    ^ t addInput: packet checkPriority: currentTask! !

!SMarkRichRunner methodsFor: 'private' stamp: 'tfel 5/15/2015 11:31'!
release: identity 
    | t |
    t := self findTask: identity.
    SMarkRichObject NoTask == t ifTrue: [ ^ SMarkRichObject NoTask ].
    t taskHolding: false.
    t priority > currentTask priority
		ifTrue: [ ^ t ]
		ifFalse: [ ^ currentTask ]! !

!SMarkRichRunner methodsFor: 'scheduling' stamp: 'tfel 5/15/2015 11:32'!
schedule
    currentTask := taskList. 
    [SMarkRichObject NoTask == currentTask]
		whileFalse: 
	    [currentTask isTaskHoldingOrWaiting
			ifTrue: [currentTask := currentTask link]
			ifFalse: 
		    [currentTaskIdentity := currentTask identity.
			 tracing ifTrue: [ self trace: currentTaskIdentity ].
		    currentTask := currentTask runTask]]! !

!SMarkRichRunner methodsFor: 'initialize' stamp: 'tfel 5/15/2015 11:33'!
start
    | workQ |
	 self initTrace.
    self initScheduler.
    self 	createIdler: SMarkRichObject Idler
			priority: 0
			work: SMarkRichObject NoWork
			state: SMarkRichTaskState running.
    workQ := self
		createPacket: SMarkRichObject NoWork
		identity: SMarkRichObject Worker
		kind: SMarkRichObject WorkPacketKind.
    workQ := self
		createPacket: workQ
		identity: SMarkRichObject Worker
		kind: SMarkRichObject WorkPacketKind.
    self
		createWorker: SMarkRichObject Worker
		priority: 1000
		work: workQ
		state: SMarkRichTaskState waitingWithPacket.
    workQ := self
		createPacket: SMarkRichObject NoWork
		identity: SMarkRichObject DeviceA
		kind: SMarkRichObject DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: SMarkRichObject DeviceA
		kind: SMarkRichObject DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: SMarkRichObject DeviceA
		kind: SMarkRichObject DevicePacketKind.
    self
		createHandler: SMarkRichObject HandlerA
		priority: 2000
		work: workQ
		state: SMarkRichTaskState waitingWithPacket.
    workQ := self
		createPacket: SMarkRichObject NoWork
		identity: SMarkRichObject DeviceB
		kind: SMarkRichObject DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: SMarkRichObject DeviceB
		kind: SMarkRichObject DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: SMarkRichObject DeviceB
		kind: SMarkRichObject DevicePacketKind.
    self
		createHandler: SMarkRichObject HandlerB
		priority: 3000
		work: workQ
		state: SMarkRichTaskState waitingWithPacket.
    self
		createDevice: SMarkRichObject DeviceA
		priority: 4000
		work: SMarkRichObject NoWork
		state: SMarkRichTaskState waiting.
    self
		createDevice: SMarkRichObject DeviceB
		priority: 5000
		work: SMarkRichObject NoWork
		state: SMarkRichTaskState waiting.
    
	 self schedule.
    ^ (queuePacketCount = 23246) & (holdCount = 9297)
! !

!SMarkRichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:40'!
wait 
    currentTask taskWaiting: true.
    ^ currentTask! !

Object subclass: #SMarkSplaytree
	instanceVariableNames: 'rootNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:41'!
exportKeys
	"Returns an array containing all the keys of tree's nodes"
	
	| result |
	
	result :=  OrderedCollection new.
	
	( self isEmpty ) ifFalse: [
		
		self rootNode traverse: [ :node | result add: node key.].
	].

	^ result.! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:41'!
find: aKey
	"Returns the node having the specified key or nil if the tree doesn't contain
	 a node with the specified key.
	
	aKey Key to find in the tree."

	( self isEmpty ) ifTrue: [
		^ nil.
	] ifFalse: [
		self splay: aKey.
		
		( self rootNode key == aKey ) ifTrue: [
			^ self rootNode.
		] ifFalse: [
			^ nil.
		]
	].! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:42'!
findGreatestLessThan: aKey
	"Returns the node having the maximum key value 
	 that is less than the specified key value."
	
	( self isEmpty ) ifTrue: [
		^ nil.
	] ifFalse: [
		"splay on the key to move the node with the given key or the last
		 node on the search path to the top of the tree."
		
		self splay: aKey.
		
		"now the result is either the root node or the greatest node in
		 the left subtree."
		
		( self rootNode key < aKey ) ifTrue: [
			^ self rootNode.
		] ifFalse: [
			self rootNode left ifNotNil: [
				^ self findMax: ( self rootNode left ).
			] ifNil: [
				^ nil.
			]
		]
	].! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:42'!
findMax
	^self findMax: self rootNode! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 16:49'!
findMax: optStartNode
	"Return the node having the maximum key value."
	
	( self isEmpty ) ifTrue: [
		^ nil.
	] ifFalse: [
		| current |
		current := optStartNode.
		
		[current] whileNotNil: [
			current := current right.
		].
		^ current
	].! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:41'!
initialize
	rootNode := nil.
	Transcript show: 'splay tree created'; cr.! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:25'!
insert: aKey value: aValue
	"Inserts a node into the tree with the specified key and value if the tree does not already contain
	 a node with the specified key. If the value is inserted, it becomes the root of the tree.
	
	aKey Key to insert into the tree.
	aValue Value to insert into the tree."
		
	( self isEmpty ) ifTrue: [
		 rootNode := SMarkSplaytreeNode newWithKey: aKey andValue: aValue.
	] ifFalse: [
		"Splay on the key to move the last node on the search path for the key to the root of the tree."
		| node |
		
		self splay: aKey.
		( self rootNode key = aKey) ifTrue: [
			^ self
		].
		
		node := SMarkSplaytreeNode new.
		node key: aKey.
		node value: aValue.
			
		( aKey > self rootNode key ) ifTrue: [
			node left: self rootNode.
			node right: self rootNode right.
			self rootNode right: nil.
		] ifFalse: [
			node right: self rootNode.
			node left: self rootNode left.
			self rootNode left: nil.
		].
	
		self rootNode: node.
	]! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:42'!
isEmpty
	"Says whether the tree is empty"
	^ (rootNode isNil).! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 16:36'!
remove: aKey
	"Removes a node with the specified key from the tree if the tree contains a node with this key.
	 The removed node is returned. If the key is not found, an exception is thrown.
	
	 aKey Key to find and remove from the tree.
	 Returns the removed node."
	
	| removed right |
	
	( self isEmpty ) ifTrue: [
		Error signal: 'Key not found.'.
	].

	self splay: aKey.
		
	(self rootNode key ~= aKey) ifTrue: [
		Error signal: 'Key not found.'.
	].
	
	removed := self rootNode.
		
	self rootNode left ifNil: [
		self rootNode: self rootNode right.
	] ifNotNil: [
		right := self rootNode right.
		self rootNode: self rootNode left.
			
		"Splay to make sure that the new root has an empty right child."
		self splay: aKey.
			
		"insert the original right child as the right child of the new root."
		self rootNode right: right.
	].

	^ removed! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:42'!
rootNode

	^ rootNode! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:42'!
rootNode: anObject

	rootNode := anObject! !

!SMarkSplaytree methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:25'!
splay: aKey
	"Perform the splay operation for the given key. Moves the node with
	the given key to the top of the tree.  If no node has the given
	key, the last node on the search path is moved to the top of the
	tree. This is the simplified top-down splaying algorithm from:
	'Self-adjusting Binary Search Trees by Sleator and Tarjan'
	
	aKey Key to splay the tree on"
	
	| dummy left right current looping|
	
	"init"
	dummy := SMarkSplaytreeNode new.	
	left := dummy.
	right := dummy.
	
	current := self rootNode.
	
	looping := true.
	[looping] whileTrue: [
			( aKey < (current key) ) ifTrue: [	
				( current left isNil ) ifTrue: [
					looping := false.
				] ifFalse: [
					( aKey < current left key) ifTrue: [
						"rotate right"
						| tmp |
						tmp := current left.
						current left: ( tmp right).
						tmp right: current.
						current := tmp.
					
						current left ifNil: [
							looping := false.
						].
					].
					looping ifTrue:[
						"link right"
						right left: current.
						right := current.
						current := current left.
					]
				].
			] ifFalse: [
				( aKey > current key ) ifTrue: [
					( current right isNil ) ifTrue: [
						looping := false.
					] ifFalse: [
				
						( aKey > current right key ) ifTrue: [
							"rotate left"
							| tmp |
							tmp := current right.
							current right: ( tmp left ).
							tmp left: current.
							current := tmp.
						
							current right ifNil: [
								looping := false.
							].
						].
					
						looping ifTrue: [
							"link left"
							left right: current.
							left := current.
							current := current right.
						]
					].
				] ifFalse: [
					looping := false.
				].
			].
	 ].

	"assemble"
	
	left right: ( current left ).
	right left: ( current right ).
	current left: ( dummy right ).
	current right: ( dummy left ).
	self rootNode: current.! !

Object subclass: #SMarkSplaytreeNode
	instanceVariableNames: 'key value left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkSplaytreeNode class methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:38'!
newWithKey: aKey andValue: aValue 
	^ self new key: aKey;
		 value: aValue;
		 yourself! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:36'!
initialize
	self left: nil.
	self right: nil.! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
key

	^ key! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
key: anObject

	key := anObject! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
left

	^ left! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
left: anObject

	left := anObject! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
right

	^ right! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
right: anObject

	right := anObject! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 16:29'!
traverse: aBlock

	"Performs an ordered traversal of the subtree starting at this SplaytreeNode
	 aBlock is a visitor function"
	
	| current |
	
	current := self.
	[current] whileNotNil: [
		| left |
		left := current left.
		
		left ifNotNil: [
			left traverse: aBlock.
		].
		aBlock value: current.
		current := current right.
	].! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
value

	^value! !

!SMarkSplaytreeNode methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:37'!
value: anObject

	value := anObject! !

Object subclass: #SMarkStrength
	instanceVariableNames: 'symbolicValue arithmeticValue'
	classVariableNames: 'AbsoluteStrongest AbsoluteWeakest Required StrengthConstants StrengthTable'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkStrength commentStamp: '<historical>' prior: 0!
Strengths are used to measure the relative importance of constraints. The hierarchy of available strengths is determined by the class variable StrengthTable (see my class initialization method). Because Strengths are invariant, references to Strength instances are shared (i.e. all references to
"Strength of: #required" point to a single, shared instance). New strengths may be inserted in the strength hierarchy without disrupting current constraints.

Instance variables:
	symbolicValue		symbolic strength name (e.g. #required) <Symbol>
	arithmeticValue		index of the constraint in the hierarchy, used for comparisons <Number>!

!SMarkStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
absoluteStrongest

	^AbsoluteStrongest! !

!SMarkStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
absoluteWeakest

	^AbsoluteWeakest! !

!SMarkStrength class methodsFor: 'initialize' stamp: 'tfel 6/2/2015 11:21'!
initialize
	"Initialize the symbolic strength table. Fix the internally caches
	 values of all existing instances."
	"Strength initialize"

	StrengthTable := Dictionary new.
	StrengthTable at: #absoluteStrongest put: -10000.
	StrengthTable at: #required put: -800.
	StrengthTable at: #strongPreferred put: -600.
	StrengthTable at: #preferred put: -400.
	StrengthTable at: #strongDefault put: -200.
	StrengthTable at: #default put: 0.
	StrengthTable at: #weakDefault put: 500.
	StrengthTable at: #absoluteWeakest put: 10000.

	StrengthConstants := Dictionary new.
	StrengthTable keys do:
		[: strengthSymbol |
			StrengthConstants
				at: strengthSymbol
				put: ((super new) initializeWith: strengthSymbol)].

	AbsoluteStrongest := self of: #absoluteStrongest.
	AbsoluteWeakest := self of: #absoluteWeakest.
	Required := self of: #required.! !

!SMarkStrength class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:52'!
of: aSymbol
	"Answer an instance with the specified strength."

	^ StrengthConstants at: aSymbol! !

!SMarkStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
required

	^Required! !

!SMarkStrength class methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 16:39'!
strengthTable
	^ StrengthTable! !

!SMarkStrength methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:50'!
arithmeticValue
	"Answer my arithmetic value. Used for comparisons. Note that
	 STRONGER constraints have SMALLER arithmetic values."

	^arithmeticValue! !

!SMarkStrength methodsFor: 'private' stamp: 'tfel 6/2/2015 11:20'!
initializeWith: symVal
	"Record my symbolic value and reset my arithmetic value."

	symbolicValue := symVal.
	arithmeticValue := self class strengthTable at: symbolicValue.! !

!SMarkStrength methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 10:50'!
printOn: aStream
	"Append a string which represents my strength onto aStream."

	aStream nextPutAll: '%', symbolicValue, '%'.! !

!SMarkStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
sameAs: aStrength
	"Answer true if I am the same strength as the given Strength."

	^ arithmeticValue = aStrength arithmeticValue! !

!SMarkStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
stronger: aStrength
	"Answer true if I am stronger than the given Strength."

	^ arithmeticValue < aStrength arithmeticValue! !

!SMarkStrength methodsFor: 'max / min' stamp: 'StefanMarr 4/2/2015 16:37'!
strongest: aStrength
	"Answer the stronger of myself and aStrength."

	(aStrength stronger: self)
		ifTrue: [^aStrength]
		ifFalse: [^self]! !

!SMarkStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
weaker: aStrength
	"Answer true if I am weaker than the given Strength."

	^ arithmeticValue > aStrength arithmeticValue! !

!SMarkStrength methodsFor: 'max / min' stamp: 'StefanMarr 4/2/2015 16:37'!
weakest: aStrength
	"Answer the weaker of myself and aStrength."

	(aStrength weaker: self)
		ifTrue: [^aStrength]
		ifFalse: [^self].! !

Object subclass: #SMarkTreeNode
	instanceVariableNames: 'left right item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkTreeNode class methodsFor: 'instance creation' stamp: 'MP 12/11/2013 21:54'!
bottomUpTree: anItem depth: anInteger
   ^(anInteger > 0) 
      ifTrue: [
         self 
            left: (self bottomUpTree: 2*anItem - 1 depth: anInteger - 1) 
            right: (self bottomUpTree: 2*anItem depth: anInteger - 1)  
            item: anItem
         ]
      ifFalse: [self left: nil right: nil item: anItem]! !

!SMarkTreeNode class methodsFor: 'instance creation' stamp: 'MP 12/11/2013 21:55'!
left: leftChild right: rightChild item: anItem      
   ^(super new) left: leftChild right: rightChild item: anItem! !

!SMarkTreeNode methodsFor: 'accessing' stamp: 'MP 12/11/2013 21:54'!
itemCheck
   ^left isNil 
      ifTrue: [item] ifFalse: [item + (left itemCheck - right itemCheck)]! !

!SMarkTreeNode methodsFor: 'initialize-release' stamp: 'MP 12/11/2013 21:52'!
left: leftChild right: rightChild item: anItem
   left := leftChild.
   right := rightChild.
   item := anItem! !

Object subclass: #SMarkVariable
	instanceVariableNames: 'constraints determinedBy mark stay value walkStrength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkVariable commentStamp: '<historical>' prior: 0!
I represent a constrained variable. In addition to my value, I maintain the structure of the constraint graph, the current dataflow graph, and various parameters of interest to the DeltaBlue incremental constraint solver.

Instance variables:
	value			my value; changed by constraints, read by client <Object>
	constraints		normal constraints that reference me <Array of Constraint>
	determinedBy	the constraint that currently determines
					my value (or nil if there isn''t one) <Constraint>
	walkStrength		my walkabout strength <Strength>
	stay			true if I am a planning-time constant <Boolean>
	mark			used by the planner to mark constraints <Number>!

!SMarkVariable class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 11:01'!
value: aValue

	^self new value: aValue! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
addConstraint: aConstraint
	"Add the given constraint to the set of all constraints that refer
	 to me."

	constraints add: aConstraint.! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
constraints
	^ constraints! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
determinedBy
	^ determinedBy! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
determinedBy: anObject
	determinedBy := anObject! !

!SMarkVariable methodsFor: 'initialize' stamp: 'tfel 5/15/2015 11:47'!
initialize
	value := 0.
	constraints := OrderedCollection new: 2.
	determinedBy := nil.
	walkStrength := SMarkStrength absoluteWeakest.
	stay := true.
	mark := 0.! !

!SMarkVariable methodsFor: 'printing' stamp: 'StefanMarr 4/2/2015 21:00'!
longPrintOn: aStream
	^ super longPrintOn: aStream
"	self shortPrintOn: aStream.
	aStream nextPutAll: '   Constraints: '.
	(constraints isEmpty)
		ifTrue: [aStream cr; tab; nextPutAll: 'none']
		ifFalse:
			[constraints do:
				[: c | aStream cr; tab. c shortPrintOn: aStream]].
	(determinedBy isNil) ifFalse:
		[aStream cr; nextPutAll: '   Determined by: '.
		 aStream cr; tab. determinedBy shortPrintOn: aStream].
	aStream cr."! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
mark
	^ mark! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
mark: anObject
	mark := anObject! !

!SMarkVariable methodsFor: 'printing' stamp: 'StefanMarr 4/2/2015 20:59'!
printOn: aStream
	^ super printOn: aStream
	"self shortPrintOn: aStream"! !

!SMarkVariable methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 16:44'!
removeConstraint: c
	"Remove all traces of c from this variable."

	constraints remove: c ifAbsent: [].
	(determinedBy == c) ifTrue: [determinedBy := nil].! !

!SMarkVariable methodsFor: 'update' stamp: 'ClementBera 9/23/2013 10:59'!
setValue: aValue
	"Attempt to assign the given value to me using a strength of
	 #preferred."

	self setValue: aValue strength: #preferred.! !

!SMarkVariable methodsFor: 'update' stamp: 'tfel 5/15/2015 11:10'!
setValue: aValue strength: strengthSymbol
	"Attempt to assign the given value to me using the given strength."

	| editConstraint |
	editConstraint := SMarkEditConstraint var: self strength: strengthSymbol.
	(editConstraint isSatisfied) ifTrue:
		[self value: aValue.
		 SMarkPlanner propagateFrom: self].
	editConstraint destroyConstraint.! !

!SMarkVariable methodsFor: 'printing' stamp: 'StefanMarr 4/2/2015 21:00'!
shortPrintOn: aStream
	^ super shortPrintOn: aStream.
"
	aStream nextPutAll: 'V(', self printString, ', '.
	aStream nextPutAll: walkStrength printString, ', '.
	(stay isNil) ifFalse:
		[aStream nextPutAll: (stay ifTrue: ['stay, '] ifFalse: ['changing, '])].
	aStream nextPutAll: value printString.
	aStream nextPutAll: ')'.
	aStream cr."! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
stay
	^ stay! !

!SMarkVariable methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 16:44'!
stay: aBoolean
	stay := aBoolean! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
value
	^ value! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
value: anObject
	value := anObject! !

!SMarkVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
walkStrength
	^ walkStrength! !

!SMarkVariable methodsFor: 'accessing' stamp: 'StefanMarr 4/2/2015 16:44'!
walkStrength: aStrength
	walkStrength := aStrength! !

Object subclass: #ShootoutBody
	instanceVariableNames: 'x y z vx vy vz mass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutBody class methodsFor: 'constants' stamp: ''!
daysPerYear
	^365.24! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
jupiter
	^self new
		x: 4.84143144246472090
		y: -1.16032004402742839
		z: -1.03622044471123109e-1
		vx: 1.66007664274403694e-3 * self daysPerYear
		vy: 7.69901118419740425e-3 * self daysPerYear
		vz: -6.90460016972063023e-5 * self daysPerYear
		mass: 9.54791938424326609e-4 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
neptune
	^self new
		x: 1.53796971148509165e1
		y: -2.59193146099879641e1
		z: 1.79258772950371181e-1
		vx: 2.68067772490389322e-3 * self daysPerYear
		vy: 1.62824170038242295e-3 * self daysPerYear
		vz: -9.51592254519715870e-5 * self daysPerYear
		mass: 5.15138902046611451e-5 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
pi
	^3.141592653589793! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
saturn
	^self new
		x: 8.34336671824457987
		y: 4.12479856412430479
		z: -4.03523417114321381e-1
		vx: -2.76742510726862411e-3 * self daysPerYear
		vy: 4.99852801234917238e-3 * self daysPerYear
		vz: 2.30417297573763929e-5 * self daysPerYear
		mass: 2.85885980666130812e-4 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: 'eem 7/28/2008 12:42'!
solarMass
	^4.0 * self pi * self pi! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
sun
	^self new
		x: 0.0
		y: 0.0
		z: 0.0
		vx: 0.0
		vy: 0.0
		vz: 0.0
		mass: self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
uranus
	^self new
		x: 1.28943695621391310e1
		y: -1.51111514016986312e1
		z: -2.23307578892655734e-1
		vx: 2.96460137564761618e-3 * self daysPerYear
		vy: 2.37847173959480950e-3 * self daysPerYear
		vz: -2.96589568540237556e-5 * self daysPerYear
		mass: 4.36624404335156298e-5 * self solarMass! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
addMomentumTo: anArray
	anArray at: 1 put: (anArray at: 1) + (vx * mass).
	anArray at: 2 put: (anArray at: 2) + (vy * mass).
	anArray at: 3 put: (anArray at: 3) + (vz * mass).
	^anArray! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
and: aBody velocityAfter: dt
	| dx dy dz distance mag |
	dx := x - aBody x.
	dy := y - aBody y.
	dz := z - aBody z.

	distance := ((dx*dx) + (dy*dy) + (dz*dz)) sqrt.
	mag := dt / (distance * distance * distance).

	self decreaseVelocity: dx y: dy z: dz m: aBody mass * mag.
	aBody increaseVelocity: dx y: dy z: dz m: mass * mag! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
decreaseVelocity: dx y: dy z: dz m: m
	vx := vx - (dx * m).
	vy := vy - (dy * m).
	vz := vz - (dz * m)! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
increaseVelocity: dx y: dy z: dz m: m
	vx := vx + (dx * m).
	vy := vy + (dy * m).
	vz := vz + (dz * m)! !

!ShootoutBody methodsFor: 'nbody' stamp: 'eem 7/28/2008 12:44'!
kineticEnergy
	^0.5 * mass * ((vx * vx) + (vy * vy) + (vz * vz))! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
mass
	^mass! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
offsetMomentum: anArray
	| m |
	m := self class solarMass.
	vx := (anArray at: 1) negated / m.
	vy := (anArray at: 2) negated / m.
	vz := (anArray at: 3) negated / m! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
positionAfter: dt
	x := x + (dt * vx).
	y := y + (dt * vy).
	z := z + (dt * vz)! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
potentialEnergy: aBody
	| dx dy dz distance |
	dx := x - aBody x.
	dy := y - aBody y.
	dz := z - aBody z.

	distance := ((dx*dx) + (dy*dy) + (dz*dz)) sqrt.
	^mass * aBody mass / distance! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
x
	^x! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
x: d1 y: d2 z: d3 vx: d4 vy: d5 vz: d6 mass: d7
	x := d1.
	y := d2.
	z := d3.
	vx := d4.
	vy := d5.
	vz := d6.
	mass := d7! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
y
	^y! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
z
	^z! !

Object subclass: #ShootoutChameneosColour
	instanceVariableNames: 'color'
	classVariableNames: 'Blue Red Yellow'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
blue
	^Blue! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
blue: anObject
	Blue := anObject! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createBlue
	"comment stating purpose of message"

	^super new color: #blue! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createRed
	"comment stating purpose of message"

	^super new color: #red! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createYellow
	"comment stating purpose of message"

	^super new color: #yellow! !

!ShootoutChameneosColour class methodsFor: 'printing' stamp: ''!
generateReportOfColoursOn: readOut
	| colours |
	colours := Array
				with: Blue
				with: Red
				with: Yellow.
	colours do:
			[:aColour |
			colours do:
					[:anotherColour |
					aColour printOn: readOut.
					readOut nextPutAll: ' + '.
					anotherColour printOn: readOut.
					readOut nextPutAll: ' -> '.
					(aColour complementaryColourFor: anotherColour) printOn: readOut.
					readOut nl]].
	^readOut! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
initialize
	"self initialize"

	Red := self createRed.
	Blue := self createBlue.
	Yellow := self createYellow! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
red
	^Red! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
red: anObject
	Red := anObject! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
yellow
	^Yellow! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
yellow: anObject
	Yellow := anObject! !

!ShootoutChameneosColour methodsFor: 'accessing' stamp: ''!
color
	^color! !

!ShootoutChameneosColour methodsFor: 'accessing' stamp: ''!
color: aColor
	color := aColor! !

!ShootoutChameneosColour methodsFor: 'as yet unclassified' stamp: ''!
complementaryColourFor: aChameneosColour
	"determine the complementary colour defined as..."

	self == aChameneosColour ifTrue: [^self].
	self isBlue
		ifTrue:
			[aChameneosColour isRed
				ifTrue: [^self class yellow]
				ifFalse: [^self class red]].
	self isRed
		ifTrue:
			[aChameneosColour isBlue
				ifTrue: [^self class yellow]
				ifFalse: [^self class blue]].
	aChameneosColour isBlue
		ifTrue: [^self class red]
		ifFalse: [^self class blue]! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
hasSameColorAs: aChameneos
	^self color == aChameneos color! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isBlue
	^self == self class blue! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isRed
	^self == self class red! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isYellow
	^self == self class yellow! !

!ShootoutChameneosColour methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self color! !

Object subclass: #ShootoutCreature
	instanceVariableNames: 'creatureName colour selfMet creaturesMet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutCreature class methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:15'!
withName: aName colour: aColour
	^(ShootoutCreature new initialize)
		name: aName;
		colour: aColour! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
colour
	^colour! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
colour: anObject
	colour := anObject! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
creaturesMet
	^creaturesMet! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
creaturesMet: anObject
	creaturesMet := anObject! !

!ShootoutCreature methodsFor: 'initialize-release' stamp: ''!
initialize
	selfMet := 0.
	creaturesMet := 0! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
name
	^creatureName! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
name: anObject
	creatureName := anObject! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
selfMet
	^selfMet! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
selfMet: anObject
	^selfMet := anObject! !

!ShootoutCreature methodsFor: 'controlling' stamp: ''!
visitMall: mall

	[| partner |
	partner := mall visitWith: self.
	partner ifNotNil:
			[colour := colour complementaryColourFor: partner colour.
			self == partner ifTrue: [selfMet := selfMet + 1].
			creaturesMet := creaturesMet + 1].
	partner isNil]
			whileFalse! !

Object subclass: #ShootoutMall
	instanceVariableNames: 'guard maxRendezvous open process queue cache pairCache'
	classVariableNames: 'Units'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
createAllowing: maxRendezvous
	"Private"

	^self basicNew initialize maxRendezvous: maxRendezvous! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:15'!
createCreaturesWith: aCollectionOfColours
	"Private"

	| aName |
	aName := 0.
	^aCollectionOfColours collect:
			[:aColour |
			aName := aName + 1.
			ShootoutCreature withName: aName colour: aColour]! !

!ShootoutMall class methodsFor: 'printing' stamp: ''!
generateReportFor: creatures printOn: stream
	| sum |
	sum := creatures inject: 0 into: [:accum :each | accum + each creaturesMet].
	creatures do:
			[:aCreature |
			aCreature creaturesMet printOn: stream.
			stream
				space;
				nextPutAll: (self units at: aCreature selfMet + 1);
				nl].
	stream space.
	sum printString
		do: [:el | stream nextPutAll: (self units at: el digitValue + 1)]
		separatedBy: [stream space].
	^stream! !

!ShootoutMall class methodsFor: 'printing' stamp: ''!
generateReportForColours: colours printOn: stream
	stream space.
	colours do: [:colour | colour printOn: stream] separatedBy: [stream space].
	^stream! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
initialize
	"self initialize"

	Units := #('zero' 'one' 'two' 'three' 'four' 'five' 'six' 'seven' 'eight' 'nine')! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
new
	^self shouldNotImplement! !

!ShootoutMall class methodsFor: 'private' stamp: ''!
openMall: aMall forCreatures: creatures usingGuard: sema
	| processes |
	processes := creatures
				collect: [:aCreature |
					[aCreature visitMall: aMall.
					sema signal] newProcess].
	processes do:
			[:proc |
			proc priority: Processor userBackgroundPriority.
			proc resume]! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
openMallWith: aCollectionOfColours forNumberOfMeets: aNumber
	| mall creatures guard |
	mall := self createAllowing: aNumber.
	mall run.
	creatures := self createCreaturesWith: aCollectionOfColours.
	guard := Semaphore new.
	self
		openMall: mall
		forCreatures: creatures
		usingGuard: guard.
	self
		waitForClosingOfMall: mall
		withCreatures: creatures
		usingGuard: guard.
	^creatures! !

!ShootoutMall class methodsFor: 'public' stamp: 'eem 8/1/2008 16:16'!
runBenchMark: number on: anOutputStream
	"self runBenchMark: 60000 on: Transcript."

	| firstTestColours secondTestColours blue red yellow creatures |
	blue := ShootoutChameneosColour blue.
	red := ShootoutChameneosColour red.
	yellow := ShootoutChameneosColour yellow.
	firstTestColours := Array
				with: blue
				with: red
				with: yellow.
	secondTestColours := (OrderedCollection new)
				add: blue;
				add: red;
				add: yellow;
				add: red;
				add: yellow;
				add: blue;
				add: red;
				add: yellow;
				add: red;
				add: blue;
				yourself.
	(ShootoutChameneosColour generateReportOfColoursOn: anOutputStream) nl.
	(self generateReportForColours: firstTestColours printOn: anOutputStream)
		nl.
	creatures := ShootoutMall openMallWith: firstTestColours forNumberOfMeets: number.
	(self generateReportFor: creatures printOn: anOutputStream)
		nl;
		nl.
	(self generateReportForColours: secondTestColours printOn: anOutputStream)
		nl.
	creatures := ShootoutMall openMallWith: secondTestColours forNumberOfMeets: number.
	(self generateReportFor: creatures printOn: anOutputStream)
		nl;
		nl! !

!ShootoutMall class methodsFor: 'accessing' stamp: ''!
units
	^Units! !

!ShootoutMall class methodsFor: 'private' stamp: ''!
waitForClosingOfMall: aMall withCreatures: creatures usingGuard: guard
	creatures size timesRepeat: [guard wait].
	aMall close! !

!ShootoutMall methodsFor: 'controlling' stamp: ''!
close
	open := false! !

!ShootoutMall methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:14'!
initialize
	guard := Semaphore forMutualExclusion.
	queue := SharedQueue new.
	cache := OrderedCollection new.
	1 to: 10 do: [:x | cache add: ShootoutPair new]! !

!ShootoutMall methodsFor: 'accessing' stamp: ''!
maxRendezvous: max
	maxRendezvous := max! !

!ShootoutMall methodsFor: 'private' stamp: ''!
obtainPair
	^cache removeFirst! !

!ShootoutMall methodsFor: 'private' stamp: ''!
processVisitors
	[open] whileTrue:
			[1 to: maxRendezvous
				do:
					[:x |
					| first second |
					first := queue next.
					second := queue next.
					self setPartnersOn: first and: second.
					first signal.
					second signal].
			[queue isEmpty] whileFalse: [queue next signal]].
	process terminate.
	process := nil! !

!ShootoutMall methodsFor: 'private' stamp: ''!
releasePair: pair
	pair release.
	cache addFirst: pair! !

!ShootoutMall methodsFor: 'initialize-release' stamp: ''!
run
	open := true.
	process ifNil:
			[process := [self processVisitors] newProcess.
			process priority: Processor userBackgroundPriority -1 ].
	process resume! !

!ShootoutMall methodsFor: 'private' stamp: ''!
setPartnersOn: first and: second
	first partner: second me.
	second partner: first me.
! !

!ShootoutMall methodsFor: 'private' stamp: ''!
shutdown
	[queue isEmpty] whileFalse: [queue next signal].
	process terminate.
	process := nil! !

!ShootoutMall methodsFor: 'controlling' stamp: ''!
visitWith: aChameneos
	| pair partner |
	pair := self obtainPair.
	pair me: aChameneos.
	queue nextPut: pair.
	pair wait.
	partner := pair partner.
	self releasePair: pair.
	^partner! !

Object subclass: #ShootoutMeteorBoard
	instanceVariableNames: 'pieces ncol ncell twoRows sixRows oddRowsMask evenRowsMask southEdge eastEdge westEdge southToNorthMasks eastToWestMasks northWestMask northEastMask southWestMask southEastMask positionsPerPiece loopCount fillMask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorBoard class methodsFor: 'instance creation' stamp: 'nice 3/29/2012 00:01'!
default
	^self basicNew fromString:
'0 0 0 0 1 
 2 2 2 0 1 
2 6 6 1 1 
 2 6 1 5 5 
8 6 5 5 5 
 8 6 3 3 3 
4 8 8 9 3 
 4 4 8 9 3 
4 7 4 7 9 
 7 7 7 9 9'! !

!ShootoutMeteorBoard class methodsFor: 'instance creation' stamp: 'nice 5/16/2012 02:00'!
solveDefault
	^String streamContents: [:outputStream |
		| board count minSolution maxSolution loopCount |
		count := 0.
		minSolution := String new: 50 withAll: $9.
		maxSolution := String new: 50 withAll: $0.
		loopCount := (board := self default) solvedPuzzleDo:
			[:aString |
					count := count + 1.
					aString < minSolution ifTrue: [minSolution := aString].
					aString > maxSolution ifTrue: [maxSolution := aString]].
		outputStream print: loopCount; nextPutAll: ' loops'; nl;nl.
		outputStream print: count; nextPutAll: ' solutions found'; nl; nl.
		board printSolution: minSolution on: outputStream.
		outputStream nl.
		board printSolution: maxSolution on: outputStream.
		outputStream nl]! !

!ShootoutMeteorBoard methodsFor: 'solving' stamp: 'nice 4/14/2012 16:52'!
addPiece: aPiece index: pieceNumber forRow: iRow
! !

!ShootoutMeteorBoard methodsFor: 'solving' stamp: 'nice 4/4/2012 08:21'!
boardStringWithPieces: pArray
	| board |
	board := String new: ncell.
	1 to: pArray size do: [:i | | c |
		c := '0123456789*' at: i.
		(pArray at: i) fillSolution: board ncol: ncol withColor: c].
	^board! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:09'!
canShiftE: aPieceMask
	^(eastEdge bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:21'!
canShiftNE: aPieceMask
	^(northEastMask bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:21'!
canShiftNW: aPieceMask
	^(northWestMask bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:21'!
canShiftSE: aPieceMask
	^(southEastMask bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:21'!
canShiftSW: aPieceMask
	^(southEastMask bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:09'!
canShiftW: aPieceMask
	^(westEdge bitAnd: aPieceMask) = 0! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/13/2012 13:43'!
fillMaskStartingAt: pos stoppingAbove: maxCell ifFoundEnough: exitBlock
	(fillMask bitAnd: pos) = 0 ifFalse: [^self].
	(pos > maxCell) ifTrue: [^exitBlock value].
	fillMask := fillMask + pos.
	(self canShiftE: pos) ifTrue: [self fillMaskStartingAt: (self shiftE: pos) stoppingAbove: maxCell ifFoundEnough: exitBlock].
	(self canShiftNE: pos) ifTrue: [self fillMaskStartingAt: (self shiftNE: pos) stoppingAbove: maxCell ifFoundEnough: exitBlock].
	(self canShiftNW: pos) ifTrue: [self fillMaskStartingAt: (self shiftNW: pos) stoppingAbove: maxCell ifFoundEnough: exitBlock].
	(self canShiftW: pos) ifTrue: [self fillMaskStartingAt: (self shiftW: pos) stoppingAbove: maxCell ifFoundEnough: exitBlock].
	^self! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/7/2012 03:09'!
findIsland: aMask
	| nextFreeCellMask open |
	nextFreeCellMask := 1 + aMask bitAnd: -1 - aMask.
	fillMask :=  aMask.
	open := false.
	self fillMaskStartingAt: nextFreeCellMask stoppingAbove: 1 << (fillMask highBit - 1 // ncol * ncol - 1) ifFoundEnough: [open := true].
	^open
		ifTrue: [0]
		ifFalse: [fillMask - aMask]! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 22:59'!
flip: aPieceMask
	^self shiftSEmost: (southToNorthMasks
		inject: 0 into: [:mask :rowMask |
			mask << ncol + ((rowMask bitAnd: aPieceMask) >> (rowMask lowBit - 1))]) >> ncol! !

!ShootoutMeteorBoard methodsFor: 'initialize-release' stamp: 'nice 4/7/2012 00:57'!
fromString: aString
	| rawString |
	rawString := aString reject: [:e | e isSeparator].
	ncell := rawString size.
	ncol := (aString readStream upTo: Character cr) count: [:e | e isSeparator not].
	twoRows := ncol * 2.
	sixRows := ncol * 6.
	self initializeRowColMasks.
	pieces := rawString asSet asSortedArray collect: [:char |
		self shiftSEmost:
			(rawString inject: 0 into: [:pmask :c | pmask * 2 + (c = char ifTrue: [1] ifFalse: [0])])].
	self initializePossiblePositions.! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/13/2012 13:50'!
hasEastOrWestIsland: aMask
	^ (self hasInsetZero: southEdge * (eastEdge bitAnd: aMask))
		or: [(self hasInsetZero: southEdge * (westEdge bitAnd: aMask))
			or: [(aMask bitAnd: eastEdge) > 0 and: [(aMask bitAnd: westEdge) > 0 and: [(self findIsland: aMask) bitCount \\ 5 > 0]]]]! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 3/31/2012 00:37'!
hasInsetZero: aMask
	| allOnes |
	allOnes := aMask bitOr: aMask - 1.
	^(allOnes bitAnd: allOnes + 1) > 0! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/13/2012 23:28'!
hasNorthIsland: aPieceMask row: iRow
	| bitReverse |
	bitReverse := (#(-1 -1 6 4 2) at: iRow) * ncol.
	^self hasSouthIsland: (aPieceMask bitReverse: bitReverse)! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/7/2012 00:52'!
hasSouthIsland: aMask
	^(self findIsland: aMask) bitCount \\ 5 > 0
		or: [(self findIsland: fillMask) bitCount \\ 5 > 0]! !

!ShootoutMeteorBoard methodsFor: 'initialize-release' stamp: 'nice 4/14/2012 23:30'!
initializePossiblePositions
	| positionsPerPiecePerCell thePieceWhichBreakSymmetry |
	positionsPerPiecePerCell := self possiblePositionsOnTwoRows.
	thePieceWhichBreakSymmetry := (1 to: pieces size) detectMax: [:i | (positionsPerPiecePerCell at: i) detectSum: [:orientations | orientations count: [:e | e mask > 0]]].
	positionsPerPiece := (1 to: 5) collect: [:iRow |
		| maxMaskForRow northRow |
		maxMaskForRow := (1 bitShift: (#(6 6 6 4 2) at: iRow) * ncol) - 1.
		northRow :=  southEdge bitShift: ((#(-1 -1 6 4 2) at: iRow) - 1 * ncol).
		(1 to: twoRows) collect: [:cellNumber |
			(1 to: pieces size) collect: [:pieceNumber |
				| orientations n |
				orientations := (positionsPerPiecePerCell at: pieceNumber) at: cellNumber.
				n := pieceNumber = thePieceWhichBreakSymmetry ifTrue: [6] ifFalse: [12].
				Array new: n streamContents: [:str |
					1 to: n do: [:i |
						| aPiece |
						aPiece := orientations at: i.
						(aPiece mask > 0 and: [aPiece mask <= maxMaskForRow])
							ifTrue:
								[(iRow = 1 and: [cellNumber <= ncol])
									ifTrue: [(self hasSouthIsland: aPiece mask)
										ifFalse: [str nextPut: (ShootoutMeteorPiece mask: aPiece mask islands: 0)]]
									ifFalse: [(aPiece mask bitAnd: northRow) > 0
										ifTrue: [(self hasNorthIsland: aPiece mask row: iRow)
											ifFalse:
												[| isle |
												isle := iRow = 5
													ifTrue: [0]
													ifFalse: [self northIslandsFor: aPiece mask row: iRow].
												str nextPut: (ShootoutMeteorPiece mask: aPiece mask islands: isle)]]
										ifFalse: [str nextPut: aPiece]]]]]]]]! !

!ShootoutMeteorBoard methodsFor: 'initialize-release' stamp: 'nice 4/7/2012 00:58'!
initializeRowColMasks
	southEdge := 1 << ncol - 1.
	southToNorthMasks := (0 to: 5) collect: [:i | southEdge << (ncol * i)].
	eastEdge := 1<<sixRows-1/southEdge.
	eastToWestMasks := (0 to: ncol - 1) collect: [:i | eastEdge << i].
	westEdge := eastToWestMasks last.
	oddRowsMask := 1<<sixRows-1/(1<<twoRows-1)*southEdge.
	evenRowsMask := oddRowsMask << ncol.
	northWestMask := westEdge bitAnd: evenRowsMask.
	northEastMask := eastEdge bitAnd: oddRowsMask.
	southWestMask := southEdge bitOr: (westEdge bitAnd: evenRowsMask).
	southEastMask := southEdge bitOr: (eastEdge bitAnd: oddRowsMask).! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/13/2012 21:58'!
islandsFor: aPieceMask
	| islands aMask nextFreeCellMask open top |
	islands := 0.
	fillMask := aPieceMask.
	top := 1 << (fillMask highBit - 1 // ncol * ncol - 1).
	[(nextFreeCellMask := 1 + fillMask bitAnd: -1 - fillMask) <= top]
		whileTrue:
			[open := false.
			aMask := fillMask.
			self fillMaskStartingAt: nextFreeCellMask stoppingAbove: top ifFoundEnough: [open := true].
			open ifFalse: [islands := islands + (fillMask - aMask)]].
	^islands! !

!ShootoutMeteorBoard methodsFor: 'islands' stamp: 'nice 4/15/2012 00:46'!
northIslandsFor: aPieceMask row: iRow
	| filled isleSEW bitReverse isleNE isleNW |
	bitReverse := (#(-1 -1 6 4 2) at: iRow) * ncol.
	filled := aPieceMask bitOr: aPieceMask - 1.
	isleSEW := self islandsFor: filled.
	(aPieceMask bitAnd: (eastEdge bitOr: westEdge)) = 0 ifFalse: [^isleSEW].
	(isleSEW bitAnd: (eastEdge bitOr: westEdge)) = 0 ifFalse: [^isleSEW].
	(southEdge bitAnd: aPieceMask) = 0
		ifTrue: [filled := filled >> ncol << ncol].
	isleNE := ((self islandsFor: (filled bitReverse: bitReverse)) bitReverse: bitReverse) bitOr: isleSEW.
	isleNW := (1 << bitReverse - 1 - (isleNE bitOr: (aPieceMask bitOr: aPieceMask - 1))) bitOr: isleSEW.
	^isleNW bitCount < isleNE bitCount
		ifTrue: [isleNW]
		ifFalse: [isleNE]! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/4/2012 03:56'!
placesFor: aPieceMask do: aBlock
	| westMask eastMask cellNumber |
	eastMask := self shiftSEmost: aPieceMask.
	
	[[westMask := eastMask.
	[(cellNumber := westMask lowBit) > twoRows ifTrue: [^self].
	(self hasEastOrWestIsland: westMask) ifFalse: [aBlock value: westMask].
	self canShiftW: westMask] whileTrue: [westMask := self shiftW: westMask].
	self canShiftNE: eastMask] whileTrue: [eastMask := self shiftNE: eastMask].
	self canShiftNW: eastMask] whileTrue: [eastMask := self shiftNW: eastMask]! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/14/2012 23:15'!
possiblePositionsOnTwoRows
	^pieces collect: [:aPieceMask |
		| possible iRot |
		possible := (Array new: twoRows) collect: [:freeCell | Array new: 12 withAll: (ShootoutMeteorPiece new mask: 0)].
		iRot := 0.
		self rotationsOf: aPieceMask do: [:rotated |
			iRot := iRot + 1.
			self placesFor: rotated do: [:shifted |
				(possible at: shifted lowBit) at: iRot put: (ShootoutMeteorPiece
					mask: ((self hasEastOrWestIsland: shifted) ifTrue: [0] ifFalse: [shifted])
					islands: (self islandsFor: (shifted bitOr: shifted - 1)))]].
		possible]! !

!ShootoutMeteorBoard methodsFor: 'printing' stamp: 'nice 4/7/2012 00:53'!
printMask: aPieceMask
	^String new: ncol * 2 + 1 * 6 streamContents: [:aStream | self printMask: aPieceMask on: aStream]! !

!ShootoutMeteorBoard methodsFor: 'printing' stamp: 'nice 4/7/2012 00:53'!
printMask: aPieceMask on: aStream
	6 to: 1 by: -1 do: [:irow |
		| mask |
		irow odd ifTrue: [aStream space].
		mask := 1 << (southToNorthMasks at: irow) highBit.
		1 to: ncol do: [:icol |
			aStream
				nextPut: ((aPieceMask bitAnd: (mask := mask >> 1)) = 0
					ifTrue: [$0]
					ifFalse: [$1]);
				space].
		aStream cr]! !

!ShootoutMeteorBoard methodsFor: 'printing' stamp: 'nice 5/16/2012 01:59'!
printSolution: aString on: aStream
	| src even |
	src := aString readStream.
	even := true.
	[src atEnd]
		whileFalse:
			[(even := even not) ifTrue: [aStream space].
			1 to: ncol do: [:j | aStream nextPut: src next; space].
			aStream nl]! !

!ShootoutMeteorBoard methodsFor: 'solving' stamp: 'nice 4/14/2012 16:52'!
removePiece: aPiece index: pieceNumber forRow: iRow! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:08'!
rotate: aPieceMask
	| rotatedMask pivot rotatedPivot irow row |
	rotatedMask := 0.
	irow := 1.
	row := aPieceMask bitAnd: (southToNorthMasks at: irow).
	rotatedPivot := pivot := 1 << (row highBit - 1).
	
	[rotatedMask := rotatedMask + rotatedPivot.
	[(row bitAnd: pivot - 1) = 0]
		whileFalse:
			[pivot := self shiftE: pivot.
			rotatedPivot := self shiftNE: rotatedPivot.
			(row bitAnd: pivot) = 0
				ifFalse:
					[rotatedMask := rotatedMask + rotatedPivot]].
	(row := aPieceMask bitAnd: (southToNorthMasks at: (irow := irow + 1))) = 0]
		whileFalse:
			[(self canShiftNE: pivot)
				ifTrue:
					[pivot := self shiftNE: pivot.
					rotatedPivot := self shiftNW: rotatedPivot]
				ifFalse:
					[pivot := self shiftNW: pivot.
					rotatedPivot := self shiftW: rotatedPivot].
			[row >= (pivot << 1)]
				whileTrue:
					[pivot := self shiftW: pivot.
					(self canShiftSW: rotatedPivot)
						ifFalse:
							[rotatedPivot := rotatedPivot << twoRows.
							rotatedMask := rotatedMask << twoRows.].
					rotatedPivot := self shiftSW: rotatedPivot]].
	^self shiftSEmost: rotatedMask! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:03'!
rotationsOf: aPieceMask do: aBlock
	| next |
	aBlock value: (next := aPieceMask); value: (self flip: next).
	5 timesRepeat:  [aBlock value: (next := self rotate: next); value: (self flip: next)]! !

!ShootoutMeteorBoard methodsFor: 'solving' stamp: 'nice 4/14/2012 23:56'!
searchPuzzlesWithColorMask: colorMask boardMask: bMask rowOffset: rowOff pieces: pArray ifFound: solutionBlock
	| nextFreeCell possibles colorBit iRow boardMask |
	colorMask = 0 ifTrue: [ ^solutionBlock value: (self boardStringWithPieces: pieces) ].
	loopCount := loopCount + 1.
	boardMask := bMask.
	iRow := rowOff.
	[(nextFreeCell := (boardMask + 1) lowBit) > twoRows]
		whileTrue:
			[ iRow := iRow + 2.
			boardMask := boardMask >> twoRows ].
	possibles := (positionsPerPiece at: iRow // 2 + 1) at: nextFreeCell.
	colorBit := 1.
	1 to: pieces size do: [:pieceNumber |
		(colorMask bitAnd: colorBit) = 0
			ifFalse:
				[ | positions |
				positions := possibles at: pieceNumber.
				1 to: positions size do: [:i |
					| aPiece |
					((aPiece := positions at: i) fitOnBoard: boardMask)
						ifTrue:
							[pieces at: pieceNumber put: (aPiece forRow: iRow).
							self addPiece: aPiece index: pieceNumber forRow: iRow.
							self searchPuzzlesWithColorMask: colorMask - colorBit boardMask: boardMask + aPiece mask rowOffset: iRow pieces: pArray ifFound: solutionBlock.
							self removePiece: aPiece index: pieceNumber forRow: iRow]]].
		colorBit := colorBit * 2].
	^nil! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/31/2012 00:13'!
shiftE: aPieceMask
	^aPieceMask >> 1! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:15'!
shiftNE: aPieceMask
	| evens odds |
	odds := oddRowsMask bitAnd: aPieceMask.
	evens := evenRowsMask bitAnd: aPieceMask.
	^odds >> 1 + evens << ncol! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:15'!
shiftNW: aPieceMask
	| evens odds |
	odds := oddRowsMask bitAnd: aPieceMask.
	evens := evenRowsMask bitAnd: aPieceMask.
	^evens << 1 + odds << ncol! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:15'!
shiftSE: aPieceMask
	| evens odds |
	odds := oddRowsMask bitAnd: aPieceMask.
	evens := evenRowsMask bitAnd: aPieceMask.
	^odds >> 1 + evens >> ncol! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 4/6/2012 09:09'!
shiftSEmost: aPieceMask
	| mostSEMask eastColumn lowBit |
	aPieceMask odd ifTrue: [^aPieceMask].
	lowBit := aPieceMask lowBit.
	mostSEMask := aPieceMask >> (lowBit - 1 // twoRows * twoRows).
	(mostSEMask bitAnd: southEdge) = 0
		ifTrue: [mostSEMask := (self canShiftSE: mostSEMask)
			ifTrue: [self shiftSE: mostSEMask]
			ifFalse: [self shiftSW: mostSEMask]].
	eastColumn := eastToWestMasks findFirst: [:e | (e bitAnd: mostSEMask) > 0].
	^mostSEMask >> (eastColumn - 1)! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/30/2012 23:16'!
shiftSW: aPieceMask
	| evens odds |
	odds := oddRowsMask bitAnd: aPieceMask.
	evens := evenRowsMask bitAnd: aPieceMask.
	^evens << 1 + odds >> ncol! !

!ShootoutMeteorBoard methodsFor: 'generating' stamp: 'nice 3/31/2012 00:12'!
shiftW: aPieceMask
	^aPieceMask << 1! !

!ShootoutMeteorBoard methodsFor: 'solving' stamp: 'nice 4/14/2012 17:14'!
solvedPuzzleDo: solutionBlock
	loopCount := 0.
	self
		searchPuzzlesWithColorMask: 1 << pieces size - 1
		boardMask: 0
		rowOffset: 0
		pieces: pieces copy
		ifFound: [:aSolution |
			solutionBlock value: aSolution; value: aSolution reversed].
	^loopCount! !

ShootoutMeteorBoard subclass: #ShootoutMeteorInstrumentedBoard
	instanceVariableNames: 'boardMorph iFrame forMovie'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorInstrumentedBoard methodsFor: 'solving' stamp: 'nice 4/15/2012 01:30'!
addPiece: aPiece index: pieceNumber forRow: iRow
	boardMorph addPiece: aPiece index: pieceNumber forRow: iRow.
	boardMorph world displayWorld.
	forMovie
		ifTrue: [self snapshotBoard]
		ifFalse: [(Delay forMilliseconds: 200) wait].! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'initialize-release' stamp: 'nice 4/15/2012 01:08'!
forMovie: aBoolean
	forMovie := aBoolean.
	iFrame := 0! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'initialize-release' stamp: 'nice 4/15/2012 01:06'!
fromString: boardString
	forMovie := false.
	self initializeMorph.
	super fromString: boardString.! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'initialize-release' stamp: 'nice 4/14/2012 16:43'!
initializeMorph
	boardMorph := ShootoutMeteorBoardMorph new.
	boardMorph position: Display boundingBox center. "World cursorPoint."
	boardMorph openInWorld.
	"hexaBoard activeHand attachMorph: hexaBoard."! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'solving' stamp: 'nice 4/15/2012 01:29'!
removePiece: aPiece index: pieceNumber forRow: iRow
	forMovie ifFalse: [(Delay forMilliseconds: 200) wait].
	boardMorph removePiece: aPiece index: pieceNumber forRow: iRow.
	boardMorph world displayWorld.
	forMovie ifTrue: [self snapshotBoard]! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'solving' stamp: 'nice 4/15/2012 01:29'!
snapshotBoard
	iFrame := iFrame + 1.
	boardMorph exportAsPNGNamed: 'meteor_' , (iFrame printPaddedWith: $0 to: 6) , '.png'! !

!ShootoutMeteorInstrumentedBoard methodsFor: 'solving' stamp: 'nice 4/14/2012 17:34'!
solvedPuzzleDo: solutionBlock
	^[super solvedPuzzleDo: [:aSolution |
			boardMorph flash.
			(Delay forSeconds: 1) wait.
			solutionBlock value: aSolution]]
		ensure: [boardMorph delete]! !

Object subclass: #ShootoutMeteorPiece
	instanceVariableNames: 'mask row'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorPiece class methodsFor: 'instance creation' stamp: 'nice 4/4/2012 08:17'!
mask: p islands: i
	^i = 0
		ifTrue: [ShootoutMeteorPiece new mask: p]
		ifFalse: [ShootoutMeteorPieceWithIsland new mask: p; islands: i]! !

!ShootoutMeteorPiece methodsFor: 'accessing' stamp: 'nice 4/13/2012 21:53'!
fillSolution: aString ncol: ncol withColor: c 
	| offset |
	offset := row * ncol.
	mask bitsDo: [:k | aString at: offset + k put: c]! !

!ShootoutMeteorPiece methodsFor: 'testing' stamp: 'nice 4/4/2012 02:09'!
fitOnBoard: aBoardMask
	^0 == (aBoardMask bitAnd: mask)! !

!ShootoutMeteorPiece methodsFor: 'initialize-release' stamp: 'nice 4/4/2012 04:00'!
forRow: rowOffset
	row := rowOffset! !

!ShootoutMeteorPiece methodsFor: 'accessing' stamp: 'nice 4/4/2012 01:50'!
mask
	^mask! !

!ShootoutMeteorPiece methodsFor: 'initialize-release' stamp: 'nice 4/4/2012 01:50'!
mask: aPieceMask
	mask := aPieceMask! !

ShootoutMeteorPiece subclass: #ShootoutMeteorPieceWithIsland
	instanceVariableNames: 'islands aPieceCouldFitIntoIsland'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorPieceWithIsland methodsFor: 'testing' stamp: 'nice 4/4/2012 09:19'!
fitOnBoard: aBoardMask
	| occupied |
	^0 == (aBoardMask bitAnd: mask) and:
		[(occupied := aBoardMask bitAnd: islands) = islands
			or: [aPieceCouldFitIntoIsland and: [(islands - occupied) bitCount = 5]]]! !

!ShootoutMeteorPieceWithIsland methodsFor: 'initialize-release' stamp: 'nice 4/4/2012 09:16'!
islands: islandMask
	islands := islandMask.
	aPieceCouldFitIntoIsland := islands bitCount >= 5! !

Object subclass: #ShootoutNBodySystem
	instanceVariableNames: 'bodies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutNBodySystem methodsFor: 'nbody' stamp: 'ul 5/24/2015 06:30'!
after: dt
	1 to: bodies size do: [:i|
		i+1 to: bodies size do: [:j|
			(bodies at: i) and: (bodies at: j) velocityAfter: dt].
	].
	1 to: bodies size do: [ :i |
		(bodies at: i) positionAfter: dt]! !

!ShootoutNBodySystem methodsFor: 'nbody' stamp: ''!
energy
	| e |
	e := 0.0.
	1 to: bodies size do: [:i|
		e := e + (bodies at: i) kineticEnergy.

		i+1 to: bodies size do: [:j|
			e := e - ((bodies at: i) potentialEnergy: (bodies at: j))].
	].
	^e! !

!ShootoutNBodySystem methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:08'!
initialize
	bodies := (OrderedCollection new
		add: ShootoutBody sun; add: ShootoutBody jupiter; add: ShootoutBody saturn;
		add: ShootoutBody uranus; add: ShootoutBody neptune; yourself) asArray.

	bodies first offsetMomentum:
		(bodies inject: (Array with: 0.0 with: 0.0 with: 0.0)
			into: [:m :each | each addMomentumTo: m])! !

Object subclass: #ShootoutPair
	instanceVariableNames: 'partner me sema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutPair class methodsFor: 'instance creation' stamp: ''!
new
	"Answer a newly created and initialized instance."
	^super new initialize.! !

!ShootoutPair class methodsFor: 'instance creation' stamp: ''!
with: me
	"Answer a newly created and initialized instance."
self halt.
	^super new initialize me: me! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	partner := nil.
	me := nil.
	sema := Semaphore new.
	^self! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
me
	^me! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
me: anObject
	me := anObject! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
partner
	^partner! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
partner: anObject
	partner := anObject! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
release
partner:=nil.! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
signal
	sema signal! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
wait
	sema wait! !

Object subclass: #ShootoutPermGeneratorRedux
	instanceVariableNames: 'timesRotated perm atEnd prevPerm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutPermGeneratorRedux class methodsFor: 'instance creation' stamp: ''!
new: size
	^self new
		initialize: size;
		yourself! !

!ShootoutPermGeneratorRedux methodsFor: 'accessing' stamp: ''!
atEnd
	^atEnd! !

!ShootoutPermGeneratorRedux methodsFor: 'initialize-release' stamp: 'ul 5/25/2015 15:34'!
initialize: size
	perm := (1 to: size) asArray.
	prevPerm := Array new: size.
	timesRotated := Array new: size withAll: 0.
	atEnd := false.! !

!ShootoutPermGeneratorRedux methodsFor: 'initialize-release' stamp: 'ul 5/25/2015 16:04'!
makeNext
	"* Generate the next permutation. *"

	2 to: perm size do: [ :r |
		| temp |
		"* Rotate the first r items to the left. *"
		temp := perm at: 1.
		perm
			replaceFrom: 1
			to: r - 1
			with: perm
			startingAt: 2.
		perm at: r put: temp.
		(timesRotated at: r put: ((timesRotated at: r) + 1) \\ r) = 0 ifFalse: [ ^self ].

		"* After r rotations, the first r items are in their original positions.
		Go on rotating the first r+1 items. *"
	].

	"* We are past the final permutation. *"
	atEnd := true! !

!ShootoutPermGeneratorRedux methodsFor: 'benchmarks' stamp: 'ul 5/25/2015 15:37'!
maxPfannkuchenTo: output
	| max checksum permCount flipsCount |
	max := 0.
	permCount := 0.
	checksum := 0.
	[ atEnd ] whileFalse: [
		self next.
		(permCount := permCount + 1) = 1048576 ifTrue: [ permCount := 0 ].
		flipsCount := prevPerm pfannkuchen.
		checksum := permCount odd ifTrue: [checksum+flipsCount] ifFalse: [checksum-flipsCount].
		max := max max: flipsCount].
	output print: checksum; nl.
	^max! !

!ShootoutPermGeneratorRedux methodsFor: 'accessing' stamp: 'ul 5/25/2015 15:36'!
next
	
	prevPerm 
		replaceFrom: 1
		to: prevPerm size
		with: perm
		startingAt: 1.
	self makeNext! !

Object subclass: #ShootoutRandomNumber
	instanceVariableNames: 'seed scale'
	classVariableNames: 'FModulus Increment Modulus Multiplier'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutRandomNumber class methodsFor: 'class initialization' stamp: ''!
initialize
	FModulus := 139968.0d0.
	Increment := 29573.
	Modulus := 139968.
	Multiplier := 3877.! !

!ShootoutRandomNumber class methodsFor: 'initialize-release' stamp: ''!
to: anInteger
	^self basicNew to: anInteger! !

!ShootoutRandomNumber methodsFor: 'accessing' stamp: ''!
next
	seed := (seed * Multiplier + Increment) \\ Modulus.
	^(seed * scale) / FModulus! !

!ShootoutRandomNumber methodsFor: 'private' stamp: ''!
to: anInteger
	seed := 42.
	scale := anInteger! !

Object subclass: #ShootoutRandomNumberRedux
	instanceVariableNames: 'seed scale multiplier increment modulus'
	classVariableNames: 'FModulus Increment Modulus Multiplier'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutRandomNumberRedux class methodsFor: 'class initialization' stamp: 'nice 5/6/2012 16:21'!
initialize
   FModulus := 139968.0d0.
   Increment := 29573.
   Modulus := 139968.
   Multiplier := 3877.! !

!ShootoutRandomNumberRedux class methodsFor: 'instance creation' stamp: ''!
to: anInteger
   ^self basicNew to: anInteger! !

!ShootoutRandomNumberRedux methodsFor: 'accessing' stamp: 'nice 5/6/2012 16:21'!
next
   ^scale * (seed := seed * multiplier + increment \\ modulus)! !

!ShootoutRandomNumberRedux methodsFor: 'private' stamp: 'nice 5/6/2012 16:21'!
to: anInteger
   seed := 42.
   scale := anInteger / FModulus.
   multiplier := Multiplier.
   increment := Increment.
   modulus := Modulus.! !

Object subclass: #ShootoutTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 4/26/2016 01:49'!
allBenchmarksTo: stream
	"The N values are from benchmarksgame.alioth.debian.org."

	^{
		[ self binarytrees: 16 to: stream ].
		[ self chameneosredux: 600000 to: stream ].
		[ self fannkuchRedux: 10 to: stream ].
		[ self fasta: 2500000 to: stream ].
		[ self fastaRedux: 2500000 to: stream ].
		[ 
			| fasta250000 |
			fasta250000 := (String new:  2541745 streamContents: [ :s |
				self fasta: 250000 to: s ]) readStream.
			[ self knucleotideFrom: fasta250000 to: stream ] ] value.
		[ self mandelbrot3: 1000 to: stream ].
		[ self meteor: 2098 to: stream ].
		[ self nbody: 500000 to: stream ].
		[ self pidigitsTo: 2000 width: 10 to: stream ].
		[ 
			| fasta50000 |
			fasta50000 := String new: 508411 streamContents: [ :s |
				self fasta: 50000 to: s ].
			[ self regexDNA: fasta50000 to: stream ] ] value.
		[
			| fasta2500000 |
			fasta2500000 := (String new: 25416745 streamContents: [ :s |
				self fasta: 2500000 to: s ]) readStream.
			[ self reverseComplement: fasta2500000 to: stream ] ] value.
		[ self spectralnorm: 500].
		[ self threadring: 5000000 to: stream ]
	 }! !

!ShootoutTests class methodsFor: 'platform' stamp: 'eem 11/17/2008 12:37'!
arg
	3 to: 5 do:
		[:i|
		(SmalltalkImage current getSystemAttribute: i) ifNotNil:
			[:aString|
			aString asInteger ifNotNil:
				[:arg| ^arg]]].
	^nil! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
binarytrees
	self binarytrees: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 8/1/2008 16:10'!
binarytrees: n to: output
	| minDepth maxDepth stretchDepth check longLivedTree iterations |
	minDepth := 4.
	maxDepth := minDepth + 2 max: n.
	stretchDepth := maxDepth + 1.

	check := (ShootoutTreeNode bottomUpTree: 0 depth: stretchDepth) itemCheck.
	output
		nextPutAll: 'stretch tree of depth '; print: stretchDepth; tab;
		nextPutAll: ' check: '; print: check; nl.

	longLivedTree := ShootoutTreeNode bottomUpTree: 0 depth: maxDepth.
	minDepth to: maxDepth by: 2 do: [:depth|
		iterations := 1 bitShift: maxDepth - depth + minDepth.

		check := 0.
		1 to: iterations do: [:i|
			check := check + (ShootoutTreeNode bottomUpTree: i depth: depth) itemCheck.
			check := check + (ShootoutTreeNode bottomUpTree: -1*i depth: depth) itemCheck
			].
		output
			print:  (2*iterations); tab;
			nextPutAll: ' trees of depth '; print: depth; tab;
			nextPutAll: ' check: '; print: check; nl
		].

	output
		nextPutAll: 'long lived tree of depth '; print: maxDepth; tab;
		nextPutAll: ' check: '; print: longLivedTree itemCheck; nl! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 8/1/2008 16:26'!
chameneosredux2
	self chameneosredux: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 8/1/2008 16:26'!
chameneosredux: arg to: aStream
	ShootoutMall runBenchMark: arg on: aStream! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 5/4/2010 11:46'!
collectReferenceTimes
	"Run the benchmarks 3 times and take their average, e.g. suitable
	 for filling in values for referenceTimesForClosureInterpreter"

	"ShootoutTests collectReferenceTimes"
	| n refs |
	Transcript clear.
	n := 3.
	refs := (1 to: n) collect: [:i| ShootoutTests runAllToInternalStream].
	^{	refs.
		(1 to: refs first size) collect:
			[:i|
			((refs inject: 0 into: [:sum :ref| (ref at: i) + sum]) / n) rounded] }! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
fannkuchRedux: n to: output
	^(ShootoutPermGeneratorRedux new: n) maxPfannkuchenTo: output! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
fannkuchredux
	| n f |
	n := self arg.
	f := self fannkuchRedux: n to: self stdout.
	self stdout
		nextPutAll: 'Pfannkuchen(', n printString, ') = ';
		print: f; nl.
	^''! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
fasta
	self fasta: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
fasta: n to: out
	| r lineLength |
	lineLength := 60.
	self
		writeFasta: 'ONE Homo sapiens alu'
		from:
			( ShootoutRepeatStream
				to: n*2
				on:'GGCCGGGCGCGGTGGCTCACGCCTGTAATCCCAGCACTTTGG',
					'GAGGCCGAGGCGGGCGGATCACCTGAGGTCAGGAGTTCGAGA',
					'CCAGCCTGGCCAACATGGTGAAACCCCGTCTCTACTAAAAAT',
					'ACAAAAATTAGCCGGGCGTGGTGGCGCGCGCCTGTAATCCCA',
					'GCTACTCGGGAGGCTGAGGCAGGAGAATCGCTTGAACCCGGG',
					'AGGCGGAGGTTGCAGTGAGCCGAGATCGCGCCACTGCACTCC',
					'AGCCTGGGCGACAGAGCGAGACTCCGTCTCAAAAA' )
		to: out
		lineLength: lineLength.

	r := ShootoutRandomNumber to: 1. "Shared random sequence"

	self
		writeFasta: 'TWO IUB ambiguity codes'
		from:
			(( ShootoutRandomStream
				to: n*3
				on: #(	#($a 0.27d0)
						#($c 0.12d0)
						#($g 0.12d0)
						#($t 0.27d0)

						#($B 0.02d0)
						#($D 0.02d0)
						#($H 0.02d0)
						#($K 0.02d0)
						#($M 0.02d0)
						#($N 0.02d0)
						#($R 0.02d0)
						#($S 0.02d0)
						#($V 0.02d0)
						#($W 0.02d0)
						#($Y 0.02d0)))
			random: r;
			yourself)
		to: out
		lineLength: lineLength.

	self
		writeFasta: 'THREE Homo sapiens frequency'
		from:
			(( ShootoutRandomStream
				to: n*5
				on: #(	#($a 0.3029549426680d0)
						#($c 0.1979883004921d0)
						#($g 0.1975473066391d0)
						#($t 0.3015094502008d0)))
				random: r;
				yourself)
		to: out
		lineLength: lineLength.

	out flush. ! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'nice 5/6/2012 16:17'!
fastaRedux: n to: out
   | lineLength iub sapiens |
   lineLength := 60.
   self
      writeFastaRedux: 'ONE Homo sapiens alu'
      from:
         ( ShootoutRepeatStreamRedux
            to: n*2
            on:'GGCCGGGCGCGGTGGCTCACGCCTGTAATCCCAGCACTTTGG',
               'GAGGCCGAGGCGGGCGGATCACCTGAGGTCAGGAGTTCGAGA',
               'CCAGCCTGGCCAACATGGTGAAACCCCGTCTCTACTAAAAAT',
               'ACAAAAATTAGCCGGGCGTGGTGGCGCGCGCCTGTAATCCCA',
               'GCTACTCGGGAGGCTGAGGCAGGAGAATCGCTTGAACCCGGG',
               'AGGCGGAGGTTGCAGTGAGCCGAGATCGCGCCACTGCACTCC',
               'AGCCTGGGCGACAGAGCGAGACTCCGTCTCAAAAA' )
      to: out
      lineLength: lineLength.

   iub :=  ShootoutRandomStreamRedux
            to: n*3
            on: #(   #($a 0.27d0)
                  #($c 0.12d0)
                  #($g 0.12d0)
                  #($t 0.27d0)

                  #($B 0.02d0)
                  #($D 0.02d0)
                  #($H 0.02d0)
                  #($K 0.02d0)
                  #($M 0.02d0)
                  #($N 0.02d0)
                  #($R 0.02d0)
                  #($S 0.02d0)
                  #($V 0.02d0)
                  #($W 0.02d0)
                  #($Y 0.02d0)).
   sapiens :=  ShootoutRandomStreamRedux
            to: n*5
            on: #(   #($a 0.3029549426680d0)
                  #($c 0.1979883004921d0)
                  #($g 0.1975473066391d0)
                  #($t 0.3015094502008d0)).

   sapiens random: iub random. "Share random sequence"

   self
      writeFastaRedux: 'TWO IUB ambiguity codes'
      from: iub
      to: out
      lineLength: lineLength.

   self
      writeFastaRedux: 'THREE Homo sapiens frequency'
      from: sapiens
      to: out
      lineLength: lineLength.

   out flush.! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'nice 5/6/2012 16:16'!
fastaredux
   self fastaRedux: self arg to: self stdout.
   ^''! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 4/25/2016 15:55'!
knucleotide

	self knucleotideFrom: self stdin to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 4/26/2016 01:40'!
knucleotideFrom: input to: output

	| sequence writeFrequencies writeCount |
	sequence := (self readFasta: 'THREE' from: input) value asUppercase.

	writeFrequencies := [ :k |
		| frequencies count |
		frequencies := SortedCollection sortBlock: [:a :b|
		(a value = b value) ifTrue: [b key < a key] ifFalse: [b value < a value]].

		count := 0.
		(sequence substringFrequenciesFor: k) associationsDo: [ :each |
			frequencies add: each.
			count := count + each value ].

		frequencies do: [ :each |
			| percentage |
			percentage := each value * 100 / count.
			output nextPutAll: each key; space.
			percentage printOn: output showingDecimalPlaces: 3.
			output nl ] ].

	writeCount := [:nucleotideFragment | | frequencies count |
		frequencies := sequence substringFrequenciesFor: nucleotideFragment size.
		count := frequencies at: nucleotideFragment ifAbsent: 0.
		output print: count; tab; nextPutAll: nucleotideFragment; nl].

	writeFrequencies value: 1. output nl.
	writeFrequencies value: 2. output nl.

	writeCount value: 'GGT'.
	writeCount value: 'GGTA'.
	writeCount value: 'GGTATT'.
	writeCount value: 'GGTATTTTAATT'.
	writeCount value: 'GGTATTTTAATTTATAGT'.! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
mandelbrot2
	| n output |
	n := self arg.
	(output := self stdout)
		nextPutAll: 'P4'; nl; print: n; space; print: n; nl;
		binary.

	self mandelbrot2: n to: output.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
mandelbrot2: extent to: output
	| limit2 m bits zr zi cr ci i tr stepr stepi |
	limit2 := 4.0d0.
	m := 50.

	stepr := 2.0d0 / extent.
	stepi := 2.0d0 / extent.

	0 to: extent - 1 do: [ :y |
		 bits := 0.
		 ci := stepi * y asFloat - 1.0d0.
		 0 to: extent - 1 do: [ :x |
			  cr := stepr * x asFloat - 1.5d0.
			  zr := cr. zi := ci.

			  bits := bits bitShift: 1.
			  i := 1.  
			  [
					tr := (zr*zr) - (zi*zi) + cr.
					zi := 2.0d0 * zr * zi + ci.
					zr := tr.
					(zr*zr) + (zi*zi) < limit2 and: [ (i := i + 1) < m ]
			  ] whileTrue.

			  i = m ifTrue: [ bits := bits + 1 ].
			  (x bitAnd: 7) == 7 ifTrue: [
					output nextPut: bits.
					bits := 0.
			  ]
		 ]. 
		 (extent bitAnd: 7) == 0 ifFalse: [
			  bits := bits bitShift: 8 - (extent bitAnd: 7).
			  output nextPut: bits.
		 ]
	]! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'nice 5/6/2012 22:14'!
mandelbrot3
   | n output |
   n := self arg.
   (output := self stdout)
      nextPutAll: 'P4'; nl; print: n; space; print: n; nl;
      binary.

   self mandelbrot3: n to: output.
   ^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'nice 5/6/2012 22:14'!
mandelbrot3: extent to: output
   | bits zr zi zr2 zi2 cr ci i tr step reals imags |
  step := 2.0d0 / extent.
  reals := (0 to: extent - 1) collect: [:x | step * x - 1.5d0].
  imags := (0 to: extent - 1) collect: [:y | step * y - 1.0d0].

   1 to: extent do: [ :iy |
       bits := 0.
       ci := imags at: iy.
       1 to: extent do: [ :ix |
           cr := reals at: ix.
           zr := cr. zi := ci.
           zr2 := zr * zr. zi2 := zi * zi.

           bits := bits bitShift: 1.
           i := 1.  
           [
               tr := zr2 - zi2 + cr.
               zi := 2.0d0 * zr * zi + ci.
               zr := tr.
               (zr2 := zr*zr) + (zi2 := zi*zi) < 4.0d0 and: [ (i := i + 1) < 50 ]
           ] whileTrue.

           i = 50 ifTrue: [ bits := bits + 1 ].
           (ix bitAnd: 7) == 0 ifTrue: [
               output nextPut: bits.
               bits := 0.
           ]
       ]. 
       (extent bitAnd: 7) == 0 ifFalse: [
           bits := bits bitShift: 8 - (extent bitAnd: 7).
           output nextPut: bits.
       ]
   ]! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
matchPatterns
	^#(	'agggtaaa|tttaccct'
			'[cgt]gggtaaa|tttaccc[acg]'
			'a[act]ggtaaa|tttacc[agt]t'
			'ag[act]gtaaa|tttac[agt]ct'
			'agg[act]taaa|ttta[agt]cct'
			'aggg[acg]aaa|ttt[cgt]ccct'
			'agggt[cgt]aa|tt[acg]accct'
			'agggta[cgt]a|t[acg]taccct'
			'agggtaa[cgt]|[acg]ttaccct'
	)! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'nice 5/6/2012 22:43'!
meteor
	self meteor: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'nice 5/16/2012 02:00'!
meteor: nMax to: outputStream
	| board count minSolution maxSolution |
	count := 0.
	minSolution := String new: 50 withAll: $9.
	maxSolution := String new: 50 withAll: $0.
	(board := ShootoutMeteorBoard default) solvedPuzzleDo:
		[:aString |
			count := count + 1.
			aString < minSolution ifTrue: [minSolution := aString].
			aString > maxSolution ifTrue: [maxSolution := aString]. ]. 
	outputStream print: count; nextPutAll: ' solutions found'; nl; nl.
	board printSolution: minSolution on: outputStream.
	outputStream nl.
	board printSolution: maxSolution on: outputStream.
	outputStream nl.! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'nice 5/6/2012 22:43'!
nbody
	self nbody: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 4/26/2016 01:47'!
nbody: count to: output
	| bodies |
	bodies := ShootoutNBodySystem new initialize.

	bodies energy printOn: output showingDecimalPlaces: 9.
	output cr.
	1 to: count do: [ :i | bodies after: 0.01].
	bodies energy printOn: output showingDecimalPlaces: 9.
	output cr.
	^''! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
pidigits4
	self pidigitsTo: self arg width: 10 to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 5/24/2015 20:56'!
pidigitsTo: v width: width to: output

	| n i pidigits endIndex |
	n := v.
	i := 0.
	pidigits := ShootoutPiDigitSpigot new.
	[ n >= width ] whileTrue: [
		endIndex := i + width.
		[ 
			output nextPut: (Character digitValue: pidigits next).
			(i := i + 1) < endIndex ] whileTrue.
		output tab; nextPut: $:; print: i; nl.
		n := n - width ].
	n = 0 ifTrue: [ ^self ].
	[ (i := i + 1) <= v ] whileTrue: [ 
		output nextPut: (Character digitValue: pidigits next) ].
	1 to: width - (v - 1 \\ width + 1) do: [ :x | output space ].
	output tab; nextPut: $:; print: v; nl.! !

!ShootoutTests class methodsFor: 'profiling' stamp: 'ul 5/24/2015 17:15'!
profileAll
	"self profileAll"

	self allBenchmarksTo: (DummyStream on: nil)! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 4/26/2016 01:45'!
readFasta: sequenceName from: input

	| peek prefix newline description  |
	prefix := '>', sequenceName.
	newline := Character lf.

	"* find start of particular fasta sequence *"
	[ ((peek := input peek) == nil or: [ peek == $> ])
		ifTrue: [ (description := input upTo: newline) beginsWith: prefix ]
		ifFalse: [ input skipTo: newline. false ] ] whileFalse.

	"* line-by-line read - it would be a lot faster to block read *"
	^description -> (String new: 1023 streamContents: [ :stream |
		| character |
		[ (character := input peek) == nil or: [ character == $> ] ] whileFalse: [
			character == $;
				ifTrue: [ input skipTo: newline ]
				ifFalse: [ stream nextPutAll: (input upTo: newline) ] ] ])! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 5/4/2010 11:44'!
referenceTimesForClosureInterpreter
	 "ClosureVM (QF 1.2.23 + Closure Bytecodes) on Eliot's 2010 vintage 2.66GHz Intel Core i7 MacBook Pro"
	^Dictionary new
		at: #nbody put: 4543;
		at: #binarytrees put: 6944;
		at: #chameneosredux put: 5799;
		at: #threadring put: 5623;
		yourself

	 "ClosureVM (QF 1.2.23 + Closure Bytecodes) on Eliot's 2006 vintage 2.16GHz Intel Core Duo MacBook Pro"
	"^Dictionary new
		at: #nbody put: 7660;
		at: #binarytrees put: 14417;
		at: #chameneosredux put: 8478;
		at: #threadring put: 8718;
		yourself"! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 19:57'!
referenceTimesForSqueakVM
	 "Squeak VM (4.2.2beta1 + Closure Bytecodes) on Eliot's 2010 vintage 2.66GHz Intel Core i7 MacBook Pro"
	^Dictionary new
		at: #nbody put: 4917;
		at: #binarytrees put: 8593;
		at: #chameneosredux put: 5405;
		at: #threadring put: 3789;
		yourself! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 4/26/2016 01:50'!
referenceTimesForVW
	 "CPU secs from https://benchmarksgame.alioth.debian.org/u32/measurements.php?lang=vw
	VisualWorks® Personal Use Edition Release 8.1 of July 24, 2015"

	^(Dictionary new
		at: #binarytrees put: 2360;
		at: #chameneosredux put: 4720;
		at: #fannkuchRedux put: 4010;
		at: #fasta put: 4740;
		at: #fastaRedux put: 3220;
		at: #knucleotideFrom put: 3220;
		at: #mandelbrot3 put: 3930; "mandelbrot2 actually"
		at: #meteor put: 550;
		at: #nbody put: 3120;
		at: #pidigitsTo put: 1010;
		at: #regexDNA put: 7110;
		at: #reverseComplement put: 3020;
		at: #spectralnorm put: 1010;
		at: #threadring put: 4580;
		yourself) * 3050 // 2992 "i3-3110M / Q6600 from https://www.cpubenchmark.net/cpu_lookup.php?cpu=Intel+Core+i3-3110M+%40+2.40GHz"! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 5/24/2015 21:28'!
regexDNA: sequence to: output
	| s size1 size2 translation |
	size1 := sequence size.

	"* remove FASTA sequence descriptions and new-lines *"
	s := (sequence lines reject: [ :each | each isEmpty or: [ each first == $> ] ]) join.
	size2 := s size.

	"* regex match *"
	self matchPatterns do: [:each| 
		output 
			nextPutAll: each; space; 
			print: (s occurrencesOfRegex: each); nl
		]. 

	"* regex substitution *"
	translation := Dictionary new.
	self substitutionPatterns do: [:each| 
		translation at: each first put: each last].

	s := s copyWithRegex: '[', 
			(translation keys asArray fold: [:a :b| a, b]), ']'
		matchesTranslatedUsing: [:l| translation at: l].

	output
		nl;
		print: size1; nl; 
		print: size2; nl; 
		print: s size; nl! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
regexdna
	self regexDNA: self stdin contents to: self stdout.
	^'' ! !

!ShootoutTests class methodsFor: 'reporting' stamp: 'ul 5/24/2015 17:45'!
report: name time: millisecs reference: reference on: aStream
	aStream
		cr;
		nextPutAll: name; cr;
		nextPutAll: ' took '.
	(millisecs / 1000.0) printOn: aStream maxDecimalPlaces: 3.
	aStream
		nextPutAll: ' seconds'; cr; flush;
		nextPutAll: 'ratio: '.
	(millisecs / reference) printOn: aStream maxDecimalPlaces: 3.
	aStream nextPutAll: '   % change: '.
	(millisecs - reference * 100 / reference) printOn: aStream maxDecimalPlaces: 3.
	aStream nextPut: $%; cr; flush! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 5/24/2015 22:37'!
revcomp
	
	self reverseComplement: self stdin to: self stdout.
	^'' ! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'ul 4/25/2016 02:32'!
reverseComplement: sequence named: sequenceName to: output
	
	| newline complement |
	sequenceName ifNil: [ ^self ].

	complement := ByteString new: 256 withAll: $*.
	'ABCDGHKMNRSTVWY' with: 
	'TVGHCDMKNYSABWR'
		do: [:a :b|
			complement at: a asInteger put: b.
			complement at: a asLowercase asInteger put: b].
	sequence 
		translateWith: complement;
		reverseInPlace.

	newline := Character lf.

	output nextPutAll: sequenceName; nextPut: newline.

	1 to: sequence size by: 60 do: [ :index |
		output
			next: 60
				putAll: sequence
				startingAt: index;
			nextPut: newline ]! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 5/24/2015 22:37'!
reverseComplement: input to: output

	#('ONE' 'TWO' 'THREE') do: [ :sequenceName |
		| fasta |
		fasta := self readFasta: sequenceName from: input.
		self reverseComplement: fasta value named: fasta key to: output ].
	output flush! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToDummyStream
	"Transcript clear.
	 self runAllToDummyStream"
	^self runAllToDummyStreamVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 5/24/2015 17:46'!
runAllToDummyStreamVs: referenceTimes
	"Transcript clear.
	 self runAllToDummyStreamVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToDummyStreamVs: self referenceTimesForSqueakVM"
	| stream times ratios geometricMean |
	stream := DummyStream on: nil.
	times := Array new writeStream.
	ratios := Array new writeStream.
	(self allBenchmarksTo: stream) do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean printShowingDecimalPlaces: 3);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) printShowingDecimalPlaces: 3); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToInternalStream
	"Transcript clear.
	 self runAllToInternalStream"
	^self runAllToInternalStreamVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 5/24/2015 17:13'!
runAllToInternalStreamVs: referenceTimes
	"Transcript clear.
	 self runAllToInternalStreamVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToInternalStreamVs: self referenceTimesForSqueakVM"
	| stream times ratios geometricMean |
	stream := (ByteString new: 10000) writeStream.
	times := Array new writeStream.
	ratios := Array new writeStream.
	(self allBenchmarksTo: stream) do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean roundTo: 0.001);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) roundTo: 0.01); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToTranscript
	"Transcript clear.
	 self runAllToTranscript"
	^self runAllToTranscriptVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 5/24/2015 17:13'!
runAllToTranscriptVs: referenceTimes
	"Transcript clear.
	 self runAllToTranscriptVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToTranscriptVs: self referenceTimesForSqueakVM"
	| times ratios geometricMean |
	times := Array new writeStream.
	ratios := Array new writeStream.
	(self allBenchmarksTo: Transcript) do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean roundTo: 0.001);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) roundTo: 0.01); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 10/30/2008 10:43'!
selectorForSimpleBlock: aBlock
	| is |
	is := InstructionStream on: aBlock method.
	is pc: aBlock startpc.
	is scanFor:
		[:x| | selectorOrScanner |
		(selectorOrScanner := is selectorToSendOrSelf) ~~ is ifTrue:
			[^selectorOrScanner].
		false].
	^nil! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'ul 4/26/2016 01:48'!
spectralnorm2

	(self spectralnorm: self arg) printOn: self stdout showingDecimalPlaces: 9.
	self stdout nl.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
spectralnorm: n
	| u v vBv vv |
	u := Array new: n withAll: 1.0d0.
	10 timesRepeat:
		[v := u multiplyAtAv.
		 u := v multiplyAtAv].
	vBv := 0.0d0.
	vv := 0.0d0.
	1 to: n do:
		[:i |
		 vBv := vBv + ((u at: i) * (v at: i)).
		 vv := vv + ((v at: i) * (v at: i))].
	^(vBv / vv) sqrt! !

!ShootoutTests class methodsFor: 'platform' stamp: 'nice 3/31/2012 01:43'!
stdin
	^StandardFileStream stdin! !

!ShootoutTests class methodsFor: 'platform' stamp: 'nice 3/31/2012 01:42'!
stdout
	^StandardFileStream stdout! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
substitutionPatterns
	^#(	#('B' '(c|g|t)')
			#('D' '(a|g|t)')
			#('H' '(a|c|t)')
			#('K' '(g|t)')
			#('M' '(a|c)')
			#('N' '(a|c|g|t)')
			#('R' '(a|g)')
			#('S' '(c|g)')
			#('V' '(a|c|g)')
			#('W' '(a|t)')
			#('Y' '(c|t)'))! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 6/9/2009 12:25'!
threadRing: aSemaphore output: output
	| first last |
	503 to: 1 by: -1 do: [:i|
		first := ShootoutThread named: i next: first done: aSemaphore output: output.
		last isNil ifTrue: [ last := first ].
	].
	last nextThread: first.
	^first ! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/9/2009 12:30'!
threadring
  self threadring: self arg to: self stdout.
   ^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 6/9/2009 12:29'!
threadring: arg to: output
	| done |
	(self threadRing: (done := Semaphore new) output: output) takeToken: arg.
	done wait! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: ''!
writeFasta: aString from: inStream to: outStream lineLength: lineLength
	| i |
	outStream nextPut: $>; nextPutAll: aString; nl.
	i := 0.
	[inStream atEnd] whileFalse:
		[i == lineLength ifTrue: [outStream nl. i := 0].
		outStream nextPut: inStream next.
		i := i + 1].
	outStream nl! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'nice 5/6/2012 16:15'!
writeFastaRedux: aString from: inStream to: outStream lineLength: lineLength
   | i |
   outStream nextPut: $>; nextPutAll: aString; nl.
   i := 0.
  [ [
      outStream nextPut: inStream next.
     (i := i + 1) == lineLength ifTrue: [outStream nl. i := 0]
   ] repeat ]
         on: ShootoutFastaReduxEnd do: [:ignoreThisException | ].
   i = 0 ifFalse: [outStream nl]! !

Object subclass: #ShootoutThread
	instanceVariableNames: 'name nextThread token semaphore done output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutThread class methodsFor: 'instance creation' stamp: 'eem 6/9/2009 12:28'!
named: anInteger next: aThread done: aSemaphore output: aStream
	^self new name: anInteger; nextThread: aThread; done: aSemaphore; output: aStream; fork ! !

!ShootoutThread class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew semaphore: Semaphore new ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
done: aSemaphore
	done := aSemaphore ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
fork
	[ self run ] fork ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
name: anInteger
	name := anInteger ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
nextThread: aThread
	nextThread := aThread ! !

!ShootoutThread methodsFor: 'accessing' stamp: 'eem 6/9/2009 12:26'!
output: anObject
	"Set the value of output"

	output := anObject! !

!ShootoutThread methodsFor: 'accessing' stamp: 'eem 6/9/2009 12:33'!
run
	[ self tokenNotDone ] whileTrue: [ nextThread takeToken: token - 1 ].
	output print: name.
	output name = 'stdout'
	ifTrue: [output nl]
	ifFalse: [output cr; flush].
	done signal ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
semaphore: aSemaphore
	semaphore := aSemaphore ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
takeToken: x
	token := x.
	semaphore signal ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
tokenNotDone
	semaphore wait.
	^token > 0 ! !

Object subclass: #ShootoutTreeNode
	instanceVariableNames: 'left right item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutTreeNode class methodsFor: 'instance creation' stamp: 'ul 5/24/2015 06:04'!
bottomUpTree: anItem depth: anInteger
	
	anInteger = 0 ifTrue: [ ^self left: nil right: nil item: anItem ].
	^self
		left: (self bottomUpTree: 2 * anItem - 1 depth: anInteger - 1)
		right: (self bottomUpTree: 2 * anItem depth: anInteger - 1) 
		item: anItem! !

!ShootoutTreeNode class methodsFor: 'instance creation' stamp: 'ul 5/24/2015 06:04'!
left: leftChild right: rightChild item: anItem
	
	^self basicNew left: leftChild right: rightChild item: anItem! !

!ShootoutTreeNode methodsFor: 'accessing' stamp: 'ul 5/24/2015 06:33'!
itemCheck
	
	left ifNil: [ ^item ].
	^item - right itemCheck + left itemCheck ! !

!ShootoutTreeNode methodsFor: 'initialize-release' stamp: ''!
left: leftChild right: rightChild item: anItem
	left := leftChild.
	right := rightChild.
	item := anItem! !

Stream subclass: #ShootoutPiDigitSpigot
	instanceVariableNames: 'numer accum denom k precalc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutPiDigitSpigot class methodsFor: 'instance creation' stamp: ''!
new
	^super basicNew initialize! !

!ShootoutPiDigitSpigot methodsFor: 'stream' stamp: ''!
atEnd
	^false! !

!ShootoutPiDigitSpigot methodsFor: 'private' stamp: 'ul 5/24/2015 20:04'!
eliminate: digit
	accum := accum - (denom * digit) * 10.
	numer := numer * 10.
	precalc := numer + numer + accum! !

!ShootoutPiDigitSpigot methodsFor: 'private' stamp: 'ul 5/24/2015 20:07'!
extract

	| qr |
	precalc := numer + numer + accum.
	numer > accum ifTrue: [ ^nil ].
	qr := precalc + numer digitDiv: denom neg: false.
	(qr at: 2) normalize >= (denom - numer) ifTrue: [ ^nil ].
	^(qr at: 1) normalize! !

!ShootoutPiDigitSpigot methodsFor: 'private' stamp: 'ul 5/24/2015 20:07'!
initialize

	numer := denom := 1.
	k := accum := 0.
	precalc := numer + numer + accum! !

!ShootoutPiDigitSpigot methodsFor: 'stream' stamp: 'ul 5/24/2015 19:42'!
next
	| digit |
	[ self step. (digit := self extract) == nil ] whileTrue.
	self eliminate: digit.
	^digit! !

!ShootoutPiDigitSpigot methodsFor: 'private' stamp: 'ul 5/24/2015 20:07'!
step

	| y2 |
	k := k + 1.
	y2 := k * 2 + 1.
	accum := precalc * y2.
	numer := numer * k.
	denom := denom * y2.! !

!Time class methodsFor: '*SMark-squeak protocol' stamp: 'sm 5/25/2011 14:26'!
milliseconds: currentTime since: lastTime
	"Answer the elapsed time since last recorded in milliseconds.
	Compensate for rollover."

	| delta |
	delta := currentTime - lastTime.
	^ delta < 0
		ifTrue: [SmallInteger maxVal + delta]
		ifFalse: [delta]
! !

Benchmark subclass: #SMarkAStarBenchmark
	instanceVariableNames: 'graph1 graph2 astar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkAStarBenchmark methodsFor: 'initialize-release' stamp: 'MP 2/7/2014 15:11'!
benchAStar
	5 timesRepeat: [
		astar 
			graph: graph1;
			findPath;
			reset .
		astar
			graph: graph2;
			findPath;
			reset .].! !

!SMarkAStarBenchmark methodsFor: 'initialize-release' stamp: 'tfel 6/2/2015 10:31'!
setUp
	astar := SMarkAStar new .
	graph1 := SMarkAStarGraph testGraph .
	graph2 := SMarkAStarGraph testGraph2 .! !

!SMarkAStarBenchmark methodsFor: 'initialize-release' stamp: 'MP 2/7/2014 15:04'!
tearDown
	astar := nil .
	graph1 := nil .
	graph2 := nil .! !

Benchmark subclass: #SMarkBinaryTreeBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkBinaryTreeBenchmark methodsFor: 'testing' stamp: 'MP 1/27/2014 14:10'!
benchBinaryTree
	"starts the binary tree benchmark"
	
	self binarytrees: 10 .! !

!SMarkBinaryTreeBenchmark methodsFor: 'testing' stamp: 'tfel 6/2/2015 10:36'!
binarytrees: n
   | minDepth maxDepth stretchDepth check longLivedTree iterations |
   minDepth := 4.
   maxDepth := minDepth + 2 max: n.
   stretchDepth := maxDepth + 1.

   check := (SMarkTreeNode bottomUpTree: 0 depth: stretchDepth) itemCheck.
  
   longLivedTree := SMarkTreeNode bottomUpTree: 0 depth: maxDepth.
   minDepth to: maxDepth by: 2 do: [:depth|
      iterations := 1 bitShift: maxDepth - depth + minDepth.

      check := 0.
      1 to: iterations do: [:i|
         check := check + (SMarkTreeNode bottomUpTree: i depth: depth) itemCheck.
         check := check + (SMarkTreeNode bottomUpTree: -1*i depth: depth) itemCheck
         ].
      ].! !

Benchmark subclass: #SMarkBlowfishBenchmark
	instanceVariableNames: 'blowfish'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkBlowfishBenchmark methodsFor: 'as yet unclassified' stamp: 'BS 1/28/2014 13:31'!
benchBlowfish
	blowfish longEncryptionTest.
	blowfish longDecryptionTest.! !

!SMarkBlowfishBenchmark methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:32'!
setUp
	blowfish := SMarkBlowfishProfiling new.! !

Benchmark subclass: #SMarkCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkCompiler class methodsFor: 'script entry' stamp: ''!
defaultNumberOfIterations
	^ 50! !

!SMarkCompiler class methodsFor: 'script entry' stamp: ''!
defaultNumberOfProcesses
	^ 8! !

!SMarkCompiler methodsFor: 'benchmarking' stamp: ''!
benchCompiler
	"was Benchmark>>testCompiler"
	SMarkCompilerTargetClass new compile:
		'somethingDummy: aBlock repeated: nTimes | i emptyBlock emptyTime blockTime |
		nTimes > 1000 ifTrue: [^self time: aBlock repeatedK: nTimes // 1000].
		emptyBlock := [].
		emptyTime := Time millisecondsToRun:
						[i := 0.
						 [(i := i + 1) <= nTimes] whileTrue: [emptyBlock value]].
		blockTime := Time millisecondsToRun:
						[i := 0.
						 [(i := i + 1) <= nTimes] whileTrue: [aBlock value]].
		^blockTime - emptyTime'.! !

Benchmark subclass: #SMarkDeltaBlue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkDeltaBlue commentStamp: '<historical>' prior: 0!
One-way constraint solver Benchmark. The main focus in DeltaBlue is on polymorphism and object-oriented programming

To run the benchmark, execute the expression 'SMarkDeltaBlue run'.!

!SMarkDeltaBlue methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:09'!
benchDeltaBlue
	"This the combined benchmark."
	
	| n |
	
	n := self problemSize.
	
	SMarkPlanner initialize.
	SMarkPlanner chainTest: n.
	SMarkPlanner projectionTest: n.
	^ true! !

!SMarkDeltaBlue methodsFor: 'defaults' stamp: 'ClementBera 9/23/2013 11:18'!
defaultProblemSize
	^ 5000! !

!SMarkDeltaBlue methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 11:05'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

Benchmark subclass: #SMarkFannkuch
	instanceVariableNames: 'timesRotated perm atEnd'
	classVariableNames: 'Results'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-SOM'!

!SMarkFannkuch class methodsFor: 'as yet unclassified' stamp: 'tfel 5/11/2015 15:46'!
expectedResult: problemSize
      Results isNil ifTrue: [
        Results := Array new: 12.
        Results at:  1 put:  0.
        Results at:  2 put:  1.
        Results at:  3 put:  2.
        Results at:  4 put:  4.
        Results at:  5 put:  7.
        Results at:  6 put: 10.
        Results at:  7 put: 16.
        Results at:  8 put: 22.
        Results at:  9 put: 30.
        Results at: 10 put: 38.
        Results at: 11 put: 51.
        Results at: 12 put: 65.
      ].
      ^ Results at: problemSize! !

!SMarkFannkuch methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 16:23'!
atEnd
        ^atEnd! !

!SMarkFannkuch methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:25'!
benchFannkuch
		| result |
      self initialize: self problemSize.
      result := self maxPfannkuchen.
      ^ result = (SMarkFannkuch expectedResult: self problemSize)! !

!SMarkFannkuch methodsFor: 'initialization' stamp: 'StefanMarr 4/3/2015 16:31'!
initialize: size
	perm := Array new: size.
	1 to: size do: [:i | perm at: i put: i ].
	timesRotated := Array new: size withAll: 0.
	atEnd := false! !

!SMarkFannkuch methodsFor: 'benchmarking' stamp: 'tfel 4/10/2015 11:17'!
innerBenchmarkLoop
		| result |
      self initialize: innerIterations.
      result := self maxPfannkuchen.
      ^ result = (SomFannkuch expectedResult: innerIterations).! !

!SMarkFannkuch methodsFor: 'initialize-release' stamp: 'tfel 5/15/2015 11:45'!
makeNext
	| temp remainder |
	"* Generate the next permutation. *"
	2 to: perm size do: [ :r |
		"* Rotate the first r items to the left. *"
		temp := perm at: 1.
		1 to: r - 1 do: [ :i | perm at: i put: (perm at: i + 1) ].
		perm at: r put: temp.

		timesRotated at: r put: ((timesRotated at: r) + 1) \\ r.
		remainder := timesRotated at: r.
		remainder = 0 ifFalse: [ ^self ].

		"* After r rotations, the first r items are in their original positions.
		 Go on rotating the first r+1 items. *"
	].

	"* We are past the final permutation. *"
	atEnd := true.! !

!SMarkFannkuch methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 16:23'!
maxPfannkuchen
        | max permutation |
        max := 0.
        [self atEnd] whileFalse: [
            permutation := self next.
            max := max max: (self pfannkuchen: permutation)].
        ^max! !

!SMarkFannkuch methodsFor: 'accessing' stamp: 'StefanMarr 4/3/2015 16:24'!
next
        | result |
        result := perm copy.
        self makeNext.
        ^result! !

!SMarkFannkuch methodsFor: 'benchmarking' stamp: 'StefanMarr 4/3/2015 16:21'!
pfannkuchen: anArray
	| first complement a b k |
	k := 0.
	[ (first := anArray at: 1) = 1 ] whileFalse: [
		k := k + 1.
		complement := first + 1.

		1 to: first / 2 do: [ :i |
			a := anArray at: i.
			b := anArray at: complement - i.
			anArray at: i put: b.
			anArray at: complement - i put: a.
	] ].
	^ k! !

Benchmark subclass: #SMarkGSGraphSearch
	instanceVariableNames: 'graphNodes graphMask updatingGraphMask graphVisited cost graphEdges k firstCost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-GraphSearch'!

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:37'!
ExpectedNoOfNodes
	^ 3000000! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:37'!
ExpectedTotalCost
	^ 26321966! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:36'!
MaxInitEdges
	^ 4! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:36'!
MaxNodes 
	^ 1 << 31! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:37'!
MaxWeight
	^ 1! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:36'!
MinEdges
	^ 2
! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:35'!
MinNodes
	^ 20! !

!SMarkGSGraphSearch class methodsFor: 'constants' stamp: 'StefanMarr 4/3/2015 15:36'!
MinWeight
	^ 1! !

!SMarkGSGraphSearch methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:46'!
benchGraphSearch
    | noOfNodes |
    SMarkGSJenkinsRandom new seed: 49734321.
    noOfNodes := SMarkGSGraphSearch ExpectedNoOfNodes / 1000 * self problemSize.

    self initializeGraph: noOfNodes.
    self breadthFirstSearch: noOfNodes.
    ^ cost! !

!SMarkGSGraphSearch methodsFor: 'helper' stamp: 'StefanMarr 4/3/2015 15:34'!
breadthFirstSearch: noOfNodes
    | stop |
    stop := true.
    [stop] whileTrue: [
      stop := false.
      
      1 to: noOfNodes do: [:tid |
        (graphMask at: tid) ifTrue: [
          graphMask at: tid put: false.
          (graphNodes at: tid) starting 
              to: ((graphNodes at: tid) noOfEdges + (graphNodes at: tid) starting) - 1
              do: [:i |
            | id |
            id := graphEdges at: i.
            (graphVisited at: id) ifFalse: [
              cost at: id put: (cost at: tid) + 1.
              updatingGraphMask at: id put: true.
            ]
          ]
        ]
      ].
      
      1 to: noOfNodes do: [:tid |
        (updatingGraphMask at: tid) ifTrue: [
          graphMask    at: tid put: true.
          graphVisited at: tid put: true.
          stop := true.
          updatingGraphMask at: tid put: false
        ]
      ]
    ]! !

!SMarkGSGraphSearch methodsFor: 'initialization' stamp: 'tfel 5/15/2015 11:47'!
initializeGraph: noOfNodes
    | source graph totalEdges |
    graphNodes        := Array new: noOfNodes.
    graphMask         := Array new: noOfNodes withAll: false.
    updatingGraphMask := Array new: noOfNodes withAll: false.
    graphVisited      := Array new: noOfNodes withAll: false.
    cost              := Array new: noOfNodes withAll: -1.

    source := 1.

    graph := Array new: noOfNodes.
    1 to: noOfNodes do: [:i | graph at: i put: OrderedCollection new ].

    1 to: noOfNodes do: [:i |
      | noOfEdges |
      noOfEdges := (SMarkGSJenkinsRandom new random
                       rem: SMarkGSGraphSearch MaxInitEdges - SMarkGSGraphSearch MinEdges + 1) abs
                   + SMarkGSGraphSearch MinEdges.
      1 to: noOfEdges do: [:j |
        | nodeId weight |
        nodeId := (SMarkGSJenkinsRandom random rem: noOfNodes) abs + 1.
        weight := (SMarkGSJenkinsRandom random rem: (
                    SMarkGSGraphSearch MaxWeight - SMarkGSGraphSearch MinWeight + 1)) abs
                  + SMarkGSGraphSearch MinWeight.
        (graph at: i)      append: (SMarkGSEdge newWith: nodeId and: weight).
        (graph at: nodeId) append: (SMarkGSEdge newWith:      i and: weight).
      ]
    ].

    totalEdges := 0.
    1 to: noOfNodes do: [:i |
      | noOfEdges |
      noOfEdges := (graph at: i) size.
      graphNodes at: i put: (SMarkGSNode newWith: totalEdges + 1 and: noOfEdges).
      totalEdges := totalEdges + noOfEdges
    ].

    graphMask    at: source put: true.
    graphVisited at: source put: true.

    graphEdges := Array new: totalEdges withAll: 0.
    
    k := 1.
    graph do: [:i |
      i do: [:j |
        graphEdges at: k put: j dest.
        k := k + 1.
      ]
    ].
    cost at: source put: 0.! !

!SMarkGSGraphSearch methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:28'!
verifyGraphSearch: result
    | totalCost |
    cost length = (SMarkGSGraphSearch ExpectedNoOfNodes / 1000 * self problemSize)
      ifFalse: [ ^ false ].

    totalCost := 0.    
    cost do: [:c | totalCost := totalCost + c].

    cost length = SMarkGSGraphSearch ExpectedNoOfNodes
      ifTrue:  [
        totalCost = SMarkGSGraphSearch ExpectedTotalCost ifFalse: [
          self error: 'ERROR: the total cost obtained for ', cost length asString,
              ' nodes is ', totalCost asString, ' while the expected cost is ',
              SMarkGSGraphSearch ExpectedTotalCost 
        ]]
      ifFalse: [
        firstCost == nil
          ifTrue: [
            firstCost := totalCost.
            ^ true ]
          ifFalse: [
            ^ firstCost = totalCost
          ]
      ].

    ^ true! !

Benchmark subclass: #SMarkJSJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Json'!

!SMarkJSJson class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/2/2015 22:45'!
RapBenchmarkMinified
	^ '{"head":{"requestCounter":4},"operations":[["destroy","w54"],["set","w2",{"activeControl":"w99"}],["set","w21",{"customVariant":"variant_navigation"}],["set","w28",{"customVariant":"variant_selected"}],["set","w53",{"children":["w95"]}],["create","w95","rwt.widgets.Composite",{"parent":"w53","style":["NONE"],"bounds":[0,0,1008,586],"children":["w96","w97"],"tabIndex":-1,"clientArea":[0,0,1008,586]}],["create","w96","rwt.widgets.Label",{"parent":"w95","style":["NONE"],"bounds":[10,30,112,26],"tabIndex":-1,"customVariant":"variant_pageHeadline","text":"TableViewer"}],["create","w97","rwt.widgets.Composite",{"parent":"w95","style":["NONE"],"bounds":[0,61,1008,525],"children":["w98","w99","w226","w228"],"tabIndex":-1,"clientArea":[0,0,1008,525]}],["create","w98","rwt.widgets.Text",{"parent":"w97","style":["LEFT","SINGLE","BORDER"],"bounds":[10,10,988,32],"tabIndex":22,"activeKeys":["#13","#27","#40"]}],["listen","w98",{"KeyDown":true,"Modify":true}],["create","w99","rwt.widgets.Grid",{"parent":"w97","style":["SINGLE","BORDER"],"appearance":"table","indentionWidth":0,"treeColumn":-1,"markupEnabled":false}],["create","w100","rwt.widgets.ScrollBar",{"parent":"w99","style":["HORIZONTAL"]}],["create","w101","rwt.widgets.ScrollBar",{"parent":"w99","style":["VERTICAL"]}],["set","w99",{"bounds":[10,52,988,402],"children":[],"tabIndex":23,"activeKeys":["CTRL+#70","CTRL+#78","CTRL+#82","CTRL+#89","CTRL+#83","CTRL+#71","CTRL+#69"],"cancelKeys":["CTRL+#70","CTRL+#78","CTRL+#82","CTRL+#89","CTRL+#83","CTRL+#71","CTRL+#69"]}],["listen","w99",{"MouseDown":true,"MouseUp":true,"MouseDoubleClick":true,"KeyDown":true}],["set","w99",{"itemCount":118,"itemHeight":28,"itemMetrics":[[0,0,50,3,0,3,44],[1,50,50,53,0,53,44],[2,100,140,103,0,103,134],[3,240,180,243,0,243,174],[4,420,50,423,0,423,44],[5,470,50,473,0,473,44]],"columnCount":6,"headerHeight":35,"headerVisible":true,"linesVisible":true,"focusItem":"w108","selection":["w108"]}],["listen","w99",{"Selection":true,"DefaultSelection":true}],["set","w99",{"enableCellToolTip":true}],["listen","w100",{"Selection":true}],["set","w101",{"visibility":true}],["listen","w101",{"Selection":true}],["create","w102","rwt.widgets.GridColumn",{"parent":"w99","text":"Nr.","width":50,"moveable":true}],["listen","w102",{"Selection":true}],["create","w103","rwt.widgets.GridColumn",{"parent":"w99","text":"Sym.","index":1,"left":50,"width":50,"moveable":true}],["listen","w103",{"Selection":true}],["create","w104","rwt.widgets.GridColumn",{"parent":"w99","text":"Name","index":2,"left":100,"width":140,"moveable":true}],["listen","w104",{"Selection":true}],["create","w105","rwt.widgets.GridColumn",{"parent":"w99","text":"Series","index":3,"left":240,"width":180,"moveable":true}],["listen","w105",{"Selection":true}],["create","w106","rwt.widgets.GridColumn",{"parent":"w99","text":"Group","index":4,"left":420,"width":50,"moveable":true}],["listen","w106",{"Selection":true}],["create","w107","rwt.widgets.GridColumn",{"parent":"w99","text":"Period","index":5,"left":470,"width":50,"moveable":true}],["listen","w107",{"Selection":true}],["create","w108","rwt.widgets.GridItem",{"parent":"w99","index":0,"texts":["1","H","Hydrogen","Nonmetal","1","1"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w109","rwt.widgets.GridItem",{"parent":"w99","index":1,"texts":["2","He","Helium","Noble gas","18","1"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w110","rwt.widgets.GridItem",{"parent":"w99","index":2,"texts":["3","Li","Lithium","Alkali metal","1","2"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w111","rwt.widgets.GridItem",{"parent":"w99","index":3,"texts":["4","Be","Beryllium","Alkaline earth metal","2","2"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w112","rwt.widgets.GridItem",{"parent":"w99","index":4,"texts":["5","B","Boron","Metalloid","13","2"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w113","rwt.widgets.GridItem",{"parent":"w99","index":5,"texts":["6","C","Carbon","Nonmetal","14","2"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w114","rwt.widgets.GridItem",{"parent":"w99","index":6,"texts":["7","N","Nitrogen","Nonmetal","15","2"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w115","rwt.widgets.GridItem",{"parent":"w99","index":7,"texts":["8","O","Oxygen","Nonmetal","16","2"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w116","rwt.widgets.GridItem",{"parent":"w99","index":8,"texts":["9","F","Fluorine","Halogen","17","2"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w117","rwt.widgets.GridItem",{"parent":"w99","index":9,"texts":["10","Ne","Neon","Noble gas","18","2"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w118","rwt.widgets.GridItem",{"parent":"w99","index":10,"texts":["11","Na","Sodium","Alkali metal","1","3"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w119","rwt.widgets.GridItem",{"parent":"w99","index":11,"texts":["12","Mg","Magnesium","Alkaline earth metal","2","3"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w120","rwt.widgets.GridItem",{"parent":"w99","index":12,"texts":["13","Al","Aluminium","Poor metal","13","3"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w121","rwt.widgets.GridItem",{"parent":"w99","index":13,"texts":["14","Si","Silicon","Metalloid","14","3"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w122","rwt.widgets.GridItem",{"parent":"w99","index":14,"texts":["15","P","Phosphorus","Nonmetal","15","3"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w123","rwt.widgets.GridItem",{"parent":"w99","index":15,"texts":["16","S","Sulfur","Nonmetal","16","3"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w124","rwt.widgets.GridItem",{"parent":"w99","index":16,"texts":["17","Cl","Chlorine","Halogen","17","3"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w125","rwt.widgets.GridItem",{"parent":"w99","index":17,"texts":["18","Ar","Argon","Noble gas","18","3"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w126","rwt.widgets.GridItem",{"parent":"w99","index":18,"texts":["19","K","Potassium","Alkali metal","1","4"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w127","rwt.widgets.GridItem",{"parent":"w99","index":19,"texts":["20","Ca","Calcium","Alkaline earth metal","2","4"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w128","rwt.widgets.GridItem",{"parent":"w99","index":20,"texts":["21","Sc","Scandium","Transition metal","3","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w129","rwt.widgets.GridItem",{"parent":"w99","index":21,"texts":["22","Ti","Titanium","Transition metal","4","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w130","rwt.widgets.GridItem",{"parent":"w99","index":22,"texts":["23","V","Vanadium","Transition metal","5","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w131","rwt.widgets.GridItem",{"parent":"w99","index":23,"texts":["24","Cr","Chromium","Transition metal","6","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w132","rwt.widgets.GridItem",{"parent":"w99","index":24,"texts":["25","Mn","Manganese","Transition metal","7","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w133","rwt.widgets.GridItem",{"parent":"w99","index":25,"texts":["26","Fe","Iron","Transition metal","8","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w134","rwt.widgets.GridItem",{"parent":"w99","index":26,"texts":["27","Co","Cobalt","Transition metal","9","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w135","rwt.widgets.GridItem",{"parent":"w99","index":27,"texts":["28","Ni","Nickel","Transition metal","10","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w136","rwt.widgets.GridItem",{"parent":"w99","index":28,"texts":["29","Cu","Copper","Transition metal","11","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w137","rwt.widgets.GridItem",{"parent":"w99","index":29,"texts":["30","Zn","Zinc","Transition metal","12","4"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w138","rwt.widgets.GridItem",{"parent":"w99","index":30,"texts":["31","Ga","Gallium","Poor metal","13","4"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w139","rwt.widgets.GridItem",{"parent":"w99","index":31,"texts":["32","Ge","Germanium","Metalloid","14","4"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w140","rwt.widgets.GridItem",{"parent":"w99","index":32,"texts":["33","As","Arsenic","Metalloid","15","4"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w141","rwt.widgets.GridItem",{"parent":"w99","index":33,"texts":["34","Se","Selenium","Nonmetal","16","4"],"cellBackgrounds":[null,null,null,[138,226,52,255],null,null]}],["create","w142","rwt.widgets.GridItem",{"parent":"w99","index":34,"texts":["35","Br","Bromine","Halogen","17","4"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w143","rwt.widgets.GridItem",{"parent":"w99","index":35,"texts":["36","Kr","Krypton","Noble gas","18","4"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w144","rwt.widgets.GridItem",{"parent":"w99","index":36,"texts":["37","Rb","Rubidium","Alkali metal","1","5"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w145","rwt.widgets.GridItem",{"parent":"w99","index":37,"texts":["38","Sr","Strontium","Alkaline earth metal","2","5"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w146","rwt.widgets.GridItem",{"parent":"w99","index":38,"texts":["39","Y","Yttrium","Transition metal","3","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w147","rwt.widgets.GridItem",{"parent":"w99","index":39,"texts":["40","Zr","Zirconium","Transition metal","4","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w148","rwt.widgets.GridItem",{"parent":"w99","index":40,"texts":["41","Nb","Niobium","Transition metal","5","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w149","rwt.widgets.GridItem",{"parent":"w99","index":41,"texts":["42","Mo","Molybdenum","Transition metal","6","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w150","rwt.widgets.GridItem",{"parent":"w99","index":42,"texts":["43","Tc","Technetium","Transition metal","7","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w151","rwt.widgets.GridItem",{"parent":"w99","index":43,"texts":["44","Ru","Ruthenium","Transition metal","8","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w152","rwt.widgets.GridItem",{"parent":"w99","index":44,"texts":["45","Rh","Rhodium","Transition metal","9","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w153","rwt.widgets.GridItem",{"parent":"w99","index":45,"texts":["46","Pd","Palladium","Transition metal","10","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w154","rwt.widgets.GridItem",{"parent":"w99","index":46,"texts":["47","Ag","Silver","Transition metal","11","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w155","rwt.widgets.GridItem",{"parent":"w99","index":47,"texts":["48","Cd","Cadmium","Transition metal","12","5"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w156","rwt.widgets.GridItem",{"parent":"w99","index":48,"texts":["49","In","Indium","Poor metal","13","5"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w157","rwt.widgets.GridItem",{"parent":"w99","index":49,"texts":["50","Sn","Tin","Poor metal","14","5"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w158","rwt.widgets.GridItem",{"parent":"w99","index":50,"texts":["51","Sb","Antimony","Metalloid","15","5"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w159","rwt.widgets.GridItem",{"parent":"w99","index":51,"texts":["52","Te","Tellurium","Metalloid","16","5"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w160","rwt.widgets.GridItem",{"parent":"w99","index":52,"texts":["53","I","Iodine","Halogen","17","5"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w161","rwt.widgets.GridItem",{"parent":"w99","index":53,"texts":["54","Xe","Xenon","Noble gas","18","5"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w162","rwt.widgets.GridItem",{"parent":"w99","index":54,"texts":["55","Cs","Caesium","Alkali metal","1","6"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w163","rwt.widgets.GridItem",{"parent":"w99","index":55,"texts":["56","Ba","Barium","Alkaline earth metal","2","6"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w164","rwt.widgets.GridItem",{"parent":"w99","index":56,"texts":["57","La","Lanthanum","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w165","rwt.widgets.GridItem",{"parent":"w99","index":57,"texts":["58","Ce","Cerium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w166","rwt.widgets.GridItem",{"parent":"w99","index":58,"texts":["59","Pr","Praseodymium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w167","rwt.widgets.GridItem",{"parent":"w99","index":59,"texts":["60","Nd","Neodymium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w168","rwt.widgets.GridItem",{"parent":"w99","index":60,"texts":["61","Pm","Promethium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w169","rwt.widgets.GridItem",{"parent":"w99","index":61,"texts":["62","Sm","Samarium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w170","rwt.widgets.GridItem",{"parent":"w99","index":62,"texts":["63","Eu","Europium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w171","rwt.widgets.GridItem",{"parent":"w99","index":63,"texts":["64","Gd","Gadolinium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w172","rwt.widgets.GridItem",{"parent":"w99","index":64,"texts":["65","Tb","Terbium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w173","rwt.widgets.GridItem",{"parent":"w99","index":65,"texts":["66","Dy","Dysprosium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w174","rwt.widgets.GridItem",{"parent":"w99","index":66,"texts":["67","Ho","Holmium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w175","rwt.widgets.GridItem",{"parent":"w99","index":67,"texts":["68","Er","Erbium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w176","rwt.widgets.GridItem",{"parent":"w99","index":68,"texts":["69","Tm","Thulium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w177","rwt.widgets.GridItem",{"parent":"w99","index":69,"texts":["70","Yb","Ytterbium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w178","rwt.widgets.GridItem",{"parent":"w99","index":70,"texts":["71","Lu","Lutetium","Lanthanide","3","6"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w179","rwt.widgets.GridItem",{"parent":"w99","index":71,"texts":["72","Hf","Hafnium","Transition metal","4","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w180","rwt.widgets.GridItem",{"parent":"w99","index":72,"texts":["73","Ta","Tantalum","Transition metal","5","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w181","rwt.widgets.GridItem",{"parent":"w99","index":73,"texts":["74","W","Tungsten","Transition metal","6","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w182","rwt.widgets.GridItem",{"parent":"w99","index":74,"texts":["75","Re","Rhenium","Transition metal","7","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w183","rwt.widgets.GridItem",{"parent":"w99","index":75,"texts":["76","Os","Osmium","Transition metal","8","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w184","rwt.widgets.GridItem",{"parent":"w99","index":76,"texts":["77","Ir","Iridium","Transition metal","9","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w185","rwt.widgets.GridItem",{"parent":"w99","index":77,"texts":["78","Pt","Platinum","Transition metal","10","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w186","rwt.widgets.GridItem",{"parent":"w99","index":78,"texts":["79","Au","Gold","Transition metal","11","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w187","rwt.widgets.GridItem",{"parent":"w99","index":79,"texts":["80","Hg","Mercury","Transition metal","12","6"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w188","rwt.widgets.GridItem",{"parent":"w99","index":80,"texts":["81","Tl","Thallium","Poor metal","13","6"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w189","rwt.widgets.GridItem",{"parent":"w99","index":81,"texts":["82","Pb","Lead","Poor metal","14","6"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w190","rwt.widgets.GridItem",{"parent":"w99","index":82,"texts":["83","Bi","Bismuth","Poor metal","15","6"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w191","rwt.widgets.GridItem",{"parent":"w99","index":83,"texts":["84","Po","Polonium","Metalloid","16","6"],"cellBackgrounds":[null,null,null,[156,159,153,255],null,null]}],["create","w192","rwt.widgets.GridItem",{"parent":"w99","index":84,"texts":["85","At","Astatine","Halogen","17","6"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w193","rwt.widgets.GridItem",{"parent":"w99","index":85,"texts":["86","Rn","Radon","Noble gas","18","6"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w194","rwt.widgets.GridItem",{"parent":"w99","index":86,"texts":["87","Fr","Francium","Alkali metal","1","7"],"cellBackgrounds":[null,null,null,[239,41,41,255],null,null]}],["create","w195","rwt.widgets.GridItem",{"parent":"w99","index":87,"texts":["88","Ra","Radium","Alkaline earth metal","2","7"],"cellBackgrounds":[null,null,null,[233,185,110,255],null,null]}],["create","w196","rwt.widgets.GridItem",{"parent":"w99","index":88,"texts":["89","Ac","Actinium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w197","rwt.widgets.GridItem",{"parent":"w99","index":89,"texts":["90","Th","Thorium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w198","rwt.widgets.GridItem",{"parent":"w99","index":90,"texts":["91","Pa","Protactinium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w199","rwt.widgets.GridItem",{"parent":"w99","index":91,"texts":["92","U","Uranium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w200","rwt.widgets.GridItem",{"parent":"w99","index":92,"texts":["93","Np","Neptunium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w201","rwt.widgets.GridItem",{"parent":"w99","index":93,"texts":["94","Pu","Plutonium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w202","rwt.widgets.GridItem",{"parent":"w99","index":94,"texts":["95","Am","Americium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w203","rwt.widgets.GridItem",{"parent":"w99","index":95,"texts":["96","Cm","Curium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w204","rwt.widgets.GridItem",{"parent":"w99","index":96,"texts":["97","Bk","Berkelium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w205","rwt.widgets.GridItem",{"parent":"w99","index":97,"texts":["98","Cf","Californium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w206","rwt.widgets.GridItem",{"parent":"w99","index":98,"texts":["99","Es","Einsteinium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w207","rwt.widgets.GridItem",{"parent":"w99","index":99,"texts":["100","Fm","Fermium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w208","rwt.widgets.GridItem",{"parent":"w99","index":100,"texts":["101","Md","Mendelevium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w209","rwt.widgets.GridItem",{"parent":"w99","index":101,"texts":["102","No","Nobelium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w210","rwt.widgets.GridItem",{"parent":"w99","index":102,"texts":["103","Lr","Lawrencium","Actinide","3","7"],"cellBackgrounds":[null,null,null,[173,127,168,255],null,null]}],["create","w211","rwt.widgets.GridItem",{"parent":"w99","index":103,"texts":["104","Rf","Rutherfordium","Transition metal","4","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w212","rwt.widgets.GridItem",{"parent":"w99","index":104,"texts":["105","Db","Dubnium","Transition metal","5","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w213","rwt.widgets.GridItem",{"parent":"w99","index":105,"texts":["106","Sg","Seaborgium","Transition metal","6","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w214","rwt.widgets.GridItem",{"parent":"w99","index":106,"texts":["107","Bh","Bohrium","Transition metal","7","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w215","rwt.widgets.GridItem",{"parent":"w99","index":107,"texts":["108","Hs","Hassium","Transition metal","8","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w216","rwt.widgets.GridItem",{"parent":"w99","index":108,"texts":["109","Mt","Meitnerium","Transition metal","9","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w217","rwt.widgets.GridItem",{"parent":"w99","index":109,"texts":["110","Ds","Darmstadtium","Transition metal","10","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w218","rwt.widgets.GridItem",{"parent":"w99","index":110,"texts":["111","Rg","Roentgenium","Transition metal","11","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w219","rwt.widgets.GridItem",{"parent":"w99","index":111,"texts":["112","Uub","Ununbium","Transition metal","12","7"],"cellBackgrounds":[null,null,null,[252,175,62,255],null,null]}],["create","w220","rwt.widgets.GridItem",{"parent":"w99","index":112,"texts":["113","Uut","Ununtrium","Poor metal","13","7"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w221","rwt.widgets.GridItem",{"parent":"w99","index":113,"texts":["114","Uuq","Ununquadium","Poor metal","14","7"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w222","rwt.widgets.GridItem",{"parent":"w99","index":114,"texts":["115","Uup","Ununpentium","Poor metal","15","7"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w223","rwt.widgets.GridItem",{"parent":"w99","index":115,"texts":["116","Uuh","Ununhexium","Poor metal","16","7"],"cellBackgrounds":[null,null,null,[238,238,236,255],null,null]}],["create","w224","rwt.widgets.GridItem",{"parent":"w99","index":116,"texts":["117","Uus","Ununseptium","Halogen","17","7"],"cellBackgrounds":[null,null,null,[252,233,79,255],null,null]}],["create","w225","rwt.widgets.GridItem",{"parent":"w99","index":117,"texts":["118","Uuo","Ununoctium","Noble gas","18","7"],"cellBackgrounds":[null,null,null,[114,159,207,255],null,null]}],["create","w226","rwt.widgets.Composite",{"parent":"w97","style":["BORDER"],"bounds":[10,464,988,25],"children":["w227"],"tabIndex":-1,"clientArea":[0,0,986,23]}],["create","w227","rwt.widgets.Label",{"parent":"w226","style":["NONE"],"bounds":[10,10,966,3],"tabIndex":-1,"text":"Hydrogen (H)"}],["create","w228","rwt.widgets.Label",{"parent":"w97","style":["WRAP"],"bounds":[10,499,988,16],"tabIndex":-1,"foreground":[150,150,150,255],"font":[["Verdana","Lucida Sans","Arial","Helvetica","sans-serif"],10,false,false],"text":"Shortcuts: [CTRL+F] - Filter | Sort by: [CTRL+R] - Number, [CTRL+Y] - Symbol, [CTRL+N] - Name, [CTRL+S] - Series, [CTRL+G] - Group, [CTRL+E] - Period"}],["set","w1",{"focusControl":"w99"}],["call","rwt.client.BrowserNavigation","addToHistory",{"entries":[["tableviewer","TableViewer"]]}]]}'
    ! !

!SMarkJSJson methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:35'!
benchJson
	^ (SMarkJSJsonParser with: SMarkJSJson RapBenchmarkMinified) parse! !

!SMarkJSJson methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 11:37'!
verifyJson: result
	result class = SMarkJSParseException ifTrue: [ result println ].
	result isObject ifFalse: [^ false].
	(result asObject at: 'head') isObject ifFalse: [^ false].
	(result asObject at: 'operations') isArray ifFalse: [^ false].
	^ (result asObject at: 'operations') asArray size = 156! !

Benchmark subclass: #SMarkLoops
	instanceVariableNames: 'someInstVar dnuObject methodObject methodObjectRcvr'
	classVariableNames: 'ClassVarValue'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkLoops commentStamp: '<historical>' prior: 0!
SMarkLoops implements a set of microbenchmarks measuring a number of basic aspects such as message send, instance field access, and array access cost.

Example use:
  (SMarkLoops new runOnly: #benchFloatLoop) run: 10 !

!SMarkLoops class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2015 14:05'!
defaultProblemSize
	^ 10000000! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/12/2012 13:23'!
benchArrayAccess
	| i obj array |
	
	array := Array new: 1.
	obj   := Object new.
	
	i := self problemSize.
	[i > 0] whileTrue: [
		array at: 1.
		array at: 1 put: obj.
		
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 16:55'!
benchClassVarBinding
	| i r |
	i := self problemSize.
	[i > 0] whileTrue: [
		r := ClassVarValue.
		ClassVarValue := nil.

		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 11:48'!
benchDoesNotUnderstand
	| i |
	i := self problemSize.
	[i > 0] whileTrue: [
		dnuObject sendAMessageThatWeDoNotUnderstand.
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 16:56'!
benchFloatLoop
	| a limit |
	a := 1.23.
	limit := self problemSize.
	[a < limit] whileTrue: [
		a := a + 0.6.
		a := a + 0.4.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 10:09'!
benchInstVarAccess
	| i r |
	i := self problemSize.
	someInstVar := 12.
	[i > 0] whileTrue: [
		r := someInstVar.
		someInstVar := nil.

		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 16:56'!
benchIntLoop
	| i |
	i := self problemSize.
	[i > 0] whileTrue: [
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 11:53'!
benchObjectAsMethod
	| i |
	i := self problemSize.
	[i > 0] whileTrue: [
		methodObjectRcvr oam.
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 16:56'!
benchSend
	| i r |
	i := self problemSize.
	[i > 0] whileTrue: [
		self doNothing.
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 11:54'!
benchSendPrimitive
	| i |
	i := self problemSize.
	[i > 0] whileTrue: [
		self identityHash.
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 16:56'!
benchSendWithManyArguments
	| i r |
	i := self problemSize.
	[i > 0] whileTrue: [
		self doNothingA: i b: i c: i d: i e: i f: i g: i h: i i: i j: i.
		i := i - 1.
	].! !

!SMarkLoops methodsFor: 'helper' stamp: 'StefanMarr 1/10/2012 10:32'!
doNothing! !

!SMarkLoops methodsFor: 'helper' stamp: 'StefanMarr 1/10/2012 10:35'!
doNothingA: p1 b: p2 c: p3 d: p4 e: p5 f: p6 g: p7 h: p8 i: p9 j: p10! !

!SMarkLoops methodsFor: 'running' stamp: 'tfel 4/26/2016 11:56'!
setUp

	dnuObject := SMarkLoopsDNUObject new.
	methodObject := SMarkLoopsMethodObject new.
	SMarkLoopsMethodObjectReceiver methodDict at: #oam put: methodObject.
	#oam flushCache.
	methodObjectRcvr := SMarkLoopsMethodObjectReceiver new.! !

!SMarkLoops methodsFor: 'running' stamp: 'tfel 4/26/2016 12:23'!
tearDown

	SMarkLoopsMethodObjectReceiver methodDict removeKey: #oam ifAbsent: [].! !

Benchmark subclass: #SMarkMailinglistMicroBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Micro'!

!SMarkMailinglistMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:49'!
benchByteStringHash
	| s | 
	s := ByteString
			with: (Character value: 16rE4) with: (Character value: 16rE4) 
			with: (Character value: 16rE4) with: (Character value: 16rE4). 
	100000 timesRepeat: [s hash].

! !

!SMarkMailinglistMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:54'!
benchLRUCachePrintString
	| c |
	c := LRUCache size: 60 factory: [:key | key * 2].
	1 to: 60 do: [:each | c at: each].
	(c instVarNamed: #head) printString size! !

!SMarkMailinglistMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:56'!
benchOrderedCollectionInsertFirst

	| c |
	c  := OrderedCollection new: 100000.
	1 to: 10000 do: [ :i | c addFirst: i ].! !

!SMarkMailinglistMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:56'!
benchOrderedCollectionRandomInsert
	
	| c |
 	c  := OrderedCollection new.
	c add: 1.
 	2 to: 10000 do: [ :i | c add: i beforeIndex: (c atRandom) ].! !

!SMarkMailinglistMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:49'!
benchWideStringHash
	| s |
	s := WideString with: (Character value: 16r55E4). 
	100000 timesRepeat: [s hash].

! !

Benchmark subclass: #SMarkMandelbrot
	instanceVariableNames: 'firstResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-SOM'!

!SMarkMandelbrot methodsFor: 'as yet unclassified' stamp: 'test 4/21/2016 08:56'!
benchMandelbrot
	^ self mandelbrot: self problemSize! !

!SMarkMandelbrot methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 16:46'!
mandelbrot: size
        | sum byteAcc bitNum y |
        sum     := 0.
        byteAcc := 0.
        bitNum  := 0.
  
        y := 0.
        
        [y < size] whileTrue: [
            | ci x |
            ci := (2.0 * y / size) - 1.0.
            x  := 0.
            
            [x < size] whileTrue: [
                | zr zrzr zi zizi cr escape z notDone |
                zrzr := zr := 0.0.
                zizi := zi := 0.0.
                cr   := (2.0 * x / size) - 1.5.
                
                z := 0.
                notDone := true.
                escape := 0.
                [notDone and: [z < 50]] whileTrue: [
                    zr := zrzr - zizi + cr.
                    zi := 2.0 * zr * zi + ci.
            
                    "preserve recalculation"
                    zrzr := zr * zr.
                    zizi := zi * zi.
            
                    (zrzr + zizi > 4.0) ifTrue: [
                        notDone := false.
                        escape  := 1.
                    ].
                    z := z + 1.
                ].
  
                byteAcc := (byteAcc << 1) + escape.
                bitNum  := bitNum + 1.
  
                " Code is very similar for these cases, but using separate blocks
                  ensures we skip the shifting when it's unnecessary,
                  which is most cases. "
                bitNum = 8 
                    ifTrue: [
                      sum := sum bitXor: byteAcc.
                      byteAcc := 0.
                      bitNum  := 0. ]
                    ifFalse: [
                      (x = (size - 1)) ifTrue: [
                          byteAcc := byteAcc << (8 - bitNum).
                          sum := sum bitXor: byteAcc.
                          byteAcc := 0.
                          bitNum  := 0. ]].
                x := x + 1.
            ].
            y := y + 1.
        ].
        
        ^ sum! !

!SMarkMandelbrot methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/3/2015 16:44'!
verifymark: result
	  self problemSize = 750 ifTrue: [
        ^ result = 50
      ].
      firstResult isNil ifTrue: [
        firstResult := result.
      ].
      ^ result = firstResult! !

Benchmark subclass: #SMarkMandelbrotBenchmark
	instanceVariableNames: 'mandelbrotMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotIterative1Thread
	mandelbrotMorph
		mode: #iterative;
		threadCount: 1;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotIterative2Thread
	mandelbrotMorph
		mode: #iterative;
		threadCount: 2;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotIterative4Thread
	mandelbrotMorph
		mode: #iterative;
		threadCount: 4;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotIterative8Thread
	mandelbrotMorph
		mode: #iterative;
		threadCount: 8;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotRecursive1Thread
	mandelbrotMorph
		mode: #recursive;
		threadCount: 1;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotRecursive2Thread
	mandelbrotMorph
		mode: #recursive;
		threadCount: 2;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:18'!
benchMandelbrotRecursive4Thread
	mandelbrotMorph
		mode: #recursive;
		threadCount: 4;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'benchmarking' stamp: 'MP 1/27/2014 14:19'!
benchMandelbrotRecursive8Thread
	mandelbrotMorph
		mode: #recursive;
		threadCount: 8;
		reCalculate .
	! !

!SMarkMandelbrotBenchmark methodsFor: 'initialize-release' stamp: 'tfel 6/2/2015 10:35'!
setUp
	mandelbrotMorph := SMarkMandelbrotMorph new.
	mandelbrotMorph
		extent: 50@50;
		depth: 85;
		imageBounds: ((-0.3@ -0.9) corner: (0.0 @ -0.6)).! !

Benchmark subclass: #SMarkNBody
	instanceVariableNames: 'expectedEnergy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-NBody'!

!SMarkNBody methodsFor: 'as yet unclassified' stamp: 'test 4/21/2016 09:00'!
benchNBody
	     | bodies |
        bodies := SMarkNBodySystem new.
        
        1 to: self problemSize do: [:i |
            bodies advance: 0.01.
        ].
        
        self problemSize = 250000 ifTrue: [
          ^ bodies energy = -0.1690859889909308
        ].
        expectedEnergy isNil ifTrue: [
          expectedEnergy := bodies energy.
          ^ true
        ].
        
        ^ expectedEnergy = bodies energy.! !

!SMarkNBody methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 11:29'!
initialize
	SMarkNBBody initialize! !

Benchmark subclass: #SMarkPolymorphyBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

SMarkPolymorphyBenchmark class
	instanceVariableNames: 'initials'!

SMarkPolymorphyBenchmark class
	instanceVariableNames: 'initials'!

!SMarkPolymorphyBenchmark class methodsFor: 'benchmarking' stamp: 'BS 1/21/2014 13:02'!
getImplementingClasses
	^{
		Object class.
		Morph class.
		Collection class.
		String class.
		FontSet class.
		Canvas class.
		Stream class.
		Number class.
		Behavior class.
		Error class.
	}! !

!SMarkPolymorphyBenchmark class methodsFor: 'benchmarking' stamp: 'BS 1/21/2014 13:04'!
run
	1 to: 300
		do: [:i| Object class allSubclasses
				do: [:mc | mc soleInstance test123polbench: i]]! !

!SMarkPolymorphyBenchmark class methodsFor: 'benchmarking' stamp: 'BS 1/21/2014 13:03'!
setUp
	initials := Utilities authorInitialsPerSe.
	Utilities setAuthorInitials: 'test'.
	self getImplementingClasses do: [:c |
		c compile: 'test1polbench: i ', String cr, '^''I am ', c name, ''', i asString'.
		c compile: 'test2polbench: i ', String cr, '^''I still am ', c name, ''', i asString'.
		c compile: 'test3polbench: i ', String cr, '^''I allways was ', c name, ''', i asString'.
		c compile: 'test123polbench: i ', String cr,
			'self test1polbench: i.', String cr,
			'self test2polbench: i.', String cr,
			'self test3polbench: i.'.
	].! !

!SMarkPolymorphyBenchmark class methodsFor: 'benchmarking' stamp: 'BS 1/21/2014 13:03'!
tearDown
	Utilities setAuthorInitials: initials.
	self getImplementingClasses do: [:c |
		c removeSelector: #test1polbench:.
		c removeSelector: #test2polbench:.
		c removeSelector: #test3polbench:.
		c removeSelector: #test123polbench:].! !

!SMarkPolymorphyBenchmark methodsFor: 'benchmarking' stamp: 'tfel 6/2/2015 10:30'!
benchPolymorphy
	self class run .! !

!SMarkPolymorphyBenchmark methodsFor: 'initialize-release' stamp: 'tfel 6/2/2015 10:30'!
setUp
	self class setUp .! !

!SMarkPolymorphyBenchmark methodsFor: 'initialize-release' stamp: 'tfel 6/2/2015 10:30'!
tearDown
	self class tearDown .! !

Benchmark subclass: #SMarkRSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-RSqueak'!

!SMarkRSqueak methodsFor: 'as yet unclassified' stamp: 'test 4/21/2016 08:57'!
benchBitBltColorMapping

	#( paint over ) do: [:rule|
		| destRect depths |
		destRect := 0@0 extent: 600@600.
		depths := #( 1 2 4 8 16 32 ).
		depths do:[:destDepth| | dest |
			depths do:[:sourceDepth| | bb source |
				dest := Form extent: destRect extent depth: destDepth.
				source := Form extent: destRect extent depth: sourceDepth.
				(source getCanvas) fillOval: dest boundingBox color: Color yellow borderWidth: 30 borderColor: Color black.
				bb := (WarpBlt toForm: dest)
					sourceForm: source;
					sourceRect: source boundingBox;
					destRect: dest boundingBox;
					colorMap: (source colormapIfNeededFor: dest);
					combinationRule: (Form perform: rule).
				self problemSize timesRepeat: [bb copyBits]]]].! !

!SMarkRSqueak methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 09:59'!
benchDSAGen

	| randomString |
	randomString := '4647912 April 2015''unix'''.
	self problemSize timesRepeat: [
		[DigitalSignatureAlgorithm new
			initRandomFromString: randomString;
			generateKeySet] timeToRun].! !

!SMarkRSqueak methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 09:59'!
benchRenderFont
	| height ttc glyphs |
	height := (TextStyle pointsToPixels: (12 * 1.2)) rounded.
	ttc := (TextStyle named: 'BitstreamVeraSerif') fontArray last ttcDescription.
	glyphs := (((1 to: ttc size - 1) collect: [:i | ttc at: i]) reject: [:g | g = ttc fallbackGlyph or: [g contours size = 0]]) first: 52.
	self problemSize timesRepeat: [
		glyphs do: [:g| 
			g asFormWithScale: (height asFloat / ttc fontHeight)
					ascender: ttc ascender 
					descender: ttc descender 
					fgColor: Color black bgColor: Color transparent depth: 32]].! !

!SMarkRSqueak methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 09:59'!
benchShaLongString

	| longString veryLongString |
	longString := (PackageInfo named: 'Help-Squeak-Project') postscript contents asString.
	veryLongString := String streamContents: [:s| 5 timesRepeat: [s nextPutAll: longString]].
	self problemSize timesRepeat: [SecureHashAlgorithm new hashMessage: veryLongString].! !

Benchmark subclass: #SMarkRichards
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Richards'!

!SMarkRichards commentStamp: '<historical>' prior: 0!
Richards is an OS kernel simulation benchmark, originally written in BCPL by Martin Richards. The main focus in Richards is on property access and calling functions and methods.!

!SMarkRichards methodsFor: 'benchs' stamp: 'tfel 5/15/2015 11:32'!
benchRichards

	SMarkRichObject initialize.
	^ SMarkRichRunner start! !

!SMarkRichards methodsFor: 'benchs' stamp: 'ClementBera 9/27/2013 15:56'!
defaultProblemSize
	^ 50! !

!SMarkRichards methodsFor: 'benchs' stamp: 'ClementBera 9/27/2013 15:56'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

!SMarkRichards methodsFor: 'benchs' stamp: 'StefanMarr 4/3/2015 14:12'!
verifyRichards: result
	^ result! !

Benchmark subclass: #SMarkShootout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

SMarkShootout class
	instanceVariableNames: 'fasta250000 fasta50000 fasta2500000'!

SMarkShootout class
	instanceVariableNames: 'fasta250000 fasta50000 fasta2500000'!

!SMarkShootout class methodsFor: 'accessing' stamp: 'tfel 4/27/2016 09:57'!
fasta250000

	^ fasta250000! !

!SMarkShootout class methodsFor: 'accessing' stamp: 'tfel 4/27/2016 10:06'!
fasta2500000

	^ fasta2500000! !

!SMarkShootout class methodsFor: 'accessing' stamp: 'tfel 4/27/2016 09:57'!
fasta50000

	^ fasta50000! !

!SMarkShootout class methodsFor: 'class initialization' stamp: 'tfel 4/27/2016 10:06'!
initialize
	"
	self initialize
	"
	fasta250000 := String new:  2541745 streamContents: [ :s | ShootoutTests fasta: 250000 to: s ].
	fasta2500000 := String new:  25416745 streamContents: [ :s | ShootoutTests fasta: 2500000 to: s ].
	fasta50000 := String new: 508411 streamContents: [ :s | ShootoutTests fasta: 50000 to: s ].! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutBinarytrees
    | stream |
   stream := NullStream new.
   ShootoutTests binarytrees: 16 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutChameneosRedux
    | stream |
   stream := NullStream new.
   ShootoutTests chameneosredux: 600000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutFannkuchRedux
    | stream |
   stream := NullStream new.
   ShootoutTests fannkuchRedux: 10 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutFasta
    | stream |
   stream := NullStream new.
   ShootoutTests fasta: 2500000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutFastaRedux
    | stream |
   stream := NullStream new.
   ShootoutTests fastaRedux: 2500000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:03'!
benchShootoutKnucleotide
    | stream |
   stream := NullStream new.
   ShootoutTests knucleotideFrom: self class fasta250000 readStream to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutMandelbrot3
    | stream |
   stream := NullStream new.
   ShootoutTests mandelbrot3: 1000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutMeteor
    | stream |
   stream := NullStream new.
   ShootoutTests meteor: 2098 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutNBody
    | stream |
   stream := NullStream new.
   ShootoutTests nbody: 500000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutPidigits
    | stream |
   stream := NullStream new.
   ShootoutTests pidigitsTo: 2000 width: 10 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutRegexDNA
    | stream |
   stream := NullStream new.
   ShootoutTests regexDNA: self class fasta50000 to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:06'!
benchShootoutReverseComplement
    | stream |
   stream := NullStream new.
   ShootoutTests reverseComplement: self class fasta2500000 readStream to: stream
! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutSpectralNorm
    | stream |
   stream := NullStream new.
   ShootoutTests spectralnorm: 500! !

!SMarkShootout methodsFor: 'benchmarks' stamp: 'tfel 4/27/2016 10:04'!
benchShootoutThreadring
    | stream |
   stream := NullStream new.
   ShootoutTests threadring: 5000000 to: stream! !

Benchmark subclass: #SMarkSlopstone
	instanceVariableNames: 'obj o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkSlopstone commentStamp: 'nishis 2/21/98 06:26' prior: 0!
modified for Squeak by nishis@urban.ne.jp
I added one class methods.
and modified execute method.  block variables are renamed for Squeak.
Thanx to Mr. Tim Olson, Mr. Kohler Markus, Mr. Tim Rowledge, Mr. John Maloney, Mr. Ian Piumarta.

original comments
	NAME			STones80
	AUTHOR			bruce@utafll.uta.edu (Bruce Samuelson)
	FUNCTION		low and medium level benchmarks for ST80 and ST/V
	ST-VERSIONS		pre R4.0, R4.0, R4.1, ST/V
	PREREQUISITES	need floating point hardware or emulation
	CONFLICTS		none
	DISTRIBUTION	world
	VERSION			1.0
	DATE			April 16, 1993

SUMMARY The filein includes two classes: Slopstones (Smalltalk Low level
OPeration Stones) and Smopstones (Smalltalk Medium level OPeration Stones).
Each includes seven cpu intensive benchmarks. They work equally well with
16-bit and 32-bit implementations and are designed to be portable to all
Smalltalk versions from ParcPlace and Digitalk. They are normalized to the
author's 486/33 Windows 3.1 machine running ParcPlace VisualWorks 1.0.
Results have been posted to the Usenet group comp.lang.smalltalk and form the
basis of an article that is scheduled to be published in the June issue of The
Smalltalk Report.

The only difference between the ST80 (STones80) and ST/V (STonesV) filein is
in the messages that define the classes in the first few lines of code. The
ST80 messages specify the class category and message protocol, which are not
used in ST/V.

Bruce Samuelson

!

!SMarkSlopstone methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:55'!
benchSlopstone
	"Using the SlopStone benchmarks, but not doing the
	 old style Stone performance number reporting"

	| n |
	n := self problemSize.
	n > SmallInteger maxVal
		ifTrue: [ self error: 'Count exceeded max small int.' ].
	
	o := obj new.
	
	1 to: n do: [:i | self doIntAdd         ].
	1 to: n do: [:i | self doFloatAdd       ].
	1 to: n do: [:i | self doStringAccess   ].
	1 to: n do: [:i | self doObjectCreation ].
	1 to: n do: [:i | self doObjectCopy     ].
	1 to: n do: [:i | self doPerform        ].
	1 to: n do: [:i | self doBlockValue     ].
! !

!SMarkSlopstone methodsFor: 'defaults' stamp: ''!
defaultProblemSize
	^ 1! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 9/9/2012 01:52'!
doBlockValue
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value.
	[] value. [] value. [] value. [] value. [] value. [] value. [] value! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 9/9/2012 01:48'!
doFloatAdd
	1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+
	1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0+1.0! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 9/9/2012 01:47'!
doIntAdd
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+
	1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1+1! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 17:16'!
doObjectCopy
	o copy copy copy copy copy copy copy copy copy copy! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 17:11'!
doObjectCreation
	obj new. obj new. obj new. obj new. obj new.
	obj new. obj new. obj new. obj new. obj new.
	obj new. obj new. obj new. obj new. obj new.
	obj new. obj new. obj new. obj new. obj new! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 17:17'!
doPerform
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself.
	o perform: #yourself. o perform: #yourself. o perform: #yourself! !

!SMarkSlopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 9/9/2012 01:50'!
doStringAccess
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1.
	'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1. 'a' at: 1! !

!SMarkSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

!SMarkSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 9/9/2012 02:16'!
readme
   "STEFAN: use the original benchmarks, but do not use original way
            of reporting results. Rely on the SMark reporting instead."

	"INTRODUCTION 
	 
	Slopstone: Smalltalk Low level OPeration Stones 
	Portable Low Level Benchmarks for ST80 and ST/V (using 16-bit 
	SmallIntegers) Placed in public domain January 1993  (c) Bruce 
	Samuelson Permission is given to place this in public Smalltalk archives 
	 
	Use monospaced fonts if possible to view the methods in this class. 
	 
	(1) Collect garbage if supported (2) do 'SlopstoneBenchmark new 
	runBenchmark'. Results are printed in the Transcript window. 
	Post results for your machines to comp.lang.smalltalk or 
	mail them to bruce@ling.uta.edu or bruce@utafll.uta.edu. 
	 
	DISCUSSION 
	    
	This readme method would normally be in the class comment for ST80. 
	ST/V-DOS doesn't support class comments. 
	  
	The benchmarks test strictly low level operations. They do not test 
	higher level operations such as forming sets, sorting, or streaming, nor 
	do they test 
	applications. They also do not test user interface operations because of 
	the non-portability of this area of Smalltalk and its sensitivity to the 
	performance of the video subsystem. The tests are cpu bound. They do 
	not access files and should not cause disk paging. 
	 
	The benchmarks use loop counts of 16000 because SmallIntegers cannot 
	exceed 16383 for ST/V-DOS. 16-bit implementions would perform worse 
	with large loop 
	counts. The benchmarks are also suitable for testing 32-bit versions of 
	Smalltalk. 
	 
	DEFINITION OF REFERENCE MACHINE (ONE SLOPSTONE) 
	 
	The following machine is the one on which I developed these 
	benchmarks. By 
	convention it is defined to operate at one slopstone. It's a mid range 
	performer for current ParcPlace versions of Smalltalk. 
	 
	Hardware: Amax 486DX/33 (includes internal floating point processor 
	and internal 8K cache), 256K external cache, 16MB RAM. 
	 
	Software: ParcPlace VisualWorks 1.0, Windows 3.1, DOS 5.0 (plain vanilla 
	setup). 
	 
	COMPARISON TO XEROX DORADO 
	 
	For reference, the machine runs at 649% of a Dorado on ParcPlace 
	benchmarks for ST80 4.1. Its fast video card helps on these PPS 
	benchmarks. I didn't run 
	them for VisualWorks 1.0. It would be somewhat slower because there 
	are vastly 
	more classes. 
	 
	EXAMPLE RESULTS FOR REFERENCE MACHINE 
	 
	1000s    time    1000s of 
	itera-   sec-    iterations   slop- 
	tions    onds    per sec      stones   explanation 
	 
	3808     0.577   6600         1.0      add integers 
	 544     2.262    240         1.0      add floats 
	 960     1.088    882         1.0      access strings 
	 320     0.908    352         1.0      create objects 
	 160     1.49     107         1.0      copy objects 
	 480     1.129    425         1.0      perform selectors 
	 896     1.237    724         1.0      evaluate blocks 
	 
	 640     1.151    555         1.0      geometric mean"
	^ self! !

!SMarkSlopstone methodsFor: 'initialize-release' stamp: 'StefanMarr 5/16/2013 12:26'!
setUp
	obj := Object.! !

Benchmark subclass: #SMarkSmopstone
	instanceVariableNames: 'ordCollectionFact intervalFact rectFactory sortedColFact arrFact setFact pointFact'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkSmopstone commentStamp: 'nishis 2/21/98 06:26' prior: 0!
modified for Squeak by nishis@urban.ne.jp
see the comment of SlopstoneBenchmark class.
I added all class methods and initialization>initilize method,
modified:
	streamTestsOn: method.  In some case use testPrintOn: s base: instead of printOn:,
	primesUpTo: method. From recursively calling a block to whileTrue: block.
	sorcerersApprentice method. From recursively calling a block to  recursive method.
	execute and setup method.
Thanx to Mr. Tim Olson, Mr. Kohler Markus, Mr. Tim Rowledge, Mr. John Maloney, Mr. Ian Piumarta.

originak code by
	NAME			STones80
	AUTHOR			bruce@utafll.uta.edu (Bruce Samuelson)
	FUNCTION		low and medium level benchmarks for ST80 and ST/V
	ST-VERSIONS		pre R4.0, R4.0, R4.1, ST/V
	PREREQUISITES	need floating point hardware or emulation
	CONFLICTS		none
	DISTRIBUTION	world
	VERSION			1.0
	DATE			April 16, 1993

!

!SMarkSmopstone methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:56'!
benchSmopstone
	| n primes strings set |
	
	n := self problemSize.
	
	self fractonacci: n / 13. "13/2"
	
	primes := self primesUpTo: n * 100. "7351 - 1" "9000"
	self streamTestsOn: primes.
	
	strings := self stringsUpTo: n * 100. "8000"
	set := self setFrom: strings.
	self sort: set.
	
	self sorcerersApprentice: n.! !

!SMarkSmopstone methodsFor: 'defaults' stamp: 'StefanMarr 5/16/2013 11:44'!
defaultProblemSize
	^ 80! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'nishis 2/14/98 02:47'!
fractonacci: n 
	"Return something like the fibonacci function of n but
	using fractional numbers rather than whole ones. The
	reason for this variation is to run long enough to get
	a decent time measurement without exceeding 16383, the
	limit of small integers for ST/V-DOS. Choosing n = 13/2
	takes enough time and computes to 13581.

	Fibonacci uses n-1 and n-2 instead of n-(1/2) and n-(1/3).
	However, I couldn't get it to run in the above constraints.

	This benchmark tests the efficiency of recursively calling
	a method that does a little fractional arithmetic internally."

	^n > 1
		ifTrue: [(self fractonacci: n - (1/2)) + (self fractonacci: n - (1/3))]
		ifFalse: [1]! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 18:10'!
primesUpTo: n
	"modified by nishis"

	"Return the prime numbers between 2 and n.

	This method tests the efficiency of recursively calling a block
	that does some collection enumeration based on integer arithmetic."

	| nSqrt lowPrimes highPrimes genNext first |
	n < 5 | (n > 16363) ifTrue: [self error: 'Prime limit(s) out of range.'].
	nSqrt := n sqrt rounded.
	lowPrimes := ordCollectionFact with: 2.
	highPrimes := intervalFact from: 5 to: n by: 2.
	
	genNext := [:nextPrime |
		lowPrimes add: nextPrime.
		highPrimes := highPrimes select: [:k | k \\ nextPrime ~= 0].
		(first := highPrimes first) <= nSqrt ifTrue: [genNext value: first]].
	
	genNext value: 3.

	^ lowPrimes , highPrimes! !

!SMarkSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

!SMarkSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 9/9/2012 02:50'!
readme
   "STEFAN: use the original benchmarks, but do not use original way
            of reporting results. Rely on the SMark reporting instead."

	"INTRODUCTION 
	 
	Smopstone: Smalltalk Medium level OPeration Stones 
	Portable Medium level Benchmarks for ST80 and ST/V (using 16-bit 
	SmallInts) Placed in public domain January 1993  (c) Bruce Samuelson 
	Permission is given to place this in public Smalltalk archives 
	 
	Use monospaced fonts if possible to view the methods in this class. 
	 
	(1) Collect garbage if supported (2) do 'SmopstoneBenchmark new 
	runBenchmark'. Results are printed in the Transcript window. 
	Post results for your machines to comp.lang.smalltalk or 
	mail them to bruce@ling.uta.edu or bruce@utafll.uta.edu. 
	 
	DISCUSSION 
	    
	This readme method would normally be in the class comment for ST80. 
	ST/V-DOS doesn't support class comments. 
	 
	These benchmarks are a companion to the SlopstoneBenchmark class 
	posted to 
	comp.lang.smalltalk this month. Slopstones tested low level operations. 
	  
	Smopstones test medium level operations that exercise recursive block 
	and  
	method calls, collection building and enumeration, streaming, and 
	sorting. The 
	lower level operations contained in them exercise arithmetic (mostly 
	integer, with some fractions and floats) string manipulation, and low 
	level streaming. 
	 
	The benchmarks do not test applications. They also do not test user 
	interface performance because of the non-portability of this area of 
	Smalltalk and its  
	sensitivity to the speed of the video subsystem. The tests are cpu bound. 
	They do not access files and should not cause disk paging. 
	 
	The main weaknesses of the benchmarks are (1) they are not high 
	enough level 
	to test actual applications, and (2) they concentrate in too few areas of 
	Smalltalk, omitting many of the diverse capabilities of its class library. 
	My excuse is that one can only devote limited time writing public 
	domain benchmarks. 
	 
	The tests avoid generating integers larger than 16383, the maximum 
	SmallInteger in ST/V-DOS. 16-bit implementions would perform worse 
	with larger 
	integers. The benchmarks are also suitable for testing 32-bit versions of 
	Smalltalk. They try to avoid other pitfalls that would skew the results 
	such as the lack of an adequate hash function for a class. Someone 
	warned of this 
	in comp.lang.smalltalk (I forget who). 
	 
	DEFINITION OF REFERENCE MACHINE (ONE SMOPSTONE) 
	 
	The following machine is the one on which I developed these 
	benchmarks. By 
	convention it is defined to operate at one smopstone. It's a mid range 
	performer for current ParcPlace versions of Smalltalk. 
	 
	Hardware: Amax 486DX/33 (includes internal floating point processor 
	and internal 8K cache), 256K external cache, 16MB RAM. 
	 
	Software: ParcPlace VisualWorks 1.0, Windows 3.1, DOS 5.0 (plain vanilla 
	setup). 
	 
	COMPARISON TO XEROX DORADO 
	 
	For reference, the machine runs at 649% of a Dorado on ParcPlace 
	benchmarks for ST80 4.1. Its fast video card helps on these PPS 
	benchmarks. I didn't run 
	them for VisualWorks 1.0. It would be somewhat slower because there 
	are vastly 
	more classes. 
	 
	EXAMPLE RESULTS FOR REFERENCE MACHINE 
	 
	time in    smop- 
	seconds    stones    explanation 
	 
	 
	3.157      1.0       generating fractonaccis 
	1.123      1.0       generating primes 
	1.091      1.0       generating and parsing streams 
	3.091      1.0       generating strings 
	1.167      1.0       forming sets 
	5.139      1.0       sorting strings 
	5.601      1.0       sorcerer's apprentice 
	 
	2.355      1.0       geometric mean"
	^ self! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 19:05'!
setFrom: collection
	"Form a set from collection and return it.

	This method tests the efficiency of building a fairly large set
	from strings. It indirectly tests the effectiveness of the string
	hash function. Strings are used often enough as dictionary keys
	that this may be worth including in the benchmark suite.  ST/V-DOS
	has a primitive hash for strings, and ST80 has an elaborate one
	written in Smalltalk."

	^ setFact withAll: collection! !

!SMarkSmopstone methodsFor: 'running' stamp: 'StefanMarr 5/7/2013 19:27'!
setUp
	ordCollectionFact := OrderedCollection.
	intervalFact      := Interval.
	rectFactory       := Rectangle.
	sortedColFact     := SortedCollection.
	arrFact           := Array.
	setFact           := Set.
	pointFact         := Point.! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/16/2013 11:43'!
sorcerersApprentice: m
	"modified by nishis"

	" FORMATTED FOR MONOSPACED FONT

	Perform various operations on rectangles.

	This method tests the efficiency of recursively calling a block that
	includes lots of integer arithmetic, collection building, and collection
	enumeration. The method:

	(1) Creates a collection of pseudo random rectangles 
	(2) Forms a new collection of all their intersections 
	(3) Recursively continues until there are no more intersections 
	(4) Returns a collection with the counts of rectangles in each generation.

	Because the intersections are forming progressively smaller rectangles
	(we exclude intersections of a rectangle with itself), the algorithm will
	eventually converge. Depending on the choice of numeric parameters, it may
	converge very quickly or very slowly. The parameters used below make it
	converge in a reasonable amount of time (a few seconds on a one-smopstone
	machine). It took some experimentation with different combinations to
	achieve this.

	The pseudo random number generator isn't very good, but it's adequate
	for this benchmark. I had intended the number '87' it uses to be a prime,
	but 87 = 29 * 3. The numbers may have been a bit more random otherwise.

	One could write an algorithm that would converge much more quickly and in
	a more predictable amount of time by sorting the intermediate rectangles
	in two dimensions and not bothering to test for intersections those
	rectangles that are contained in mutually exclusive regions. We have
	chosen algorithmic simplicity over performance optimization. We simply
	perform intersections of each rectangle with every possible partner in
	each generation. The time consumed is quadratic in the number of rectangles.

	The algorithm originally stored rectangles in sets to eliminate duplicates.
	Unfortunately, ST/V-DOS uses the hash function inherited from Object for
	Rectangle, which will allow duplicates to be stored. So we were forced to
	store rectangles in ordered collections and eliminate duplicates by brute
	force. The brutality was heightened because we could not use the test
	collection>>includes: to decide whether to add a rectangle to the ordered
	collections, since ST/V-DOS does not define equality (=) for rectangles
	either. The remaining warts in the code are not worth explaining.

	In an actual application, these shortcomings of ST/V-DOS would have been
	overcome by adding subclasses and methods rather than writing kludgy code."

	| n firstGen intersection isIncluded counts r random
	a b c d e f g h generate nextGen |
	
	n := 20 * m.
	firstGen := ordCollectionFact new.
	counts   := ordCollectionFact new.
	r := 50.
	random := [r := r + 1 * 87 \\ n].
	m timesRepeat: [
		a := random value.
		b := random value.
		c := random value.
		d := random value.
		e := a min: b.
		f := c min: d.
		g := a max: b.
		h := c max: d.
		firstGen add: (rectFactory origin: (pointFact x: e y: f) corner: (pointFact x: g y: h))].
	generate := 
		[:lastGen |
		counts add: lastGen size.
		nextGen := ordCollectionFact new.
		lastGen do:
			[:r1 |
			lastGen do: 
				[:r2 | 
				(r1 origin ~= r2 origin or: [r1 corner ~= r2 corner])
				"In ST80 this test would have simply been r1 ~= r2"
					ifTrue:
						[(r1 intersects: r2)
							ifTrue:
								[intersection := r1 intersect: r2.
								isIncluded := false.                     "All these lines"
								nextGen do:                              "would have been"
									[:rec |                                "avoided if we"
										(rec origin = intersection origin and: "could have used"
										[rec corner = intersection corner])    "a set for"
											ifTrue: [isIncluded := true]].       "nextGen. See"
								isIncluded                               "explanation"
									ifFalse:                               "above."
										[nextGen size > 500
											ifTrue: [self error: 'Converges too slowly.']
											ifFalse: [nextGen add: intersection]]]]]].
			nextGen size > 0 ifTrue: [generate value: nextGen]].
	
	generate value: firstGen.
	^counts! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 18:18'!
sort: collection
	"Form a sorted collection from collection and return it.

	This method tests the efficiency of sorting a fairly large
	collection of strings. It indirectly measures the efficiency
	of the sorting algorithm and of string comparison operations."

	^collection as: sortedColFact! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 18:19'!
streamTestsOn: integers 
	"modified by nishis"
	"Test steaming operations on the collection of integers. 
	 
	This method measures the efficiency of integer-to-float conversion, of 
	printing numbers to a write stream, of parsing tokens in a read 
	stream,   and of converting the tokens from strings to numbers. The 
	technique for 
	converting tokens into floats is constrained by portability between 
	ST80 and ST/V. 
	 
	To validate the logic, the original integers are compared with the 
	final   floats. There should be no roundoff errors."
	"The following line accounts for the different implementations of 
	Float>>printString for some versions of Smalltalk. USA versions use 
	the decimal character, while some European versions use the comma 
	char.   Thanks to Marten Feldtmann for pointing this out."

	| delim space s floats float string |
	delim := 1.0 printString at: 2.	"$. for USA, $, for some Europe."

	space := Character value: 32.
	"Can't use Character space in ST/V-DOS"
	s := ReadWriteStream on: String new.
	integers do: 
		[:i |
			i asFloat printOn: s.
			s space].
	"Now make sure the underlying string size is < 16383, a 16-bit small int."
	s contents size > (SmallInteger maxVal) ifTrue: [self error: 'String too big.'].
	s reset.
	floats := ordCollectionFact new: integers size.
	[s atEnd]
		whileFalse: 
			[float := 0.0.
			string := s upTo: delim.
			s upTo: space.
			"In the following, digitValue is portable between ST80 and ST/V-DOS. "
			string do: [:char | float := float * 10.0 + char digitValue].
			floats add: float].
	integers = floats ifFalse: [self error: 'Numbers do not compare.']! !

!SMarkSmopstone methodsFor: 'stone benchmarks' stamp: 'StefanMarr 5/7/2013 20:18'!
stringsUpTo: n 
	"Return a collection of strings representing the integers from 1 
	to n with their digits reversed. 
	 
	This method tests the efficiency of creating small streams, performing 
	string operations, and building collections. It includes a gross kludge 
	to coerce portability between ST80 and ST/V. They vary slightly in the 
	selector used to reverse collections. Subsequent to freezing this code, 
	someone pointed out that it could have been written more simply 
	without   using perform:. It could also have been simplified using 
	select:. It 
	was too late to change. The techniques are left as an exercise for the 
	reader."

	| selector |
	(arrFact with: #reverse with: #reversed)
		do: [:symbol | (String canUnderstand: symbol)
			ifTrue: [selector := symbol]].
	^ (intervalFact from: 1 to: n)
		collect: [:m | m printString perform: selector]! !

Benchmark subclass: #SMarkSplayTreeBenchmark
	instanceVariableNames: 'splayTree kSplayTreeSize kSplayTreeModifications kSplayTreePayloadDepth keyCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 16:48'!
benchSplayTree
	"replace a few nodes in the splay tree."
	
	| key greatest |
	
	1 to: kSplayTreeModifications do: [:i|
		key := self insertNewNode.
		greatest := self splayTree findGreatestLessThan: key.
		greatest ifNil: [
			self splayTree remove: key.
		] ifNotNil: [
			self splayTree remove: greatest key.
		].
	].! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:39'!
generateKey
	^ (keyCounter := keyCounter + 1)! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:39'!
generatePayloadTreeWithDepth: depth andTag: tag
	(depth = 0) ifTrue: [
		^ Dictionary new
			at: #array put: {0. 1. 2. 3. 4. 5. 6. 7. 8. 9};
			at: #string put: 'String for key ', tag, ' in leaf node';
			yourself.
	] ifFalse: [
		^ Dictionary new
			at: #left put: (self generatePayloadTreeWithDepth: depth - 1 andTag: tag);
			at: #right put: (self generatePayloadTreeWithDepth: depth - 1 andTag: tag);
			yourself.
	]! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'BS 2/7/2014 16:23'!
insertNewNode
	"insert new node with a unique key"
	
	| key payload | 
	
	key := self generateKey.
	Transcript show: 'entering insertNewNode key: '.
	Transcript show: key.
	Transcript showln: ''.
	
	[ (self splayTree find: key) isNil ] whileFalse:
	[
		key := self generateKey.
	].

	payload := self generatePayloadTreeWithDepth: self splayTreePayloadDepth andTag: key.
	self splayTree insert: key value: payload.
	^ key.! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:25'!
setUp	
	splayTree := nil.
	kSplayTreeSize := 100. "8000"
	kSplayTreeModifications := 80. "80."
	kSplayTreePayloadDepth := 5.
	keyCounter := 0.
	
	Transcript showln: 'entering SplayTree setup'.
	
	self splayTree: (SMarkSplaytree new).
	
	1 to: self splayTreeSize do: [:i |
		self insertNewNode.
	]! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:40'!
splayTree
	^ splayTree! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:40'!
splayTree: aSplayTree
	splayTree := aSplayTree.! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:40'!
splayTreePayloadDepth
	^ kSplayTreePayloadDepth! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'HW 1/25/2014 17:40'!
splayTreeSize
	^ kSplayTreeSize! !

!SMarkSplayTreeBenchmark methodsFor: 'as yet unclassified' stamp: 'test 6/2/2015 10:40'!
tearDown
	"allow gc to reclaim the memory
	 used by the splay tree no matter how we exit the tear down function"
	
	| keys length |
	true ifTrue: [^ self "ignore for now..."].
	keys := self splayTree exportKeys.
	self splayTree: nil.
	
	"Verify that the splay tree has the right size."
	length := keys size.
	Transcript show: length.
	Transcript show: '';cr.
	Transcript show: (self splayTreeSize).
	( length ~= self splayTreeSize ) ifTrue: [
		Error signal: 'Splay tree has wrong size.'.
		Transcript show: 'Splay tree has wrongsize.'; cr .
	].

	"Verify that the splay tree has sorted, unique keys."
	1 to: (length-1) do: [:i|
		( (keys at: i) >= (keys at: ( i + 1) )) ifTrue: [
			Error signal: 'Splay tree not sorted'.
		].
	].
	! !

Benchmark subclass: #SMarkSqueakJS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-SqueakJS'!

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:59'!
benchBitBltExampleOne

	self bltExampleOneTimes: self problemSize extent: 32@32.
	self bltExampleOneTimes: self problemSize extent: 64@64.
	self bltExampleOneTimes: self problemSize extent: 256@256.! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:59'!
benchFib

	self problemSize benchFib.! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:59'!
benchFillArray
	| b o |
	b := Array new: self problemSize.
	o := Object new.
	self problemSize timesRepeat: [b atAllPut: o].! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:59'!
benchFillByteArray
	| b |
	b := ByteArray new: self problemSize.
	self problemSize timesRepeat: [b atAllPut: 11].! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 08:59'!
benchFillString
	| b |
	b := String new: self problemSize.
	self problemSize timesRepeat: [b atAllPut: $a].! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 19:34'!
benchIntegerBytecodes

	15 benchmark.! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'test 4/21/2016 09:00'!
benchMandala
	
	| f npoints d l pen points |
	npoints := self problemSize.
	f := Form extent: 1000@1000 depth: 32.
	pen := Pen newOnForm: f.
	d := f height - 50.
	l := 3.14 * d / npoints.
	pen home; up; turn: -90; go: d // 2; turn: 90; go: 0 - l / 2; down.
	points := Array new: npoints.
	1 to: npoints do: 
		[:i | 
		points at: i put: pen location rounded.
		pen go: l; turn: 360.0 / npoints].
	npoints // 2
		to: 1
		by: -1
		do: 
			[:i | 
			pen color: i.
			1 to: npoints do: 
				[:j | 
				pen place: (points at: j).
				pen goto: (points at: j + i - 1 \\ npoints + 1)]]
! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 09:41'!
bltExampleOneTimes: n extent: aPoint

	| s d aBitBlt |
	s := Form extent: aPoint.
	s fillWhite.
	'Starting and Quitting
Like most Smalltalk''s, the machine-executable portion is a relatively small program known as the "virtual machine" (VM).  The VM''s job is to provide services from the physical machine to real Smalltalk objects.  Services like input and output.  The Smalltalk system, including all data and code, is a system of objects, built from the ground up, and interpreted by this virtual computer.  This affords Smalltalk system platform portability.' asParagraph
		wrappingBox: (10@10 corner: 600@600)
		clippingBox: (0@0 extent: aPoint);
		displayOn: s at: 0@0.
	s fillBlack: (7@7 corner: 25@25).
	s fillBlack: (39@39 corner: 47@47).
	d := Form extent: aPoint.
	aBitBlt := BitBlt
				destForm: d
				sourceForm: s
				fillColor: nil
				combinationRule: 1
				destOrigin: 0@0
				sourceOrigin: 0@0
				extent: s extent
				clipRect: (0@0 corner: aPoint).
	1 to: n do: [:i |
		aBitBlt combinationRule: i \\ 16.
		d fillWhite.
		d fillBlack: (0@0 corner: 64@16).
		aBitBlt copyBits].
	! !

!SMarkSqueakJS methodsFor: 'benchmarking' stamp: 'tfel 4/26/2016 19:34'!
problemSize
	"These need to be larger"
	^ 15! !

Exception subclass: #ShootoutFastaReduxEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

ReadStream subclass: #ShootoutRepeatStream
	instanceVariableNames: 'repeatPtr repeatLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

ShootoutRepeatStream subclass: #ShootoutRandomStream
	instanceVariableNames: 'random percentages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutRandomStream methodsFor: 'accessing' stamp: ''!
next
	| r |
	r := random next.
	repeatPtr := repeatPtr + 1.
	1 to: percentages size do: [:i|
		(r < (percentages at: i)) ifTrue: [^collection at: i]]! !

!ShootoutRandomStream methodsFor: 'initialize-release' stamp: ''!
on: aCollection
	| size cp |
	repeatPtr := 0.
	random := ShootoutRandomNumber to: 1.0d0.
	size := aCollection size.
	percentages := Array new: size.
	collection := Array new: size.
	cp := 0.0d0.
	1 to: size do: [:i|
		collection at: i put: (aCollection at: i) first.
		percentages at: i put: (cp := cp + (aCollection at: i) last).
	]! !

!ShootoutRandomStream methodsFor: 'accessing' stamp: ''!
random: aRandomNumber
"* Share the random number generator so we can get the expected results. *"
	random := aRandomNumber! !

!ShootoutRepeatStream class methodsFor: 'instance creation' stamp: ''!
to: anInteger on: aCollection
	^(super on: aCollection) to: anInteger! !

!ShootoutRepeatStream methodsFor: 'testing' stamp: ''!
atEnd
	^repeatPtr >= repeatLimit! !

!ShootoutRepeatStream methodsFor: 'accessing' stamp: ''!
next
	position >= readLimit ifTrue: [ self position: 0 ].
	repeatPtr := repeatPtr + 1.
	^collection at: (position := position + 1)! !

!ShootoutRepeatStream methodsFor: 'initialize-release' stamp: ''!
to: anInteger
	repeatPtr := 0.
	repeatLimit := anInteger! !

ReadStream subclass: #ShootoutRepeatStreamRedux
	instanceVariableNames: 'repeatPtr repeatLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

ShootoutRepeatStreamRedux subclass: #ShootoutRandomStreamRedux
	instanceVariableNames: 'random percentages'
	classVariableNames: 'LookupSize'
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutRandomStreamRedux class methodsFor: 'class initialization' stamp: ''!
initialize
	LookupSize := 4 * 1024! !

!ShootoutRandomStreamRedux methodsFor: 'initialize-release' stamp: ''!
cumulatedPercentagesFor: aCollection scale: scale
   | size cp cumulatedPercentages |
   size := aCollection size.
   cumulatedPercentages := Array new: size.
   cp := 0.0d0.
   1 to: size do: [:i|
      cumulatedPercentages at: i put: (cp := cp + (aCollection at: i) last) * scale.
   ].
   cumulatedPercentages at: size put: scale.
  ^cumulatedPercentages! !

!ShootoutRandomStreamRedux methodsFor: 'accessing' stamp: 'ul 5/24/2015 19:20'!
next
   | r i |
   (repeatPtr := repeatPtr + 1) > repeatLimit ifTrue: [ShootoutFastaReduxEnd signal].
   r := random next.
   i := r truncated.
   [r > (percentages at: (i := i + 1))] whileTrue.
   ^collection at: i! !

!ShootoutRandomStreamRedux methodsFor: 'initialize-release' stamp: 'nice 5/6/2012 16:18'!
on: aCollection
   | size j cumulatedPercentages scale |
   repeatPtr := 0.
   size := LookupSize.
   scale := size - 1.
   random := ShootoutRandomNumberRedux to: scale.
   cumulatedPercentages := self cumulatedPercentagesFor: aCollection scale: scale.
   percentages := Array new: size.
   collection := Array new: size.
   j := 1.
   1 to: size do: [:i |
      [(cumulatedPercentages at: j) < (i - 1)] whileTrue: [j := j + 1].
      collection at: i put: (aCollection at: j) first.
      percentages at: i put: (cumulatedPercentages at: j).
   ].! !

!ShootoutRandomStreamRedux methodsFor: 'accessing' stamp: ''!
random
	^random! !

!ShootoutRandomStreamRedux methodsFor: 'accessing' stamp: ''!
random: aRandomNumber
   random := aRandomNumber! !

!ShootoutRepeatStreamRedux class methodsFor: 'instance creation' stamp: ''!
to: anInteger on: aCollection
   ^(super on: aCollection) to: anInteger! !

!ShootoutRepeatStreamRedux methodsFor: 'accessing' stamp: 'ul 5/24/2015 19:20'!
next
   (repeatPtr := repeatPtr + 1) > repeatLimit ifTrue: [ShootoutFastaReduxEnd signal].
   position >= readLimit ifTrue: [ self position: 0 ].
   ^collection at: (position := position + 1)! !

!ShootoutRepeatStreamRedux methodsFor: 'initialize-release' stamp: ''!
to: anInteger
   repeatPtr := 0.
   repeatLimit := anInteger! !

OrderedCollection subclass: #SMarkPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-DeltaBlue'!

!SMarkPlan commentStamp: '<historical>' prior: 0!
A Plan is an ordered list of constraints to be executed in sequence to resatisfy all currently satisfiable constraints in the face of one or more changing inputs.!

!SMarkPlan methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:49'!
execute
	"Execute my constraints in order."

	self do: [: c | c execute].! !

Class subclass: #SMarkCompilerTargetClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Classic'!

!SMarkCompilerTargetClass methodsFor: 'compiling' stamp: ''!
acceptsLoggingOfCompilation
	"Answer whether the receiver's method submisions and class defintions should be logged to the changes file and to the current change set."

	^ false! !

!SMarkCompilerTargetClass methodsFor: 'accessing method dictionary' stamp: 'StefanMarr 2/13/2013 00:43'!
addAndClassifySelector: selector withMethod: compiledMethod inProtocol: aCategory notifying: requestor
	| priorMethodOrNil oldProtocol newProtocol |
	priorMethodOrNil := self compiledMethodAt: selector ifAbsent: [nil].
	self addSelectorSilently: selector withMethod: compiledMethod.
	oldProtocol := self organization categoryOfElement: selector.

	self classify: selector under: aCategory.

	newProtocol := self organization categoryOfElement: selector.! !

!SMarkCompilerTargetClass methodsFor: 'compatibility Pharo 1.4 vs. 2.0' stamp: 'StefanMarr 2/13/2013 00:42'!
classify: selector under: aCategory
	"Use image specific approach Pharo 1.4 vs. Pharo 2.0"
	| classify |
	classify := [self organization classify: selector under: aCategory].

	"Pharo 1.4"
	(Smalltalk at: #SystemChangeNotifier ifPresent: [:cls |
		^ cls uniqueInstance doSilently: classify ]).
	
	"Pharo 2.0"
	^ SystemAnnouncer uniqueInstance suspendAllWhile: classify.! !

!SMarkCompilerTargetClass methodsFor: 'initialization' stamp: 'sm 1/17/2011 09:38'!
initialize
	super initialize.
	self methodDictionary: MethodDictionary new.! !

Morph subclass: #SMarkMandelbrotMorph
	instanceVariableNames: 'form mode threadCount depth imageBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-CPB'!

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 14:11'!
calculate
	1
		to: self form width
		do: [:x | 1
				to: self form height
				do: [:y | self
						calculateValAt: x@y]]! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'tfel 6/2/2015 10:35'!
calculateValAt: aPoint
	| val aComplex |
	aComplex := (Complex
		real: (aPoint x * (self imageBounds width / self form width) + self imageBounds left) asFloat
		imaginary: (aPoint y * (self imageBounds height / self form height) + self imageBounds top) asFloat).
 	(self mode = #iterative) ifTrue: [
		val := SMarkMandelbrotRenderBenchmark calculateAtIterative: aComplex maxIterations: self depth.
	] ifFalse: [
		val := SMarkMandelbrotRenderBenchmark calculateAtRecursive: aComplex maxIterations: self depth.
	].
	self form colorAt: aPoint put: (self colorForValue: val).! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 1/7/2014 12:18'!
calculateWithThreads: anInteger
| semaphores |
	semaphores := OrderedCollection new.
	1 to: anInteger do:[ :i |
			semaphores add: (self createThread: i of: anInteger).
		].
	semaphores do: [:s| s wait].! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 1/16/2014 15:01'!
colorForValue: val
	| r g b |
	(val = self depth) ifTrue:[^Color black].
	r := (((val+1) * 2) rem: 256)/256.
	g := (((val+1) * 3) rem: 256)/256.
	b := (((val+1) * 5) rem: 256)/256.
	^ Color r: r g: g b: b.! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 1/7/2014 12:33'!
createThread: threadNumber of: threadCount
| semaphore |
semaphore := Semaphore new.
[ | index maxIndex |
	maxIndex := self form width * self form height.
	index := threadNumber.
	[index < maxIndex] whileTrue: [
		self calculateValAt: (self pointForIndex: index).
		index := index + threadCount.
	].
	semaphore signal.
] fork.
^ semaphore.! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/11/2013 14:55'!
depth
	depth ifNil: [depth := 100].
	^depth! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/11/2013 14:54'!
depth: aNumber
	depth := aNumber! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 12/10/2013 14:08'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	aCanvas drawImage: self form at: self topLeft! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 12/10/2013 14:02'!
form
	form ifNil: [form := Form extent: self extent depth: 32].
	^form.! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/10/2013 16:04'!
form: anObject

	form := anObject! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 15:38'!
handlesMouseDown: anEvent
	^true.! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/11/2013 15:27'!
imageBounds
	imageBounds ifNil: [imageBounds := -2@ -1.5 corner: 1@1.5].
	^imageBounds! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/11/2013 15:27'!
imageBounds: aRectangle
	imageBounds := aRectangle! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/10/2013 16:04'!
mode
	mode ifNil: [mode := #iterative].
	^ mode! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 12/10/2013 16:04'!
mode: anObject

	mode := anObject! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 12/11/2013 15:43'!
mouseDown: anEvent
	| p |
	p := anEvent position - self topLeft.
	Transcript showln: (Complex 
		real: ((p x * (self imageBounds width / self form width)) + self imageBounds left) asFloat
		imaginary: ((p y * (self imageBounds height / self form height)) + self imageBounds top) asFloat)! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 1/7/2014 11:58'!
pointForIndex: anInteger
	| x y |
	y := (anInteger / self width) floor.
	x := anInteger - (self width * y).
	
	^ x@y.! !

!SMarkMandelbrotMorph methodsFor: 'as yet unclassified' stamp: 'BS 1/7/2014 12:06'!
reCalculate
	form := nil.
	(self threadCount <= 1) ifTrue: [
		self calculate.
	] ifFalse: [
		self calculateWithThreads: self threadCount.
	].
	self changed.! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 1/7/2014 12:03'!
threadCount
	threadCount ifNil: [threadCount := 1].
	^ threadCount! !

!SMarkMandelbrotMorph methodsFor: 'accessing' stamp: 'BS 1/7/2014 12:04'!
threadCount: anInteger
	threadCount := anInteger.! !

Morph subclass: #ShootoutMeteorBoardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorBoardMorph methodsFor: 'accessing' stamp: 'nice 4/15/2012 00:04'!
addPiece: aPiece index: pieceIndex forRow: row
	| rgb hColor |
	rgb := self rgbColorSpecs at: pieceIndex.
	hColor := Color r: rgb first g: rgb second b: rgb third.
	self fillMask: aPiece mask forRow: row withColor: hColor! !

!ShootoutMeteorBoardMorph methodsFor: 'drawing' stamp: 'nice 4/14/2012 21:33'!
drawOn: aCanvas! !

!ShootoutMeteorBoardMorph methodsFor: 'accessing' stamp: 'nice 4/15/2012 00:04'!
fillMask: aPieceMask forRow: row withColor: hColor
	| offset |
	offset := row * 5.
	aPieceMask bitsDo: [:k | (submorphs at: offset + k) fillColor: hColor].
	self changed.! !

!ShootoutMeteorBoardMorph methodsFor: 'initialize-release' stamp: 'nice 4/14/2012 16:14'!
initialize
	| cells center hexa x y |
	super initialize.
	cells := Array new: 50.
	x := #(0 2 4 6 8 1 3 5 7 9).
	y := (0 to: 9).
	0 to: 49 do: [:i|
		center := ((x at: 10 - (i \\ 10))*12+12) @ ((y at: 10 - (i // 5))*21+14).
		hexa := ShootoutMeteorHexaMorph new.
		hexa bounds: (center - (12@14) corner: center + (12@14)).
		cells at: i + 1 put: hexa].
	submorphs := cells.
	bounds := cells inject: cells first bounds into: [:b :h | b merge: h bounds]! !

!ShootoutMeteorBoardMorph methodsFor: 'accessing' stamp: 'nice 4/15/2012 00:04'!
removePiece: aPiece index: pieceIndex forRow: row
	self fillMask: aPiece mask forRow: row withColor: Color transparent! !

!ShootoutMeteorBoardMorph methodsFor: 'accessing' stamp: 'nice 4/13/2012 23:19'!
rgbColorSpecs
	^#(
		#(1.0  0.2  0.2)
		#(0.0  1.0  0.0)
		#(0.2  0.2  1.0)
		#(1.0  1.0  0.0)
		#(0.0  1.0  1.0)
		#(0.8  0.2  0.8)
		#(1.0  0.6  0.1)
		#(0.6  0.1  0.1)
		#(0.1  0.6  0.1)
		#(0.1  0.1  0.6)
		#(0.2  0.2  0.2)
	)! !

Morph subclass: #ShootoutMeteorHexaMorph
	instanceVariableNames: 'fillColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMark-Benchmarks-Shootout'!

!ShootoutMeteorHexaMorph methodsFor: 'initialize-release' stamp: 'nice 4/14/2012 15:54'!
bounds: newBounds
	bounds := (-12 @ -14 extent: 25@29) translateBy: newBounds center rounded.! !

!ShootoutMeteorHexaMorph methodsFor: 'drawing' stamp: 'nice 4/13/2012 15:28'!
drawOn: aCanvas
	aCanvas 
		drawPolygon: (self vertices collect: [:e | e + self bounds center])
		fillStyle: self fillColor
		borderWidth: 1
		borderColor: Color black! !

!ShootoutMeteorHexaMorph methodsFor: 'accessing' stamp: 'nice 4/13/2012 15:29'!
fillColor
	^fillColor! !

!ShootoutMeteorHexaMorph methodsFor: 'accessing' stamp: 'nice 4/13/2012 16:06'!
fillColor: aColor
	fillColor := aColor.
	self changed! !

!ShootoutMeteorHexaMorph methodsFor: 'initialize-release' stamp: 'nice 4/14/2012 16:13'!
initialize
	super initialize.
	bounds := 0@0 extent: 25@29.
	fillColor := Color transparent! !

!ShootoutMeteorHexaMorph methodsFor: 'accessing' stamp: 'nice 4/14/2012 10:38'!
vertices
	^{ 12 @ 7. 0 @ 14. -12 @ 7. -12 @ -7. 0 @ -14. 12 @ -7 }! !
SMarkJSJsonLiteral initialize!
SMarkNBBody initialize!
SMarkRichObject initialize!
SMarkStrength initialize!
ShootoutChameneosColour initialize!
ShootoutMall initialize!
ShootoutRandomNumber initialize!
ShootoutRandomNumberRedux initialize!
SMarkShootout initialize!
ShootoutRandomStreamRedux initialize!
